// Sample_MFCView.h : CSample_MFCView NX̃C^[tFCX
//


#pragma once

#include "CArtCamSdk.hpp"

const TCHAR CMOS_DLLNAMELIST[][32] = {
	_T("ArtCamSdk_036MI.dll"),
	_T("ArtCamSdk_130MI.dll"),
	_T("ArtCamSdk_130MIV.dll"),
	_T("ArtCamSdk_200MI.dll"),
	_T("ArtCamSdk_300MI.dll"),
	_T("ArtCamSdk_500MI.dll"),
	_T("ArtCamSdk_900MI.dll"),
	_T("ArtCamSdk_1000MI.dll"),
	_T("ArtCamSdk_V135MI.dll"),
	_T("ArtCamSdk_MV413.dll"),
	_T("ArtCamSdk_D131.dll"),
	_T("ArtCamSdk_Ov210.dll"),
};

const TCHAR CCD_DLLNAMELIST[][32] = {
	_T("ArtCamSdk_200SH.dll"),
	_T("ArtCamSdk_098.dll"),
	_T("ArtCamSdk_098II.dll"),
	_T("ArtCamSdk_150P.dll"),
	_T("ArtCamSdk_150P2.dll"),
	_T("ArtCamSdk_150P3.dll"),
	_T("ArtCamSdk_150P3V.dll"),
	_T("ArtCamSdk_320P.dll"),
	_T("ArtCamSdk_500P.dll"),
	_T("ArtCamSdk_267KY.dll"),
	_T("ArtCamSdk_274KY.dll"),
	_T("ArtCamSdk_445KY.dll"),
	_T("ArtCamSdk_625KY.dll"),
	_T("ArtCamSdk_500P2.dll"),
};

const TCHAR OTHER_DLLNAMELIST[][32] = {
	_T("ArtCamSdk_SATA.dll"),
	_T("ArtCnvSdk.dll"),
	_T("ArtCamSdk_USTC.dll"),
	_T("ArtCamSdk.dll"),
};

const TCHAR ERRORLIST[][128] = {
	"",
	"Ă܂",
	"ps\ȃfoCXɃANZX悤Ƃ܂",
	"摜荞ݗpXbh쐬Ɏs",
	"EBhE쐬Ɏs",
	"C[W]ɏ\ȃmۂĂȂ@́@̊mۂɎs",
	"JifoCXj̐ݒŃG[",
	"JifoCXj̃TCYݒŃG[",
	"f荞݂Ŏs",
	"ԈĂ܂",
	"DirectShow G[",
	"̋@\̓T|[gĂ܂",
	"s̃G[",
	"foCX܂",
	"wt@C܂",
	"FPGA̐ݒŃG[",
	"摜]G[",
};

const int CMOS_DLLCOUNT		= sizeof(CMOS_DLLNAMELIST)	/ ( 32 * sizeof(TCHAR));
const int CCD_DLLCOUNT		= sizeof(CCD_DLLNAMELIST)	/ ( 32 * sizeof(TCHAR));
const int OTHER_DLLCOUNT	= sizeof(OTHER_DLLNAMELIST) / ( 32 * sizeof(TCHAR));
const int ERRORCOUNT		= sizeof(ERRORLIST)			/ (128 * sizeof(TCHAR));





class CSample_MFCView : public CView
{
	CArtCamSdk	m_CArtCamSdk;
	LPBYTE		m_pImage;			// 摜f[^i[̈
	BOOL		m_PreviewMode;		// vr[\^R[obN\
	LONG		m_DllType;			// ڑDLL
	LONG		m_CameraType;		// ڑJ
	LONG		m_CurrentCameraType;// ݂̃J^Cv
	LONG		m_DeviceCount;		// oꂽfoCX̐
	LONG		m_SelectDevice;		// IĂfoCXԍ

	BOOL		m_SaveFlg;			// ۑ\
	BOOL		m_StopFlg;			// ~
	CString		m_RecName;			// ^悵t@C

	BOOL		m_CmosMenuEnable [CMOS_DLLCOUNT];
	BOOL		m_CcdMenuEnable  [CCD_DLLCOUNT];
	BOOL		m_OtherMenuEnable[OTHER_DLLCOUNT];
	LONG		m_BitMode;			// 16rbg][h


	LRESULT		DrawImage		(HDC hDC);
	BOOL		OnDllChange		(LONG DllType, LONG CameraType);
	BOOL		OnDeviceChange	(LONG Number);
	void		ChangeScrollbar	(void);
	void		CheckColorMode	(void);


public:
	void InitMenuPopup(CMenu* pPopupMenu);



protected: // VÂݍ쐬܂B
	CSample_MFCView();
	DECLARE_DYNCREATE(CSample_MFCView)

// 
public:
	CSample_MFCDoc* GetDocument() const;

// 
public:

// I[o[Ch
	public:
	virtual void OnDraw(CDC* pDC);  // ̃r[`悷邽߂ɃI[o[Ch܂B
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// 
public:
	virtual ~CSample_MFCView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif


// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg LRESULT OnGraphPaint(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnError(WPARAM wParam, LPARAM lParam);
	afx_msg void OnFileSaveimage();
	afx_msg void OnFileRec();
	afx_msg void OnExit();
	afx_msg void OnShowPreview();
	afx_msg void OnShowCallback();
	afx_msg void OnShowSnapshot();
	afx_msg void OnShowCapture();
	afx_msg void OnShowTrigger();
	afx_msg void OnShowStop();
	afx_msg void OnSetFormat();
	afx_msg void OnSetFilter();
	afx_msg void OnSetAnalog();
	afx_msg void OnSetFilterApp();
	afx_msg void OnDllCam();
	afx_msg void OnDllUstc();
	afx_msg void OnDllCnv();
	afx_msg void OnDll130mi();
	afx_msg void OnDll200mi();
	afx_msg void OnDll300mi();
	afx_msg void OnDll150p();
	afx_msg void OnDll320p();
	afx_msg void OnDllMv03();
	afx_msg void OnDll200sh();
	afx_msg void OnDll098();
	afx_msg void OnDll036mi();
	afx_msg void OnDll500p();
	afx_msg void OnDll500p2();
	afx_msg void OnDll150p2();
	afx_msg void OnDll500mi();
	afx_msg void OnDll150p3();
	afx_msg void OnDll130miv();
	afx_msg void OnDll150p3v();
	afx_msg void OnDll267ky();
	afx_msg void OnDll274ky();
	afx_msg void OnDll625ky();
	afx_msg void OnDllV135mi();
	afx_msg void OnDll445ky();
	afx_msg void OnDll098ii();
	afx_msg void OnDllMv413();
	afx_msg void OnDllOv210();
	afx_msg void OnDllD131();
	afx_msg void OnDll900mi();
	afx_msg void OnDll1000mi();
	afx_msg void OnDllSataLvds();
	afx_msg void OnDllSata300mi();
	afx_msg void OnDllSata500mi();
	afx_msg void OnDllSataMv413();
	afx_msg void OnDllSata800mi();
	afx_msg void OnDllSata036mi();
	afx_msg void OnDllSata150p3();
	afx_msg void OnDllSata274ky();
	afx_msg void OnDllSata625ky();
	afx_msg void OnDevice01();
	afx_msg void OnDevice02();
	afx_msg void OnDevice03();
	afx_msg void OnDevice04();
	afx_msg void OnDevice05();
	afx_msg void OnDevice06();
	afx_msg void OnDevice07();
	afx_msg void OnDevice08();
	afx_msg void OnSetSizeApp();
	afx_msg void OnSetIoApp();
	afx_msg void OnSetMonitorApp();
};

#ifndef _DEBUG  // Sample_MFCView.cpp ̃fobO o[W
inline CSample_MFCDoc* CSample_MFCView::GetDocument() const
   { return reinterpret_cast<CSample_MFCDoc*>(m_pDocument); }
#endif

