//==========================================================
//	ARTRAY Camera / Capture Module Software Developer Kit
//
//						Version 1.20		2003.9.4
//						Version 1.21		2003.9.18
//						Version 1.22		2003.10.10
//						Version 1.23		2004.1.21
//						Version 1.235		2004.3.19
//						Version 1.24		2004.7.9
//						Version 1.245		2004.8.17
//						Version 1.25		2004.9.1
//						Version 1.26		2004.10.28
//						Version 1.27		2005.3.8
//						Version 1.275		2005.5.23
//						Version 1.276		2005.9.5
//						Version 1.277		2005.12.22
//
//									(C) 2002-2005 Artray
//==========================================================


#ifndef _ARTCAM_SDK_
#define _ARTCAM_SDK_

#include <windows.h>



#define WM_GRAPHNOTIFY  WM_APP + 1		// {o[Wł͎gp܂
#define WM_GRAPHPAINT	WM_APP + 2		// fXVꂽɃAvP[Vɑ܂
#define WM_ERROR		WM_APP + 3		// G[ɃAvP[Vɑ܂


#define  HACAM  DWORD

enum {
	ARTCAM_CAMERATYPE_DS		= 1,	// DirectShow Camera
	ARTCAM_CAMERATYPE_DISABLE1	= 2,	// 
	ARTCAM_CAMERATYPE_USTC		= 3,	// ARTUST
	ARTCAM_CAMERATYPE_CNV		= 4,	// ARTCNV
	ARTCAM_CAMERATYPE_DISABLE2	= 5,	// 
	ARTCAM_CAMERATYPE_130MI		= 6,	// ARTCAM-130MI
	ARTCAM_CAMERATYPE_DISABLE3	= 7,	// 
	ARTCAM_CAMERATYPE_200MI		= 8,	// ARTCAM-200MI
	ARTCAM_CAMERATYPE_300MI		= 9,	// ARTCAM-300MI
	ARTCAM_CAMERATYPE_150P		= 10,	// ARTCAM-150P
	ARTCAM_CAMERATYPE_320P		= 11,	// ARTCAM-320P
	ARTCAM_CAMERATYPE_DISABLE4	= 12,	// 
	ARTCAM_CAMERATYPE_200SH		= 13,	// ARTCAM-200SH
	ARTCAM_CAMERATYPE_098		= 14,	// ARTCAM-098
	ARTCAM_CAMERATYPE_036MI		= 15,	// ARTCAM-036MI
	ARTCAM_CAMERATYPE_500P		= 16,	// ARTCAM-500P
	ARTCAM_CAMERATYPE_150P2		= 17,	// ARTCAM-150PU
};

// G[R[h
enum {
	ARTCAMSDK_NOERROR = 0,			// 
	ARTCAMSDK_NOT_INITIALIZE,		// Ă܂
	ARTCAMSDK_DISABLEDDEVICE,		// ps\ȃfoCXɃANZX悤Ƃ܂
	ARTCAMSDK_CREATETHREAD,			// 摜荞ݗpXbh쐬Ɏs
	ARTCAMSDK_CREATEWINDOW,			// EBhE쐬Ɏs
	ARTCAMSDK_OUTOFMEMORY,			// C[W]ɏ\ȃmۂĂȂ@́@̊mۂɎs
	ARTCAMSDK_CAMERASET,			// JifoCXj̐ݒŃG[
	ARTCAMSDK_CAMERASIZE,			// JifoCXj̃TCYݒŃG[
	ARTCAMSDK_CAPTURE,				// f荞݂Ŏs
	ARTCAMSDK_PARAM,				// ԈĂ܂
	ARTCAMSDK_DIRECTSHOW,			// DirectShow G[
	ARTCAMSDK_UNSUPPORTED,			// ̋@\̓T|[gĂ܂
	ARTCAMSDK_UNKNOWN,				// s̃G[
	ARTCAMSDK_CAPTURELOST,			// foCX
};

// ]

typedef struct GP_INFO {
	LONG	lSize;
	LONG	lWidth;
	LONG	lHeight;
	LONG	lBpp;
	LONG	lFps;
} *LPGP_INFO;


// 摜tB^[̎
enum {
	ARTCAM_FILTERTYPE_RESERVE = 0,			// \񂳂Ă܂
	ARTCAM_FILTERTYPE_BRIGHTNESS,			// 邳
	ARTCAM_FILTERTYPE_CONTRAST,				// RgXg
	ARTCAM_FILTERTYPE_HUE,					// F
	ARTCAM_FILTERTYPE_SATURATION,			// ʓx
	ARTCAM_FILTERTYPE_SHARPNESS,			// N
	ARTCAM_FILTERTYPE_BAYER_GAIN_RGB,		// xC[ϊ̃J[QC
	ARTCAM_FILTERTYPE_BAYER_GAIN_R,			// xC[ϊ̃J[QCiԂ̂݁j
	ARTCAM_FILTERTYPE_BAYER_GAIN_G,			// xC[ϊ̃J[QCi΂̂݁j
	ARTCAM_FILTERTYPE_BAYER_GAIN_B,			// xC[ϊ̃J[QCi̂݁j
	ARTCAM_FILTERTYPE_BAYER_GAIN_AUTO,		// zCgoX
	ARTCAM_FILTERTYPE_GAMMA,				// K}
	ARTCAM_FILTERTYPE_BAYERMODE,			// xC[ϊ[h
	ARTCAM_FILTERTYPE_GLOBAL_GAIN,			// J̃O[oQC
	ARTCAM_FILTERTYPE_COLOR_GAIN_R,			// J̃J[QCiԁj
	ARTCAM_FILTERTYPE_COLOR_GAIN_G1,		// J̃J[QCi΂Pj
	ARTCAM_FILTERTYPE_COLOR_GAIN_G2,		// J̃J[QCi΂Qj
	ARTCAM_FILTERTYPE_COLOR_GAIN_B,			// J̃J[QCij
	ARTCAM_FILTERTYPE_EXPOSURETIME,			// IԁiVb^[Xs[hj
};

// ߋ̃o[WƂ̌݊
#define ARTCAM_FILTERTYPE_RGB_GAIN		ARTCAM_FILTERTYPE_BAYER_GAIN_RGB
#define ARTCAM_FILTERTYPE_R_GAIN		ARTCAM_FILTERTYPE_BAYER_GAIN_R
#define ARTCAM_FILTERTYPE_G_GAIN		ARTCAM_FILTERTYPE_BAYER_GAIN_G
#define ARTCAM_FILTERTYPE_B_GAIN		ARTCAM_FILTERTYPE_BAYER_GAIN_B
#define ARTCAM_FILTERTYPE_AUTO_GAIN		ARTCAM_FILTERTYPE_BAYER_GAIN_AUTO


// Ԉ][h
enum {
	SUBSAMPLE_1 = 0,	// tTCY
	SUBSAMPLE_2,		// P^Q
	SUBSAMPLE_4,		// P^S
	SUBSAMPLE_8,		// P^W
};


// I[gACX[h
enum {
	AI_NONE = 0,		// 
	AI_EXPOSURE,		// Io
	AI_GAIN,			// QC
};


// rfItH[}bg
enum {
	VIDEOFORMAT_NTSC = 0,	// NTSC
	VIDEOFORMAT_PAL,		// PAL
	VIDEOFORMAT_PALM,		// PALM
	VIDEOFORMAT_SECAM,		// SECAM
};

// TvO[g
enum {
	WIDE_HISPEED = 0,	// 
	WIDE_LOWSPEED,		// 
	NORMAL_HISPEED,		// 
	NORMAL_LOWSPEED,	// 
};


// 摜ۑ`
enum {
	FILETYPE_BITMAP = 0,	// rbg}bvŕۑ܂BTCY
	FILETYPE_RAW,			// f[^݂̂ۑ܂BTCY
	FILETYPE_JPEG_HIGH,		// iJPEGŕۑ܂B⃉C͕܂BTCY
	FILETYPE_JPEG_NOMAL,	// WiJPEGŕۑ܂Bׂp^[͕܂BTCY
	FILETYPE_JPEG_LOW,		// iJPEGŕۑ܂BubNmCYڗ܂BTCY
	FILETYPE_PNG,			// PNGŕۑ܂B16rbg摜mɕۑł܂BTCY
	FILETYPE_TIFF,			// TIFFŕۑ܂B16rbg摜mɕۑł܂BTCY
};


/*
@Ӂ
@16rbg摜͑SĂ̊A摜\tgEFAœǂݍ߂̂ł͂܂B
@{SDKŕۑł16rbgPNG,TIFFɊւĂ
@А̃r[A\tgEFA version 2.0ȍ~AAdobe Photoshop 6Őɓǂݍ߂邱ƂmFĂ܂B
@Ή̃\tgœǂݍނƁA摜ĕ\ꂽAsIt@C̃bN̏Ǐ󂪏o邱Ƃ܂B
@ӂ
@
@16rbgrbg}bvŕۑꍇ16rbg̃O[XP[摜ƂĕۑĂ̂
@J[pbg͕ۑĂ܂B\tg16rbg̃pbgpӂ邩A
@O[XP[̃foCXReLXgpӂKv܂
@16rbgŕۑۂTIFFAPNGŕۑ鎖߂܂B
@
@JPEGł̓J[摜ȊO͕ۑł܂B
@Wrbg16rbg摜̓mÑJ[摜Ƃĕۑ܂B
@16rbg摜ɊւĂ͉ʂWrbg̃f[^؂̂Ăĕۑ܂B
*/





#ifdef __cplusplus
extern "C"{
#endif

	ARTCAMSDK_API DWORD		ArtCam_GetDllVersion		(void);
	ARTCAMSDK_API LONG		ArtCam_GetLastError			(HACAM hACam);

	ARTCAMSDK_API HACAM		ArtCam_Initialize			(HWND hWnd);
	ARTCAMSDK_API BOOL		ArtCam_Release				(HACAM hACam);

	ARTCAMSDK_API BOOL		ArtCam_Preview				(HACAM hACam);
	ARTCAMSDK_API BOOL		ArtCam_Record				(HACAM hACam, LPCTSTR lpAviName, UINT RecTime, BOOL fShow);
	ARTCAMSDK_API BOOL		ArtCam_CallBackPreview		(HACAM hACam, HWND hWnd, LPBYTE lpImage, LONG Size, BOOL TopDown);
	ARTCAMSDK_API BOOL		ArtCam_Close				(HACAM hACam);

	// 1230
	ARTCAMSDK_API BOOL		ArtCam_SnapShot				(HACAM hACam, LPBYTE lpImage, LONG Size, BOOL TopDown);

	// 1250
	ARTCAMSDK_API BOOL		ArtCam_Capture				(HACAM hACam);

	// 1260
	ARTCAMSDK_API BOOL		ArtCam_Trigger				(HACAM hACam, HWND hWnd, LPBYTE lpImage, LONG Size, BOOL TopDown);
	ARTCAMSDK_API BOOL		ArtCam_SaveImage			(HACAM hACam, LPCTSTR lpSaveName, LONG FileType);


	ARTCAMSDK_API BOOL		ArtCam_SetPreviewWindow		(HACAM hACam, HWND hWnd, LONG Left, LONG Top, LONG Right, LONG Bottom);
	ARTCAMSDK_API BOOL		ArtCam_SetCaptureWindow		(HACAM hACam, LONG Width, LONG Height, LONG Fps);
	ARTCAMSDK_API BOOL		ArtCam_SetCaptureWindowEx	(HACAM hACam, LONG HTotal, LONG HStart, LONG HEffective, LONG VTotal, LONG VStart, LONG VEffective);
	ARTCAMSDK_API BOOL		ArtCam_GetCaptureWindowEx	(HACAM hACam, LONG* HTotal, LONG* HStart, LONG* HEffective, LONG* VTotal, LONG* VStart, LONG* VEffective);

	ARTCAMSDK_API BOOL		ArtCam_SetColorMode			(HACAM hACam, LONG ColorMode);
	ARTCAMSDK_API LONG		ArtCam_GetColorMode			(HACAM hACam);

	ARTCAMSDK_API BOOL		ArtCam_SetCrossbar			(HACAM hACam, LONG Output, LONG Input);
	ARTCAMSDK_API BOOL		ArtCam_SetDeviceNumber		(HACAM hACam, LONG Number);
	ARTCAMSDK_API LONG		ArtCam_EnumDevice			(HACAM hACam, TCHAR szDeviceName[10][256]);
	ARTCAMSDK_API BOOL		ArtCam_GetDeviceName		(HACAM hACam, LONG index, LPSTR szDeviceName, LONG nSize);

	ARTCAMSDK_API BOOL		ArtCam_StartPreview			(HACAM hACam);
	ARTCAMSDK_API BOOL		ArtCam_StopPreview			(HACAM hACam);
	ARTCAMSDK_API BOOL		ArtCam_GetImage				(HACAM hACam, LPBYTE lpImage, LONG Size, BOOL TopDown);

	ARTCAMSDK_API LONG		ArtCam_Width				(HACAM hACam);
	ARTCAMSDK_API LONG		ArtCam_Height				(HACAM hACam);
	ARTCAMSDK_API LONG		ArtCam_Fps					(HACAM hACam);

	ARTCAMSDK_API BOOL		ArtCam_SetCameraDlg			(HACAM hACam, HWND hWnd);
	ARTCAMSDK_API BOOL		ArtCam_SetImageDlg			(HACAM hACam, HWND hWnd);
	ARTCAMSDK_API BOOL		ArtCam_SetAnalogDlg			(HACAM hACam, HWND hWnd);

	// 1230
	ARTCAMSDK_API BOOL		ArtCam_SetIOPort			(HACAM hACam, BYTE byteData, LONG longData, DWORD Reserve);
	ARTCAMSDK_API BOOL		ArtCam_GetIOPort			(HACAM hACam, LPBYTE byteData, LPLONG longData, DWORD Reserve);

	ARTCAMSDK_API BOOL		ArtCam_SetFilterValue		(HACAM hACam, LONG FilterType, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetFilterValue		(HACAM hACam, LONG FilterType, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetSubSample			(HACAM hACam, LONG SubSampleMode);
	ARTCAMSDK_API LONG		ArtCam_GetSubSample			(HACAM hACam);

	ARTCAMSDK_API BOOL		ArtCam_SetWaitTime			(HACAM hACam, LONG WaitTime);
	ARTCAMSDK_API LONG		ArtCam_GetWaitTime			(HACAM hACam);

	// 1240
	ARTCAMSDK_API BOOL		ArtCam_SetMirrorV			(HACAM hACam, BOOL Flg);
	ARTCAMSDK_API BOOL		ArtCam_GetMirrorV			(HACAM hACam);

	ARTCAMSDK_API BOOL		ArtCam_SetMirrorH			(HACAM hACam, BOOL Flg);
	ARTCAMSDK_API BOOL		ArtCam_GetMirrorH			(HACAM hACam);

	ARTCAMSDK_API BOOL		ArtCam_SetBrightness		(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetBrightness		(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetContrast			(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetContrast			(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetHue				(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetHue				(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetSaturation		(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetSaturation		(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetSharpness			(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetSharpness			(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetBayerGainRGB		(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetBayerGainRGB		(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetBayerGainRed		(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetBayerGainRed		(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetBayerGainGreen	(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetBayerGainGreen	(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetBayerGainBlue		(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetBayerGainBlue		(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetBayerGainAuto		(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetBayerGainAuto		(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetGamma				(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetGamma				(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetBayerMode			(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetBayerMode			(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetGlobalGain		(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetGlobalGain		(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetColorGainRed		(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetColorGainRed		(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetColorGainGreen1	(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetColorGainGreen1	(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetColorGainGreen2	(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetColorGainGreen2	(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetColorGainBlue		(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetColorGainBlue		(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetExposureTime		(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetExposureTime		(HACAM hACam, LPBOOL Error);

	// 1260
	ARTCAMSDK_API BOOL		ArtCam_SetHalfClock			(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetHalfClock			(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API BOOL		ArtCam_SetAutoIris			(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetAutoIris			(HACAM hACam, LPBOOL Error);

	// 1275
	ARTCAMSDK_API BOOL		ArtCam_SetSamplingRate		(HACAM hACam, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_GetSamplingRate		(HACAM hACam, LPBOOL Error);

	ARTCAMSDK_API LONG		ArtCam_GetVideoFormat		(HACAM hACam, LPBOOL Error);

	// 1276
	ARTCAMSDK_API BOOL		ArtCam_WriteSromID			(HACAM hACam, LONG Address, LONG Value);
	ARTCAMSDK_API LONG		ArtCam_ReadSromID			(HACAM hACam, LONG Address, LPBOOL Error);


#ifdef __cplusplus
}			// extern "C"{
#endif

#endif		// #ifndef _ARTCAM_SDK_




