using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;
using System.Text;
using System.IO;
using ArtCamSdk;


namespace Sample_CS
{
	/// <summary>
	/// This is an explanation for outline of "Form1".
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MainMenu mainMenu1;

		private byte[] m_pCapture;
		private Bitmap m_Bitmap = null;
		private int m_PreviewMode = -1;
		private int m_SelectDevice = -1;
		private CArtCam m_CArtCam = new CArtCam();
		private string m_RecName;
		private bool m_SaveFlg = false;
		private bool m_StopFlg = false;

		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuSave;
		private System.Windows.Forms.MenuItem menuExit;
		private System.Windows.Forms.MenuItem menuView;
		private System.Windows.Forms.MenuItem menuPreview;
		private System.Windows.Forms.MenuItem menuCallback;
		private System.Windows.Forms.MenuItem menuSnapshot;
		private System.Windows.Forms.MenuItem menuCapture;
		private System.Windows.Forms.MenuItem menuTrigger;
		private System.Windows.Forms.MenuItem menuSet;
		private System.Windows.Forms.MenuItem menuCamera;
		private System.Windows.Forms.MenuItem menuFilter;
		private System.Windows.Forms.MenuItem menuAnalog;
		private System.Windows.Forms.MenuItem menuDevice;
		private System.Windows.Forms.MenuItem menuDevice0;
		private System.Windows.Forms.MenuItem menuDevice1;
		private System.Windows.Forms.MenuItem menuDevice2;
		private System.Windows.Forms.MenuItem menuDevice3;
		private System.Windows.Forms.MenuItem menuDevice4;
		private System.Windows.Forms.MenuItem menuDevice5;
		private System.Windows.Forms.MenuItem menuDevice6;
		private System.Windows.Forms.MenuItem menuDevice7;
		private System.Windows.Forms.MenuItem menuDevice8;
		private System.Windows.Forms.MenuItem menuDevice9;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuRec;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.Timer timerRec;
		private System.Windows.Forms.MenuItem menuStop;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.Timer timer1;


		[DllImport("user32.dll")]
		public static extern IntPtr GetWindow (IntPtr hWnd, int uCmd);

		[DllImport("user32.dll")]
		public static extern int SetWindowPos (IntPtr hWnd, int hWndInsertAfter, int X, int Y, int cx, int cy, int uFlags);


		public Form1()
		{
			//
			// This is needed for Windows form designer support.
			//
			InitializeComponent();

			//
			// TODO: Add constructor code after calling InitializeComponent.
			//
		}

		/// <summary>
		/// Execute after-treatment to resource used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// This method is required for designer support.
		/// Do not change the content of this method by code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.menuSave = new System.Windows.Forms.MenuItem();
			this.menuRec = new System.Windows.Forms.MenuItem();
			this.menuExit = new System.Windows.Forms.MenuItem();
			this.menuView = new System.Windows.Forms.MenuItem();
			this.menuPreview = new System.Windows.Forms.MenuItem();
			this.menuCallback = new System.Windows.Forms.MenuItem();
			this.menuSnapshot = new System.Windows.Forms.MenuItem();
			this.menuCapture = new System.Windows.Forms.MenuItem();
			this.menuTrigger = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuStop = new System.Windows.Forms.MenuItem();
			this.menuSet = new System.Windows.Forms.MenuItem();
			this.menuCamera = new System.Windows.Forms.MenuItem();
			this.menuFilter = new System.Windows.Forms.MenuItem();
			this.menuAnalog = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuDevice = new System.Windows.Forms.MenuItem();
			this.menuDevice0 = new System.Windows.Forms.MenuItem();
			this.menuDevice1 = new System.Windows.Forms.MenuItem();
			this.menuDevice2 = new System.Windows.Forms.MenuItem();
			this.menuDevice3 = new System.Windows.Forms.MenuItem();
			this.menuDevice4 = new System.Windows.Forms.MenuItem();
			this.menuDevice5 = new System.Windows.Forms.MenuItem();
			this.menuDevice6 = new System.Windows.Forms.MenuItem();
			this.menuDevice7 = new System.Windows.Forms.MenuItem();
			this.menuDevice8 = new System.Windows.Forms.MenuItem();
			this.menuDevice9 = new System.Windows.Forms.MenuItem();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.timerRec = new System.Windows.Forms.Timer(this.components);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuFile,
																					  this.menuView,
																					  this.menuSet,
																					  this.menuDevice});
			// 
			// menuFile
			// 
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuSave,
																					 this.menuRec,
																					 this.menuExit});
			this.menuFile.Text = "File(&F)";
			this.menuFile.Popup += new System.EventHandler(this.menuFile_Popup);
			// 
			// menuSave
			// 
			this.menuSave.Index = 0;
			this.menuSave.Text = "Save(&S)";
			this.menuSave.Click += new System.EventHandler(this.menuSave_Click);
			// 
			// menuRec
			// 
			this.menuRec.Index = 1;
			this.menuRec.Text = "Recording(&R)";
			this.menuRec.Click += new System.EventHandler(this.menuRec_Click);
			// 
			// menuExit
			// 
			this.menuExit.Index = 2;
			this.menuExit.Text = "End(&X)";
			this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
			// 
			// menuView
			// 
			this.menuView.Index = 1;
			this.menuView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuPreview,
																					 this.menuCallback,
																					 this.menuSnapshot,
																					 this.menuCapture,
																					 this.menuTrigger,
																					 this.menuItem5,
																					 this.menuStop});
			this.menuView.Text = "Display(&V)";
			this.menuView.Popup += new System.EventHandler(this.menuView_Popup);
			// 
			// menuPreview
			// 
			this.menuPreview.Index = 0;
			this.menuPreview.Text = "Preview(&P)";
			this.menuPreview.Click += new System.EventHandler(this.menuPreview_Click);
			// 
			// menuCallback
			// 
			this.menuCallback.Index = 1;
			this.menuCallback.Text = "Callback(&B)";
			this.menuCallback.Click += new System.EventHandler(this.menuCallback_Click);
			// 
			// menuSnapshot
			// 
			this.menuSnapshot.Index = 2;
			this.menuSnapshot.Text = "Snapshot(&S)";
			this.menuSnapshot.Click += new System.EventHandler(this.menuSnapshot_Click);
			// 
			// menuCapture
			// 
			this.menuCapture.Index = 3;
			this.menuCapture.Text = "Capture(&C)";
			this.menuCapture.Click += new System.EventHandler(this.menuCapture_Click);
			// 
			// menuTrigger
			// 
			this.menuTrigger.Index = 4;
			this.menuTrigger.Text = "Trigger(&T)";
			this.menuTrigger.Click += new System.EventHandler(this.menuTrigger_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 5;
			this.menuItem5.Text = "-";
			// 
			// menuStop
			// 
			this.menuStop.Index = 6;
			this.menuStop.Text = "Pause";
			this.menuStop.Click += new System.EventHandler(this.menuStop_Click);
			// 
			// menuSet
			// 
			this.menuSet.Index = 2;
			this.menuSet.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.menuCamera,
																					this.menuFilter,
																					this.menuAnalog,
																					this.menuItem1,
																					this.menuItem2,
																					this.menuItem3});
			this.menuSet.Text = "Settings(&S)";
			this.menuSet.Popup += new System.EventHandler(this.menuSet_Popup);
			// 
			// menuCamera
			// 
			this.menuCamera.Index = 0;
			this.menuCamera.Text = "Camera settings(&C)";
			this.menuCamera.Click += new System.EventHandler(this.menuCamera_Click);
			// 
			// menuFilter
			// 
			this.menuFilter.Index = 1;
			this.menuFilter.Text = "Filter settings(&F)";
			this.menuFilter.Click += new System.EventHandler(this.menuFilter_Click);
			// 
			// menuAnalog
			// 
			this.menuAnalog.Index = 2;
			this.menuAnalog.Text = "Analog settings(&A)";
			this.menuAnalog.Click += new System.EventHandler(this.menuAnalog_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 3;
			this.menuItem1.Text = "-";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 4;
			this.menuItem2.Text = "User size settings";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 5;
			this.menuItem3.Text = "User filter settings";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuDevice
			// 
			this.menuDevice.Index = 3;
			this.menuDevice.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuDevice0,
																					   this.menuDevice1,
																					   this.menuDevice2,
																					   this.menuDevice3,
																					   this.menuDevice4,
																					   this.menuDevice5,
																					   this.menuDevice6,
																					   this.menuDevice7,
																					   this.menuDevice8,
																					   this.menuDevice9});
			this.menuDevice.Text = "Device(&D)";
			// 
			// menuDevice0
			// 
			this.menuDevice0.Index = 0;
			this.menuDevice0.Text = "0";
			this.menuDevice0.Click += new System.EventHandler(this.menuDevice0_Click);
			// 
			// menuDevice1
			// 
			this.menuDevice1.Index = 1;
			this.menuDevice1.Text = "1";
			this.menuDevice1.Click += new System.EventHandler(this.menuDevice1_Click);
			// 
			// menuDevice2
			// 
			this.menuDevice2.Index = 2;
			this.menuDevice2.Text = "2";
			this.menuDevice2.Click += new System.EventHandler(this.menuDevice2_Click);
			// 
			// menuDevice3
			// 
			this.menuDevice3.Index = 3;
			this.menuDevice3.Text = "3";
			this.menuDevice3.Click += new System.EventHandler(this.menuDevice3_Click);
			// 
			// menuDevice4
			// 
			this.menuDevice4.Index = 4;
			this.menuDevice4.Text = "4";
			this.menuDevice4.Click += new System.EventHandler(this.menuDevice4_Click);
			// 
			// menuDevice5
			// 
			this.menuDevice5.Index = 5;
			this.menuDevice5.Text = "5";
			this.menuDevice5.Click += new System.EventHandler(this.menuDevice5_Click);
			// 
			// menuDevice6
			// 
			this.menuDevice6.Index = 6;
			this.menuDevice6.Text = "6";
			this.menuDevice6.Click += new System.EventHandler(this.menuDevice6_Click);
			// 
			// menuDevice7
			// 
			this.menuDevice7.Index = 7;
			this.menuDevice7.Text = "7";
			this.menuDevice7.Click += new System.EventHandler(this.menuDevice7_Click);
			// 
			// menuDevice8
			// 
			this.menuDevice8.Index = 8;
			this.menuDevice8.Text = "8";
			this.menuDevice8.Click += new System.EventHandler(this.menuDevice8_Click);
			// 
			// menuDevice9
			// 
			this.menuDevice9.Index = 9;
			this.menuDevice9.Text = "9";
			this.menuDevice9.Click += new System.EventHandler(this.menuDevice9_Click);
			// 
			// timer1
			// 
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.FileName = "doc1";
			// 
			// timerRec
			// 
			this.timerRec.Tick += new System.EventHandler(this.timerRec_Tick);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(640, 481);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "C# Sample";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);

		}
		#endregion

		/// <summary>
		/// Main entry point for application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		protected override unsafe void WndProc(ref Message m)
		{
			// WM_GRAPHNOTIFY
			if(DLL_MESSAGE.WM_GRAPHNOTIFY == (DLL_MESSAGE)m.Msg)
			{
			}
			// WM_ERROR
			else if(DLL_MESSAGE.WM_ERROR == (DLL_MESSAGE)m.Msg ||
				(DLL_MESSAGE.WM_GRAPHPAINT == (DLL_MESSAGE)m.Msg && null == (GP_INFO*)m.WParam)
				)
			{
			}
			// WM_GRAPHPAINT
			else if(DLL_MESSAGE.WM_GRAPHPAINT == (DLL_MESSAGE)m.Msg)
			{
				GP_INFO* pInfo = (GP_INFO*)m.WParam;
				m_SaveFlg = true;
				Invalidate();
			}
			else
			{
				base.WndProc(ref m);
			}
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			// Drawing by double buffer(not to flicker)
			this.SetStyle(ControlStyles.DoubleBuffer | ControlStyles.UserPaint | ControlStyles.AllPaintingInWmPaint, true);

			Release();
			m_CArtCam.Initialize(this.Handle);

			// Check available device
			for(int i=0; i<10; i++)
			{
				StringBuilder Temp = new StringBuilder( 256 );
				if(0 != m_CArtCam.GetDeviceName(i, Temp, 256))
				{
					menuDevice.MenuItems[i].Text = Temp.ToString();
				}
				else
				{
					menuDevice.MenuItems[i].Enabled = false;
				}
			}

			DeviceChange(sender, e, 0);
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			Release();
		}

		private void Release()
		{
			m_CArtCam.Release();
			m_PreviewMode = -1;
			timer1.Enabled = false;
			timerRec.Enabled = false;
			m_SaveFlg = false;
			m_StopFlg = false;
		}


		// Save
		private void menuSave_Click(object sender, System.EventArgs e)
		{
			saveFileDialog1.Filter = "BITMAPFile(*.bmp)|*.bmp|JPEGFile(*.jpg)|*.jpg;*.jpeg|TIFFFile(*.tif)|*.tif;*.tiff|PNGFile(*.png)|*.png|RAWFile(*.raw)|*.raw||";

			if(DialogResult.OK == saveFileDialog1.ShowDialog())
			{
				// Set extension yourself
				FileInfo fileInfo = new FileInfo(saveFileDialog1.FileName);

				string str = fileInfo.FullName.Remove(fileInfo.FullName.Length - fileInfo.Extension.Length, fileInfo.Extension.Length);
				switch(saveFileDialog1.FilterIndex)
				{
					case 1:	str += ".bmp";	m_CArtCam.SaveImage(str, FILETYPE.FILETYPE_BITMAP);		break;
					case 2:	str += ".jpg";	m_CArtCam.SaveImage(str, FILETYPE.FILETYPE_JPEG_HIGH);	break;
					case 3:	str += ".tif";	m_CArtCam.SaveImage(str, FILETYPE.FILETYPE_TIFF);		break;
					case 4:	str += ".png";	m_CArtCam.SaveImage(str, FILETYPE.FILETYPE_PNG);		break;
					case 5:	str += ".raw";	m_CArtCam.SaveImage(str, FILETYPE.FILETYPE_RAW);		break;
				}
			}
		}

		// Recording
		private void menuRec_Click(object sender, System.EventArgs e)
		{
			saveFileDialog1.Filter = "AVIFile(*.avi)|*.avi||";
			saveFileDialog1.DefaultExt = "avi";

			if(DialogResult.OK == saveFileDialog1.ShowDialog())
			{
				m_RecName = saveFileDialog1.FileName;

				// Pause
				m_CArtCam.Close();

				// Display on different window while recording
				// When "hWnd" is NULL, window is created from SDK side and therefore the size is not important.
				m_CArtCam.SetPreviewWindow(IntPtr.Zero, 0, 0, 0, 0);

				// 5 seconds recording
				m_CArtCam.Record(m_RecName, 5000, 1);


				// Timing for record ending is not sent from SDK and therefore it needs to be stopped by software.
				// Just in case, run the timer for 1 sencond longer.
				timerRec.Interval = 6000;
				timerRec.Enabled = true;
			}
		}

		// Recording timer
		private void timerRec_Tick(object sender, System.EventArgs e)
		{
			timerRec.Enabled = false;
			m_CArtCam.Close();

			if(DialogResult.Yes == MessageBox.Show("Recording completePlay /n file?", "Complete", MessageBoxButtons.YesNo))
			{
				System.Diagnostics.Process.Start(m_RecName);
			}			
		}

		// End
		private void menuExit_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		// Preview Draw automatically
		private void menuPreview_Click(object sender, System.EventArgs e)
		{
			if(!m_CArtCam.IsInit())
			{
				MessageBox.Show("Select available device");
				return;
			}

			timer1.Enabled = false;

			// Release device
			m_CArtCam.Close();

			// Set window to be displayed
			// When setting NULL to hWnd,it is possible to create new window and show it.
			m_CArtCam.SetPreviewWindow(this.Handle, 0, 0, this.Width, this.Height);

			m_CArtCam.Preview();

			// Check menu
			menuPreview.Checked  = true;
			menuCallback.Checked = false;
			menuCapture.Checked  = false;
			menuTrigger.Checked  = false;

			m_PreviewMode = 0;
			m_SaveFlg = true;
			m_StopFlg = false;
			menuStop.Text = "Pause";

			Invalidate();
		}

		// Callback: Obtain image pointer of image and draw its own.
		private void menuCallback_Click(object sender, System.EventArgs e)
		{
			if(!m_CArtCam.IsInit())
			{
				MessageBox.Show("Select available device");
				return;
			}

			timer1.Enabled = false;

			// Release device
			m_CArtCam.Close();

			// If drawing by yourself, set all window size to 0.
			// An automatic display can be performed, if window size is set up even when using CallBackPreview
			m_CArtCam.SetPreviewWindow(Handle, 0, 0, 0, 0);

			// Creat area for capturing
			CreateBitmap();

			// Capture image
			m_CArtCam.CallBackPreview(Handle, m_pCapture, getSize(), 0);

			// Check menu
			menuPreview.Checked  = false;
			menuCallback.Checked = true;
			menuCapture.Checked  = false;
			menuTrigger.Checked  = false;

			m_PreviewMode = 1;
			m_StopFlg = false;
			menuStop.Text = "Pause";

			Invalidate();
		}

		// Snapshot
		private void menuSnapshot_Click(object sender, System.EventArgs e)
		{
			if(!m_CArtCam.IsInit())
			{
				MessageBox.Show("Select available device");
				return;
			}

			timer1.Enabled = false;

			// Release device
			m_CArtCam.Close();

			// Creat area for capturing
			CreateBitmap();

			// Capture image
			m_CArtCam.SnapShot(m_pCapture, getSize(), 1);

			// Check menu
			menuPreview.Checked  = false;
			menuCallback.Checked = false;
			menuCapture.Checked  = false;
			menuTrigger.Checked  = false;

			m_PreviewMode = -1;
			m_SaveFlg = true;
			m_StopFlg = false;
			menuStop.Text = "Pause";

			Invalidate();
		}

		// Capture
		private void menuCapture_Click(object sender, System.EventArgs e)
		{
			if(!m_CArtCam.IsInit())
			{
				MessageBox.Show("Select available device");
				return;
			}

			timer1.Enabled = false;

			// Release device
			m_CArtCam.Close();


			// Creat area for capturing
			CreateBitmap();

			// Display image
			m_CArtCam.Capture();

			// Check menu
			menuPreview.Checked  = false;
			menuCallback.Checked = false;
			menuCapture.Checked  = true;
			menuTrigger.Checked  = false;

			m_PreviewMode = 3;
			m_StopFlg = false;
			menuStop.Text = "Pause";

			Invalidate();

			timer1.Enabled = true;
			timer1.Interval = 200;
		}

		// Capture timer
		private void timer1_Tick(object sender, System.EventArgs e)
		{
			m_CArtCam.SnapShot(m_pCapture, getSize(), 1);
			m_SaveFlg = true;
			Invalidate();
		}

		// Trigger
		private void menuTrigger_Click(object sender, System.EventArgs e)
		{
			if(!m_CArtCam.IsInit())
			{
				MessageBox.Show("Select available device");
				return;
			}

			timer1.Enabled = false;

			// Release device
			m_CArtCam.Close();

			// If drawing by yourself, set all window size to 0.
			// An automatic display can be performed, if window size is set up even when using CallBackPreview
			m_CArtCam.SetPreviewWindow(this.Handle, 0, 0, 0, 0);

			// Creat area for capturing
			CreateBitmap();

			// Capture image
			m_CArtCam.Trigger(this.Handle, m_pCapture, getSize(), 1);

			// Check menu
			menuPreview.Checked  = false;
			menuCallback.Checked = false;
			menuCapture.Checked  = false;
			menuTrigger.Checked  = true;

			m_PreviewMode = 4;
			m_StopFlg = false;
			menuStop.Text = "Pause";

			Invalidate();
		}

		// Pause/Resume
		private void menuStop_Click(object sender, System.EventArgs e)
		{
			// Stop only for animated picture
			if(0 == m_PreviewMode || 1 == m_PreviewMode)
			{
				if(m_StopFlg)
				{
					m_CArtCam.StartPreview();
					m_StopFlg = false;

					menuStop.Text = "Pause";
				}
				else 
				{
					m_CArtCam.StopPreview();
					m_StopFlg = true;

					menuStop.Text = "Resume";
				}
			}
		}

		// Create bit-map
		private void CreateBitmap()
		{
			// In case bitmap is already created, release.
			if(null != m_Bitmap)
			{
				m_Bitmap.Dispose();
			}

			switch(m_CArtCam.GetColorMode())
			{
				case 8:
				case 16:
					m_Bitmap = new Bitmap(getWidth(), getHeight(), PixelFormat.Format8bppIndexed);

					// Pallet modification
					ColorPalette pal = m_Bitmap.Palette;
					Color[] cpe = m_Bitmap.Palette.Entries;

					for(int i=0; i<256; i++)
					{
						cpe.SetValue(Color.FromArgb(i, i, i), i);
						pal.Entries[i] = cpe[i];
					}
					m_Bitmap.Palette = pal;
				break;

				case 24:	m_Bitmap = new Bitmap(getWidth(), getHeight(), PixelFormat.Format24bppRgb);			break;
				case 32:	m_Bitmap = new Bitmap(getWidth(), getHeight(), PixelFormat.Format32bppRgb);			break;
				case 48:	m_Bitmap = new Bitmap(getWidth(), getHeight(), PixelFormat.Format48bppRgb);			break;
				case 64:	m_Bitmap = new Bitmap(getWidth(), getHeight(), PixelFormat.Format64bppArgb);		break;
			}

			// Arrangement for capture
			m_pCapture = new Byte[getSize()];
		}


		// Camera settings
		private void menuCamera_Click(object sender, System.EventArgs e)
		{
			if(!m_CArtCam.IsInit())
			{
				MessageBox.Show("Select available device");
				return;
			}

			if(0 != m_CArtCam.SetCameraDlg(this.Handle))
			{
				switch(m_PreviewMode)
				{
					case 0: menuPreview_Click(sender, e); break;
					case 1: menuCallback_Click(sender, e); break;
					case 3: menuCapture_Click(sender, e); break;
					case 4: menuTrigger_Click(sender, e); break;
				}
			}
		}

		// Filter settings
		private void menuFilter_Click(object sender, System.EventArgs e)
		{
			if(!m_CArtCam.IsInit())
			{
				MessageBox.Show("Select available device");
				return;
			}

			m_CArtCam.SetImageDlg(this.Handle);
		}

		// Analog settings
		private void menuAnalog_Click(object sender, System.EventArgs e)
		{
			if(!m_CArtCam.IsInit())
			{
				MessageBox.Show("Select available device");
				return;
			}

			m_CArtCam.SetAnalogDlg(this.Handle);
		}

		// Change device
		private void DeviceChange(object sender, System.EventArgs e, int Number)
		{
			if(m_CArtCam.IsInit())
			{
				m_CArtCam.Close();
			}


			// To confirm whether the device is connected, use "GetDeviceName"
			// It can be found out easily with "GetDeviceName".
			// When area for obtain name is not secured, it results in error. Prepare alignment length of at least 32.Note that if there is not enough area for obtaining name, it results in error. Secure alignment length of at least 32.
			StringBuilder Temp = new StringBuilder( 256 );
			if(0 == m_CArtCam.GetDeviceName(Number, Temp, 256))
			{
				m_PreviewMode = -1;
				m_SelectDevice = -1;
				m_StopFlg = false;
				menuStop.Text = "Pause";
				return;
			}


			// A device will be changed, if a camera is displayed after changing the number of a device now
			// Notes: A device is not changed in this function simple substance
			//   After calling this function, a device is changed by initializing a device
			m_SelectDevice = Number;
			m_CArtCam.SetDeviceNumber(Number);


			for(int i=0; i<10; i++)
			{
				menuDevice.MenuItems[i].Checked = false;
			}
			menuDevice.MenuItems[Number].Checked = true;


			switch(m_PreviewMode)
			{
				case 0:	menuPreview_Click(sender, e); break;
				case 1:	menuCallback_Click(sender, e); break;
				case 3:	menuCapture_Click(sender, e); break;
				case 4:	menuTrigger_Click(sender, e); break;
			}
		}

		private void menuDevice0_Click(object sender, System.EventArgs e){ DeviceChange(sender, e, 0); }
		private void menuDevice1_Click(object sender, System.EventArgs e){ DeviceChange(sender, e, 1); }
		private void menuDevice2_Click(object sender, System.EventArgs e){ DeviceChange(sender, e, 2); }
		private void menuDevice3_Click(object sender, System.EventArgs e){ DeviceChange(sender, e, 3); }
		private void menuDevice4_Click(object sender, System.EventArgs e){ DeviceChange(sender, e, 4); }
		private void menuDevice5_Click(object sender, System.EventArgs e){ DeviceChange(sender, e, 5); }
		private void menuDevice6_Click(object sender, System.EventArgs e){ DeviceChange(sender, e, 6); }
		private void menuDevice7_Click(object sender, System.EventArgs e){ DeviceChange(sender, e, 7); }
		private void menuDevice8_Click(object sender, System.EventArgs e){ DeviceChange(sender, e, 8); }
		private void menuDevice9_Click(object sender, System.EventArgs e){ DeviceChange(sender, e, 9); }

		private int getSize()
		{
			return ((getWidth() * (m_CArtCam.GetColorMode()/8) + 3) & ~3) * getHeight();
		}

		private int getWidth()
		{
			int[] Size = { 1, 2, 4, 8 };
			return m_CArtCam.Width() / Size[(int)m_CArtCam.GetSubSample()];
		}

		private int getHeight()
		{
			int[] Size = { 1, 2, 4, 8 };
			return m_CArtCam.Height() / Size[(int)m_CArtCam.GetSubSample()];
		}

		private BitmapData LockBitmap()
		{
			switch(m_CArtCam.GetColorMode())
			{
				case 8:
				case 16:
					return m_Bitmap.LockBits(new Rectangle(0,0,getWidth(),getHeight()), ImageLockMode.ReadWrite, PixelFormat.Format8bppIndexed);

				case 24:
				case 32:
				case 48:
				case 64:
					return m_Bitmap.LockBits(new Rectangle(0,0,getWidth(),getHeight()), ImageLockMode.ReadWrite, PixelFormat.Format24bppRgb);
			}

			return null;
		}

		private void DrawImage(Graphics g)
		{
			if(null == m_Bitmap)
			{
				return ;
			}


			BitmapData pBitmapData = LockBitmap();
			if(null == pBitmapData)
			{
				return ;
			}


			unsafe
			{
				byte* pdest = (byte*)pBitmapData.Scan0.ToPointer();

				// In case of 16 bit transfer,convert to 8 bit and display
				if(m_CArtCam.GetColorMode() == 16)
				{
					int size = getWidth() * getHeight();
					for(int i=0; i<size; i++)
					{
						pdest[i] = (byte)((m_pCapture[i*2+1] << 6) | (m_pCapture[i*2] >> 2));
					}
				}
				else if(m_CArtCam.GetColorMode() == 32)
				{
					int size = getWidth() * getHeight();
					for(int i=0; i<size; i++)
					{
						pdest[i*3]   = m_pCapture[i*4];
						pdest[i*3+1] = m_pCapture[i*4+1];
						pdest[i*3+2] = m_pCapture[i*4+2];
					}
				}
				// This is a heavy load. When using 16 (10) bit color, use C language.
				else if(m_CArtCam.GetColorMode() == 48 || m_CArtCam.GetColorMode() == 64)
				{
					int bpp = m_CArtCam.GetColorMode()/8;
					int size = getWidth() * getHeight();
					for(int i=0; i<size; i++)
					{
						pdest[i*3]   = (byte)((m_pCapture[i*bpp+1] << 6) | (m_pCapture[i*bpp]   >> 2));
						pdest[i*3+1] = (byte)((m_pCapture[i*bpp+3] << 6) | (m_pCapture[i*bpp+2] >> 2));
						pdest[i*3+2] = (byte)((m_pCapture[i*bpp+5] << 6) | (m_pCapture[i*bpp+4] >> 2));
					}
				}
				// The rest can be copied directly.
				else
				{
					int size = getSize();
					for(int i=0; i<size; i++)
					{
						pdest[i] = m_pCapture[i];
					}
				}
			}

			m_Bitmap.UnlockBits(pBitmapData);


			// Image display
			g.DrawImage(m_Bitmap, new Rectangle(0, 0, getWidth(), getHeight()));

			// Line drawing
			Point Pos = this.PointToClient(Cursor.Position);
			Pen pen = new Pen(Color.Red, 1);
			g.DrawLine(pen, Pos.X, 0, Pos.X, getHeight());
			g.DrawLine(pen, 0, Pos.Y, getWidth(), Pos.Y);
		}

		private void Form1_Resize(object sender, System.EventArgs e)
		{
			if(1 == m_PreviewMode)
			{
				IntPtr hChild = GetWindow(this.Handle, 5);
				if(IntPtr.Zero != hChild)
				{

					// Calculation results in decimal figure. So apply floating-point calculations.
					double winW = this.Width;
					double winH = this.Height;

					// To avoiding changing aspect ratio, remove comment
/*					double capW = getWidth();
					double capH = getHeight();

					if( (winW * capH) > (winH * capW) )
					{
						winW = winH * capW / capH;
					}
					else if( (winW * capH) < (winH * capW) )
					{
						winH = winW * capH / capW;
					}
*/
					SetWindowPos(hChild, 0, 0, 0, (int)winW, (int)winH, 0x0046);
				}
			}
		}

		protected override void OnPaint(PaintEventArgs e)
		{
			base.OnPaint(e);

			// Draw using double-buffer (to avoid flickering)
			// Drawing within OnPaint is written into off-screen buffer.
			// Once process in OnPaint is complete, image is drawn on the screen.
			DrawImage(e.Graphics);
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			m_CArtCam.Close();
			timer1.Enabled = false;


			Form modalDialog = new Form2(m_CArtCam);
			DialogResult result = modalDialog.ShowDialog();

			switch(m_PreviewMode)
			{
				case 0: menuPreview_Click(sender, e); break;
				case 1: menuCallback_Click(sender, e); break;
				case 3: menuCapture_Click(sender, e); break;
				case 4: menuTrigger_Click(sender, e); break;
			}
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			Form modalDialog = new Form3(m_CArtCam, m_PreviewMode);
			DialogResult result = modalDialog.ShowDialog();
		}

		private void menuFile_Popup(object sender, System.EventArgs e)
		{
			// Check if saving is available (if an image has been captured at least once, it is possible).
			if(m_SaveFlg)
			{
				menuSave.Enabled = true;
			} 
			else 
			{
				menuSave.Enabled = false;
			}

			// Check is the camera is Directshow compatible
			// Only Directshow camera has recording function
			if(ARTCAM_CAMERATYPE.ARTCAM_CAMERATYPE_DS == m_CArtCam.GetDllType())
			{
				menuRec.Enabled = true;
			} 
			else 
			{
				menuRec.Enabled = false;
			}
		}

		private void menuView_Popup(object sender, System.EventArgs e)
		{
			// Disable playback if device is not connected
			if(-1 == m_SelectDevice)
			{
				menuPreview.Enabled = false;
				menuCallback.Enabled = false;
				menuSnapshot.Enabled = false;
				menuCapture.Enabled = false;
				menuTrigger.Enabled = false;
				menuStop.Enabled = false;
			}
			else 
			{
				menuPreview.Enabled = true;
				menuCallback.Enabled = true;
				menuSnapshot.Enabled = true;
				menuCapture.Enabled = true;
				menuStop.Enabled = false;

				// Remark: Trigger mode is not available in every model.
				switch(m_CArtCam.GetDllType())
				{
					case ARTCAM_CAMERATYPE.ARTCAM_CAMERATYPE_DS:		// DS
					case ARTCAM_CAMERATYPE.ARTCAM_CAMERATYPE_USTC:		// UST
					case ARTCAM_CAMERATYPE.ARTCAM_CAMERATYPE_CNV:		// CNV
					case ARTCAM_CAMERATYPE.ARTCAM_CAMERATYPE_200SH:		// 200SH
					case ARTCAM_CAMERATYPE.ARTCAM_CAMERATYPE_098:		// 098
					case ARTCAM_CAMERATYPE.ARTCAM_CAMERATYPE_500P:		// 500P
						menuTrigger.Enabled = false;
						break;

					default:
						menuTrigger.Enabled = true;
						break;
				}
			}
		}

		private void menuSet_Popup(object sender, System.EventArgs e)
		{
			// Directshow is not available in every model.
			// Note that "SetAnalogDlg" is not available in many models.
			menuCamera.Enabled = true;
			menuFilter.Enabled = true;

			switch(m_CArtCam.GetDllType())
			{
					//case ARTCAM_CAMERATYPE.ARTCAM_CAMERATYPE_DS:		// DS
				case ARTCAM_CAMERATYPE.ARTCAM_CAMERATYPE_USTC:		// UST
				case ARTCAM_CAMERATYPE.ARTCAM_CAMERATYPE_CNV:		// CNV
					menuAnalog.Enabled = false;
					break;

				default:
					menuAnalog.Enabled = true;
					break;
			}
		}


	}
}



