#if !defined(AFX_SETFILTERDLG_H__63E9B6E9_A9A0_40D2_BC51_F8DEC76FDC75__INCLUDED_)
#define AFX_SETFILTERDLG_H__63E9B6E9_A9A0_40D2_BC51_F8DEC76FDC75__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetFilterDlg.h : Header File
//

#include "CArtCamSdk.hpp"

/////////////////////////////////////////////////////////////////////////////
// CSetFilterDlg Dialog

class CSetFilterDlg : public CDialog
{
	BOOL			m_Init;
	LONG			m_DllType;

public:
	CArtCamSdk*		m_pCArtCamSdk;
	BOOL			m_Preview;

	BOOL	InitControl	(LONG FilterType, UINT EditID, UINT SpinID, short Min, short Max);
	BOOL	SetControl	(LONG FilterType, UINT EditID, UINT SpinID);


// Construction
public:
	CSetFilterDlg(CWnd* pParent = NULL);   // Standard constructor

// Dialog data
	//{{AFX_DATA(CSetFilterDlg)
	enum { IDD = IDD_SETFILTER };
		// Memo: ClassWizard adds data member here
	//}}AFX_DATA


// Override
	// ClassWizard creates override of hypothetical function
	//{{AFX_VIRTUAL(CSetFilterDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Created message map function
	//{{AFX_MSG(CSetFilterDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnMirrorV();
	afx_msg void OnMirrorH();
	afx_msg void OnAwb();
	afx_msg void OnBayer1();
	afx_msg void OnBayer2();
	afx_msg void OnBayer3();
	afx_msg void OnBayer4();
	afx_msg void OnAi1();
	afx_msg void OnAi2();
	afx_msg void OnAi3();
	afx_msg void OnHalfclock();
	afx_msg void OnChannel1();
	afx_msg void OnChannel2();
	afx_msg void OnChannel3();
	afx_msg void OnChannel4();
	afx_msg void OnChannel5();
	afx_msg void OnChannel6();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ inserts additional declaration before the front line.

#endif // !defined(AFX_SETFILTERDLG_H__63E9B6E9_A9A0_40D2_BC51_F8DEC76FDC75__INCLUDED_)
