using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using ArtCamSdk;

namespace Sample_CS
{
	/// <summary>
	/// Outline of Form5
	/// </summary>
	public class Form5 : System.Windows.Forms.Form
	{
		private CArtCam m_CArtCam = null;

		private int[]	m_CursorPosX		= {0,0};
		private int[]	m_CursorPosY		= {0,0};
		private int[]	m_CursorSizeX		= {0,0};
		private int[]	m_CursorSizeY		= {0,0};
		private int[]	m_CursorEnable		= {0,0};
		private int		m_CurrentCursorNum	= 0;
		private System.Drawing.Color[] m_CursorColor = new System.Drawing.Color[2];
		private int		m_AIMode	= 0;
		private int		m_AIMin		= 0;
		private int		m_AIMax		= 0;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.TrackBar trackBar1;
		private System.Windows.Forms.TrackBar trackBar2;
		private System.Windows.Forms.TrackBar trackBar3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.TrackBar trackBar4;
		private System.Windows.Forms.TrackBar trackBar5;
		private System.Windows.Forms.NumericUpDown numericUpDown1;
		private System.Windows.Forms.NumericUpDown numericUpDown2;
		private System.Windows.Forms.NumericUpDown numericUpDown3;
		private System.Windows.Forms.NumericUpDown numericUpDown4;
		private System.Windows.Forms.NumericUpDown numericUpDown5;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.RadioButton ButtonCursor1;
		private System.Windows.Forms.RadioButton ButtonCursor2;
		private System.Windows.Forms.TrackBar trackBarCurPosX;
		private System.Windows.Forms.TrackBar trackBarCurPosY;
		private System.Windows.Forms.NumericUpDown numericUpDownCurPosX;
		private System.Windows.Forms.NumericUpDown numericUpDownCurPosY;
		private System.Windows.Forms.TrackBar trackBarCurSizeX;
		private System.Windows.Forms.TrackBar trackBarCurSizeY;
		private System.Windows.Forms.NumericUpDown numericUpDownCurSizeX;
		private System.Windows.Forms.NumericUpDown numericUpDownCurSizeY;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.RadioButton radioButtonCursor1;
		private System.Windows.Forms.RadioButton radioButtonCursor2;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.NumericUpDown numericUpDownAiMin;
		private System.Windows.Forms.NumericUpDown numericUpDownAiMax;
		private System.Windows.Forms.ColorDialog colorDialog1;
		private System.Windows.Forms.ComboBox ComboClock;
		private System.Windows.Forms.ComboBox ComboResolution;
		private System.Windows.Forms.Button ButtonLive;
		private System.Windows.Forms.Button ButtonStill;
		private System.Windows.Forms.CheckBox CheckColor;
		private System.Windows.Forms.CheckBox CheckAWB;
		private System.Windows.Forms.CheckBox CheckAwbLock;
		private System.Windows.Forms.CheckBox CheckVflip;
		private System.Windows.Forms.CheckBox CheckCursorEnable;
		private System.Windows.Forms.CheckBox CheckAiGain;
		private System.Windows.Forms.CheckBox CheckAiExposure;
		private System.Windows.Forms.Button ButtonCurosrColor;
		/// <summary>
		/// Necessary designer variable 
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form5(CArtCam a)
		{
			//
			// This is needed for Windows form designer support.
			//
			InitializeComponent();

			//
			// TODO: Add constructor code after calling InitializeComponent.
			//
			m_CArtCam = a;
		}

		/// <summary>
		/// Execute after-treatment to resource used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// This method is required for designer support.
		/// Do not change the content of this method by code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ComboClock = new System.Windows.Forms.ComboBox();
			this.ComboResolution = new System.Windows.Forms.ComboBox();
			this.ButtonLive = new System.Windows.Forms.Button();
			this.ButtonStill = new System.Windows.Forms.Button();
			this.CheckColor = new System.Windows.Forms.CheckBox();
			this.CheckAWB = new System.Windows.Forms.CheckBox();
			this.CheckAwbLock = new System.Windows.Forms.CheckBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.numericUpDown1 = new System.Windows.Forms.NumericUpDown();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.trackBar3 = new System.Windows.Forms.TrackBar();
			this.trackBar2 = new System.Windows.Forms.TrackBar();
			this.trackBar1 = new System.Windows.Forms.TrackBar();
			this.numericUpDown2 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDown3 = new System.Windows.Forms.NumericUpDown();
			this.button3 = new System.Windows.Forms.Button();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label8 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.trackBar5 = new System.Windows.Forms.TrackBar();
			this.trackBar4 = new System.Windows.Forms.TrackBar();
			this.numericUpDown4 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDown5 = new System.Windows.Forms.NumericUpDown();
			this.button5 = new System.Windows.Forms.Button();
			this.CheckVflip = new System.Windows.Forms.CheckBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.CheckCursorEnable = new System.Windows.Forms.CheckBox();
			this.label10 = new System.Windows.Forms.Label();
			this.ButtonCurosrColor = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			this.radioButtonCursor1 = new System.Windows.Forms.RadioButton();
			this.radioButtonCursor2 = new System.Windows.Forms.RadioButton();
			this.trackBarCurPosX = new System.Windows.Forms.TrackBar();
			this.label1 = new System.Windows.Forms.Label();
			this.numericUpDownCurPosX = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownCurPosY = new System.Windows.Forms.NumericUpDown();
			this.trackBarCurPosY = new System.Windows.Forms.TrackBar();
			this.label2 = new System.Windows.Forms.Label();
			this.numericUpDownCurSizeX = new System.Windows.Forms.NumericUpDown();
			this.trackBarCurSizeX = new System.Windows.Forms.TrackBar();
			this.label3 = new System.Windows.Forms.Label();
			this.numericUpDownCurSizeY = new System.Windows.Forms.NumericUpDown();
			this.trackBarCurSizeY = new System.Windows.Forms.TrackBar();
			this.label9 = new System.Windows.Forms.Label();
			this.ButtonCursor1 = new System.Windows.Forms.RadioButton();
			this.ButtonCursor2 = new System.Windows.Forms.RadioButton();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.numericUpDownAiMin = new System.Windows.Forms.NumericUpDown();
			this.label11 = new System.Windows.Forms.Label();
			this.CheckAiGain = new System.Windows.Forms.CheckBox();
			this.CheckAiExposure = new System.Windows.Forms.CheckBox();
			this.label12 = new System.Windows.Forms.Label();
			this.numericUpDownAiMax = new System.Windows.Forms.NumericUpDown();
			this.colorDialog1 = new System.Windows.Forms.ColorDialog();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar3)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown3)).BeginInit();
			this.groupBox2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.trackBar5)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar4)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown4)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown5)).BeginInit();
			this.groupBox3.SuspendLayout();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.trackBarCurPosX)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownCurPosX)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownCurPosY)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarCurPosY)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownCurSizeX)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarCurSizeX)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownCurSizeY)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarCurSizeY)).BeginInit();
			this.groupBox4.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAiMin)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAiMax)).BeginInit();
			this.SuspendLayout();
			// 
			// ComboClock
			// 
			this.ComboClock.Items.AddRange(new object[] {
														   "24MHz",
														   "48MHz"});
			this.ComboClock.Location = new System.Drawing.Point(16, 8);
			this.ComboClock.Name = "ComboClock";
			this.ComboClock.Size = new System.Drawing.Size(128, 20);
			this.ComboClock.TabIndex = 0;
			this.ComboClock.Text = "comboBox1";
			this.ComboClock.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
			// 
			// ComboResolution
			// 
			this.ComboResolution.Items.AddRange(new object[] {
																 "800 * 600",
																 "1280 * 720",
																 "1280 * 1024"});
			this.ComboResolution.Location = new System.Drawing.Point(16, 48);
			this.ComboResolution.Name = "ComboResolution";
			this.ComboResolution.Size = new System.Drawing.Size(128, 20);
			this.ComboResolution.TabIndex = 1;
			this.ComboResolution.Text = "comboBox2";
			this.ComboResolution.SelectedIndexChanged += new System.EventHandler(this.comboBox2_SelectedIndexChanged);
			// 
			// ButtonLive
			// 
			this.ButtonLive.Location = new System.Drawing.Point(152, 8);
			this.ButtonLive.Name = "ButtonLive";
			this.ButtonLive.Size = new System.Drawing.Size(64, 24);
			this.ButtonLive.TabIndex = 2;
			this.ButtonLive.Text = "Live";
			this.ButtonLive.Click += new System.EventHandler(this.button1_Click);
			// 
			// ButtonStill
			// 
			this.ButtonStill.Location = new System.Drawing.Point(152, 48);
			this.ButtonStill.Name = "ButtonStill";
			this.ButtonStill.Size = new System.Drawing.Size(64, 24);
			this.ButtonStill.TabIndex = 3;
			this.ButtonStill.Text = "Still";
			this.ButtonStill.Click += new System.EventHandler(this.button2_Click);
			// 
			// CheckColor
			// 
			this.CheckColor.Location = new System.Drawing.Point(224, 8);
			this.CheckColor.Name = "CheckColor";
			this.CheckColor.Size = new System.Drawing.Size(80, 16);
			this.CheckColor.TabIndex = 4;
			this.CheckColor.Text = "Color";
			this.CheckColor.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// CheckAWB
			// 
			this.CheckAWB.Location = new System.Drawing.Point(224, 32);
			this.CheckAWB.Name = "CheckAWB";
			this.CheckAWB.Size = new System.Drawing.Size(80, 16);
			this.CheckAWB.TabIndex = 6;
			this.CheckAWB.Text = "AWB";
			this.CheckAWB.CheckedChanged += new System.EventHandler(this.checkBox2_CheckedChanged);
			// 
			// CheckAwbLock
			// 
			this.CheckAwbLock.Location = new System.Drawing.Point(224, 56);
			this.CheckAwbLock.Name = "CheckAwbLock";
			this.CheckAwbLock.Size = new System.Drawing.Size(88, 16);
			this.CheckAwbLock.TabIndex = 8;
			this.CheckAwbLock.Text = "Lock";
			this.CheckAwbLock.CheckedChanged += new System.EventHandler(this.checkBox3_CheckedChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.numericUpDown1);
			this.groupBox1.Controls.Add(this.label6);
			this.groupBox1.Controls.Add(this.label5);
			this.groupBox1.Controls.Add(this.label4);
			this.groupBox1.Controls.Add(this.trackBar3);
			this.groupBox1.Controls.Add(this.trackBar2);
			this.groupBox1.Controls.Add(this.trackBar1);
			this.groupBox1.Controls.Add(this.numericUpDown2);
			this.groupBox1.Controls.Add(this.numericUpDown3);
			this.groupBox1.Location = new System.Drawing.Point(16, 88);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(376, 168);
			this.groupBox1.TabIndex = 10;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Bayer";
			// 
			// numericUpDown1
			// 
			this.numericUpDown1.Location = new System.Drawing.Point(312, 24);
			this.numericUpDown1.Maximum = new System.Decimal(new int[] {
																		   1023,
																		   0,
																		   0,
																		   0});
			this.numericUpDown1.Name = "numericUpDown1";
			this.numericUpDown1.Size = new System.Drawing.Size(56, 19);
			this.numericUpDown1.TabIndex = 9;
			this.numericUpDown1.ValueChanged += new System.EventHandler(this.numericUpDown1_ValueChanged);
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 128);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(40, 16);
			this.label6.TabIndex = 5;
			this.label6.Text = "B Gain";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 80);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(40, 16);
			this.label5.TabIndex = 4;
			this.label5.Text = "G Gain";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 32);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(40, 16);
			this.label4.TabIndex = 3;
			this.label4.Text = "R Gain";
			// 
			// trackBar3
			// 
			this.trackBar3.AutoSize = false;
			this.trackBar3.Location = new System.Drawing.Point(64, 120);
			this.trackBar3.Maximum = 1023;
			this.trackBar3.Name = "trackBar3";
			this.trackBar3.Size = new System.Drawing.Size(248, 42);
			this.trackBar3.TabIndex = 2;
			this.trackBar3.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackBar3.Scroll += new System.EventHandler(this.trackBar3_Scroll);
			// 
			// trackBar2
			// 
			this.trackBar2.AutoSize = false;
			this.trackBar2.Location = new System.Drawing.Point(64, 72);
			this.trackBar2.Maximum = 1023;
			this.trackBar2.Name = "trackBar2";
			this.trackBar2.Size = new System.Drawing.Size(248, 42);
			this.trackBar2.TabIndex = 1;
			this.trackBar2.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackBar2.Scroll += new System.EventHandler(this.trackBar2_Scroll);
			// 
			// trackBar1
			// 
			this.trackBar1.AutoSize = false;
			this.trackBar1.Location = new System.Drawing.Point(64, 24);
			this.trackBar1.Maximum = 1023;
			this.trackBar1.Name = "trackBar1";
			this.trackBar1.Size = new System.Drawing.Size(248, 42);
			this.trackBar1.TabIndex = 0;
			this.trackBar1.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackBar1.Scroll += new System.EventHandler(this.trackBar1_Scroll);
			// 
			// numericUpDown2
			// 
			this.numericUpDown2.Location = new System.Drawing.Point(312, 72);
			this.numericUpDown2.Maximum = new System.Decimal(new int[] {
																		   1023,
																		   0,
																		   0,
																		   0});
			this.numericUpDown2.Name = "numericUpDown2";
			this.numericUpDown2.Size = new System.Drawing.Size(56, 19);
			this.numericUpDown2.TabIndex = 9;
			this.numericUpDown2.ValueChanged += new System.EventHandler(this.numericUpDown2_ValueChanged);
			// 
			// numericUpDown3
			// 
			this.numericUpDown3.Location = new System.Drawing.Point(312, 120);
			this.numericUpDown3.Maximum = new System.Decimal(new int[] {
																		   1023,
																		   0,
																		   0,
																		   0});
			this.numericUpDown3.Name = "numericUpDown3";
			this.numericUpDown3.Size = new System.Drawing.Size(56, 19);
			this.numericUpDown3.TabIndex = 9;
			this.numericUpDown3.ValueChanged += new System.EventHandler(this.numericUpDown3_ValueChanged);
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(584, 384);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(96, 32);
			this.button3.TabIndex = 11;
			this.button3.Text = "Save Settings";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.label8);
			this.groupBox2.Controls.Add(this.label7);
			this.groupBox2.Controls.Add(this.trackBar5);
			this.groupBox2.Controls.Add(this.trackBar4);
			this.groupBox2.Controls.Add(this.numericUpDown4);
			this.groupBox2.Controls.Add(this.numericUpDown5);
			this.groupBox2.Location = new System.Drawing.Point(16, 264);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(376, 112);
			this.groupBox2.TabIndex = 14;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Sensor";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(8, 72);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(48, 16);
			this.label8.TabIndex = 3;
			this.label8.Text = "Shutter";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(8, 24);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(40, 16);
			this.label7.TabIndex = 2;
			this.label7.Text = "Gain";
			// 
			// trackBar5
			// 
			this.trackBar5.AutoSize = false;
			this.trackBar5.Location = new System.Drawing.Point(64, 64);
			this.trackBar5.Maximum = 16383;
			this.trackBar5.Minimum = 1;
			this.trackBar5.Name = "trackBar5";
			this.trackBar5.Size = new System.Drawing.Size(248, 42);
			this.trackBar5.TabIndex = 1;
			this.trackBar5.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackBar5.Value = 1;
			this.trackBar5.Scroll += new System.EventHandler(this.trackBar5_Scroll);
			// 
			// trackBar4
			// 
			this.trackBar4.AutoSize = false;
			this.trackBar4.Location = new System.Drawing.Point(64, 16);
			this.trackBar4.Maximum = 63;
			this.trackBar4.Name = "trackBar4";
			this.trackBar4.Size = new System.Drawing.Size(248, 42);
			this.trackBar4.TabIndex = 0;
			this.trackBar4.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackBar4.Scroll += new System.EventHandler(this.trackBar4_Scroll);
			// 
			// numericUpDown4
			// 
			this.numericUpDown4.Location = new System.Drawing.Point(312, 16);
			this.numericUpDown4.Maximum = new System.Decimal(new int[] {
																		   63,
																		   0,
																		   0,
																		   0});
			this.numericUpDown4.Name = "numericUpDown4";
			this.numericUpDown4.Size = new System.Drawing.Size(56, 19);
			this.numericUpDown4.TabIndex = 9;
			this.numericUpDown4.ValueChanged += new System.EventHandler(this.numericUpDown4_ValueChanged);
			// 
			// numericUpDown5
			// 
			this.numericUpDown5.Location = new System.Drawing.Point(312, 64);
			this.numericUpDown5.Maximum = new System.Decimal(new int[] {
																		   16383,
																		   0,
																		   0,
																		   0});
			this.numericUpDown5.Minimum = new System.Decimal(new int[] {
																		   1,
																		   0,
																		   0,
																		   0});
			this.numericUpDown5.Name = "numericUpDown5";
			this.numericUpDown5.Size = new System.Drawing.Size(56, 19);
			this.numericUpDown5.TabIndex = 9;
			this.numericUpDown5.Value = new System.Decimal(new int[] {
																		 1,
																		 0,
																		 0,
																		 0});
			this.numericUpDown5.ValueChanged += new System.EventHandler(this.numericUpDown5_ValueChanged);
			// 
			// button5
			// 
			this.button5.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.button5.Location = new System.Drawing.Point(696, 384);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(96, 32);
			this.button5.TabIndex = 13;
			this.button5.Text = "Close";
			// 
			// CheckVflip
			// 
			this.CheckVflip.Location = new System.Drawing.Point(320, 56);
			this.CheckVflip.Name = "CheckVflip";
			this.CheckVflip.Size = new System.Drawing.Size(64, 16);
			this.CheckVflip.TabIndex = 10;
			this.CheckVflip.Text = "Vflip";
			this.CheckVflip.CheckedChanged += new System.EventHandler(this.checkBox4_CheckedChanged);
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.CheckCursorEnable);
			this.groupBox3.Controls.Add(this.label10);
			this.groupBox3.Controls.Add(this.ButtonCurosrColor);
			this.groupBox3.Controls.Add(this.panel1);
			this.groupBox3.Controls.Add(this.trackBarCurPosX);
			this.groupBox3.Controls.Add(this.label1);
			this.groupBox3.Controls.Add(this.numericUpDownCurPosX);
			this.groupBox3.Controls.Add(this.numericUpDownCurPosY);
			this.groupBox3.Controls.Add(this.trackBarCurPosY);
			this.groupBox3.Controls.Add(this.label2);
			this.groupBox3.Controls.Add(this.numericUpDownCurSizeX);
			this.groupBox3.Controls.Add(this.trackBarCurSizeX);
			this.groupBox3.Controls.Add(this.label3);
			this.groupBox3.Controls.Add(this.numericUpDownCurSizeY);
			this.groupBox3.Controls.Add(this.trackBarCurSizeY);
			this.groupBox3.Controls.Add(this.label9);
			this.groupBox3.Location = new System.Drawing.Point(424, 8);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(368, 264);
			this.groupBox3.TabIndex = 15;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Cursor";
			// 
			// CheckCursorEnable
			// 
			this.CheckCursorEnable.Location = new System.Drawing.Point(16, 24);
			this.CheckCursorEnable.Name = "CheckCursorEnable";
			this.CheckCursorEnable.Size = new System.Drawing.Size(72, 16);
			this.CheckCursorEnable.TabIndex = 13;
			this.CheckCursorEnable.Text = "Enable";
			this.CheckCursorEnable.CheckedChanged += new System.EventHandler(this.checkBox5_CheckedChanged);
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(88, 232);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(152, 16);
			this.label10.TabIndex = 12;
			this.label10.Text = "Cursor Color select";
			// 
			// ButtonCurosrColor
			// 
			this.ButtonCurosrColor.Location = new System.Drawing.Point(24, 224);
			this.ButtonCurosrColor.Name = "ButtonCurosrColor";
			this.ButtonCurosrColor.Size = new System.Drawing.Size(48, 24);
			this.ButtonCurosrColor.TabIndex = 11;
			this.ButtonCurosrColor.Click += new System.EventHandler(this.button4_Click);
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.radioButtonCursor1);
			this.panel1.Controls.Add(this.radioButtonCursor2);
			this.panel1.Location = new System.Drawing.Point(112, 16);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(232, 32);
			this.panel1.TabIndex = 10;
			// 
			// radioButtonCursor1
			// 
			this.radioButtonCursor1.Location = new System.Drawing.Point(8, 8);
			this.radioButtonCursor1.Name = "radioButtonCursor1";
			this.radioButtonCursor1.Size = new System.Drawing.Size(96, 16);
			this.radioButtonCursor1.TabIndex = 0;
			this.radioButtonCursor1.Text = "Cursor 1";
			this.radioButtonCursor1.CheckedChanged += new System.EventHandler(this.radioButtonCursor1_CheckedChanged);
			// 
			// radioButtonCursor2
			// 
			this.radioButtonCursor2.Location = new System.Drawing.Point(128, 8);
			this.radioButtonCursor2.Name = "radioButtonCursor2";
			this.radioButtonCursor2.Size = new System.Drawing.Size(96, 16);
			this.radioButtonCursor2.TabIndex = 0;
			this.radioButtonCursor2.Text = "Cursor 2";
			this.radioButtonCursor2.CheckedChanged += new System.EventHandler(this.radioButtonCursor2_CheckedChanged);
			// 
			// trackBarCurPosX
			// 
			this.trackBarCurPosX.AutoSize = false;
			this.trackBarCurPosX.Location = new System.Drawing.Point(80, 56);
			this.trackBarCurPosX.Maximum = 2047;
			this.trackBarCurPosX.Name = "trackBarCurPosX";
			this.trackBarCurPosX.Size = new System.Drawing.Size(216, 42);
			this.trackBarCurPosX.TabIndex = 0;
			this.trackBarCurPosX.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackBarCurPosX.Scroll += new System.EventHandler(this.trackBarCurPosX_Scroll);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 56);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(40, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = "X Pos";
			// 
			// numericUpDownCurPosX
			// 
			this.numericUpDownCurPosX.Location = new System.Drawing.Point(296, 56);
			this.numericUpDownCurPosX.Maximum = new System.Decimal(new int[] {
																				 2047,
																				 0,
																				 0,
																				 0});
			this.numericUpDownCurPosX.Name = "numericUpDownCurPosX";
			this.numericUpDownCurPosX.Size = new System.Drawing.Size(56, 19);
			this.numericUpDownCurPosX.TabIndex = 9;
			this.numericUpDownCurPosX.ValueChanged += new System.EventHandler(this.numericUpDownCurPosX_ValueChanged);
			// 
			// numericUpDownCurPosY
			// 
			this.numericUpDownCurPosY.Location = new System.Drawing.Point(296, 96);
			this.numericUpDownCurPosY.Maximum = new System.Decimal(new int[] {
																				 2047,
																				 0,
																				 0,
																				 0});
			this.numericUpDownCurPosY.Name = "numericUpDownCurPosY";
			this.numericUpDownCurPosY.Size = new System.Drawing.Size(56, 19);
			this.numericUpDownCurPosY.TabIndex = 9;
			this.numericUpDownCurPosY.ValueChanged += new System.EventHandler(this.numericUpDownCurPosY_ValueChanged);
			// 
			// trackBarCurPosY
			// 
			this.trackBarCurPosY.AutoSize = false;
			this.trackBarCurPosY.Location = new System.Drawing.Point(80, 96);
			this.trackBarCurPosY.Maximum = 2047;
			this.trackBarCurPosY.Name = "trackBarCurPosY";
			this.trackBarCurPosY.Size = new System.Drawing.Size(216, 42);
			this.trackBarCurPosY.TabIndex = 0;
			this.trackBarCurPosY.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackBarCurPosY.Scroll += new System.EventHandler(this.trackBarCurPosY_Scroll);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 104);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(40, 16);
			this.label2.TabIndex = 3;
			this.label2.Text = "Y Pos";
			// 
			// numericUpDownCurSizeX
			// 
			this.numericUpDownCurSizeX.Location = new System.Drawing.Point(296, 136);
			this.numericUpDownCurSizeX.Maximum = new System.Decimal(new int[] {
																				  2047,
																				  0,
																				  0,
																				  0});
			this.numericUpDownCurSizeX.Name = "numericUpDownCurSizeX";
			this.numericUpDownCurSizeX.Size = new System.Drawing.Size(56, 19);
			this.numericUpDownCurSizeX.TabIndex = 9;
			this.numericUpDownCurSizeX.ValueChanged += new System.EventHandler(this.numericUpDownCurSizeX_ValueChanged);
			// 
			// trackBarCurSizeX
			// 
			this.trackBarCurSizeX.AutoSize = false;
			this.trackBarCurSizeX.Location = new System.Drawing.Point(80, 136);
			this.trackBarCurSizeX.Maximum = 2047;
			this.trackBarCurSizeX.Name = "trackBarCurSizeX";
			this.trackBarCurSizeX.Size = new System.Drawing.Size(216, 42);
			this.trackBarCurSizeX.TabIndex = 0;
			this.trackBarCurSizeX.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackBarCurSizeX.Scroll += new System.EventHandler(this.trackBarCurSizeX_Scroll);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 144);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(40, 16);
			this.label3.TabIndex = 3;
			this.label3.Text = "X Size";
			// 
			// numericUpDownCurSizeY
			// 
			this.numericUpDownCurSizeY.Location = new System.Drawing.Point(296, 176);
			this.numericUpDownCurSizeY.Maximum = new System.Decimal(new int[] {
																				  2047,
																				  0,
																				  0,
																				  0});
			this.numericUpDownCurSizeY.Name = "numericUpDownCurSizeY";
			this.numericUpDownCurSizeY.Size = new System.Drawing.Size(56, 19);
			this.numericUpDownCurSizeY.TabIndex = 9;
			this.numericUpDownCurSizeY.ValueChanged += new System.EventHandler(this.numericUpDownCurSizeY_ValueChanged);
			// 
			// trackBarCurSizeY
			// 
			this.trackBarCurSizeY.AutoSize = false;
			this.trackBarCurSizeY.Location = new System.Drawing.Point(80, 176);
			this.trackBarCurSizeY.Maximum = 2047;
			this.trackBarCurSizeY.Name = "trackBarCurSizeY";
			this.trackBarCurSizeY.Size = new System.Drawing.Size(216, 42);
			this.trackBarCurSizeY.TabIndex = 0;
			this.trackBarCurSizeY.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackBarCurSizeY.Scroll += new System.EventHandler(this.trackBarCurSizeY_Scroll);
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(16, 184);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(40, 16);
			this.label9.TabIndex = 3;
			this.label9.Text = "Y Size";
			// 
			// ButtonCursor1
			// 
			this.ButtonCursor1.Location = new System.Drawing.Point(16, 8);
			this.ButtonCursor1.Name = "ButtonCursor1";
			this.ButtonCursor1.Size = new System.Drawing.Size(112, 16);
			this.ButtonCursor1.TabIndex = 1;
			this.ButtonCursor1.Text = "Cursor 1";
			// 
			// ButtonCursor2
			// 
			this.ButtonCursor2.Location = new System.Drawing.Point(152, 8);
			this.ButtonCursor2.Name = "ButtonCursor2";
			this.ButtonCursor2.Size = new System.Drawing.Size(112, 16);
			this.ButtonCursor2.TabIndex = 1;
			this.ButtonCursor2.Text = "Cursor 2";
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.Add(this.numericUpDownAiMin);
			this.groupBox4.Controls.Add(this.label11);
			this.groupBox4.Controls.Add(this.CheckAiGain);
			this.groupBox4.Controls.Add(this.CheckAiExposure);
			this.groupBox4.Controls.Add(this.label12);
			this.groupBox4.Controls.Add(this.numericUpDownAiMax);
			this.groupBox4.Location = new System.Drawing.Point(424, 288);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(368, 88);
			this.groupBox4.TabIndex = 16;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Auto Iris";
			// 
			// numericUpDownAiMin
			// 
			this.numericUpDownAiMin.Location = new System.Drawing.Point(296, 24);
			this.numericUpDownAiMin.Maximum = new System.Decimal(new int[] {
																			   255,
																			   0,
																			   0,
																			   0});
			this.numericUpDownAiMin.Name = "numericUpDownAiMin";
			this.numericUpDownAiMin.Size = new System.Drawing.Size(56, 19);
			this.numericUpDownAiMin.TabIndex = 2;
			this.numericUpDownAiMin.ValueChanged += new System.EventHandler(this.numericUpDownAiMin_ValueChanged);
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(168, 24);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(80, 16);
			this.label11.TabIndex = 1;
			this.label11.Text = "Min (0 - 255)";
			// 
			// CheckAiGain
			// 
			this.CheckAiGain.Location = new System.Drawing.Point(24, 24);
			this.CheckAiGain.Name = "CheckAiGain";
			this.CheckAiGain.Size = new System.Drawing.Size(96, 16);
			this.CheckAiGain.TabIndex = 0;
			this.CheckAiGain.Text = "Gain";
			this.CheckAiGain.CheckedChanged += new System.EventHandler(this.checkBoxAiGain_CheckedChanged);
			// 
			// CheckAiExposure
			// 
			this.CheckAiExposure.Location = new System.Drawing.Point(24, 56);
			this.CheckAiExposure.Name = "CheckAiExposure";
			this.CheckAiExposure.Size = new System.Drawing.Size(96, 16);
			this.CheckAiExposure.TabIndex = 0;
			this.CheckAiExposure.Text = "Exposure";
			this.CheckAiExposure.CheckedChanged += new System.EventHandler(this.checkBoxAiExposure_CheckedChanged);
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(168, 56);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(88, 16);
			this.label12.TabIndex = 1;
			this.label12.Text = "Max (0 - 255)";
			// 
			// numericUpDownAiMax
			// 
			this.numericUpDownAiMax.Location = new System.Drawing.Point(296, 56);
			this.numericUpDownAiMax.Maximum = new System.Decimal(new int[] {
																			   255,
																			   0,
																			   0,
																			   0});
			this.numericUpDownAiMax.Name = "numericUpDownAiMax";
			this.numericUpDownAiMax.Size = new System.Drawing.Size(56, 19);
			this.numericUpDownAiMax.TabIndex = 2;
			this.numericUpDownAiMax.ValueChanged += new System.EventHandler(this.numericUpDownAiMax_ValueChanged);
			// 
			// Form5
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(794, 423);
			this.Controls.Add(this.groupBox4);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.button5);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.CheckAwbLock);
			this.Controls.Add(this.CheckAWB);
			this.Controls.Add(this.CheckColor);
			this.Controls.Add(this.ButtonStill);
			this.Controls.Add(this.ButtonLive);
			this.Controls.Add(this.ComboResolution);
			this.Controls.Add(this.ComboClock);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.CheckVflip);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Form5";
			this.Text = "Form5";
			this.Load += new System.EventHandler(this.Form5_Load);
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar3)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown3)).EndInit();
			this.groupBox2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.trackBar5)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar4)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown4)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown5)).EndInit();
			this.groupBox3.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.trackBarCurPosX)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownCurPosX)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownCurPosY)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarCurPosY)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownCurSizeX)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarCurSizeX)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownCurSizeY)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarCurSizeY)).EndInit();
			this.groupBox4.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAiMin)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAiMax)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void Form5_Load(object sender, System.EventArgs e)
		{
			//! J[[h̎擾 (/J[)
			int MonitorColorMode = m_CArtCam.Monitor_GetColorMode();
			if(1 == MonitorColorMode) this.CheckColor.Checked = true;
			else
			{
				this.CheckAWB.Enabled = false;
				this.CheckAwbLock.Enabled = false;
			}

			// Get auto iris settings (ON/OFF)
			if(1 == m_CArtCam.Monitor_GetBayerGainAuto())
				this.CheckAWB.Checked = true;
			else 
				this.CheckAwbLock.Enabled = false;

			//! I[gzCgoXŒݒ̎擾 (ON/OFF)
			if(1 == m_CArtCam.Monitor_GetBayerGainLock()) 
				this.CheckAwbLock.Checked = true;


			//! xC[J[QC̐ݒ (AWBL͖܂)
			this.numericUpDown1.Value	= this.trackBar1.Value	= m_CArtCam.Monitor_GetBayerGainRed();
			this.numericUpDown2.Value	= this.trackBar2.Value	= m_CArtCam.Monitor_GetBayerGainGreen();
			this.numericUpDown3.Value	= this.trackBar3.Value	= m_CArtCam.Monitor_GetBayerGainBlue();
			
			//! QCAVb^[Xs[hA~[]Ԃ̎擾
			this.numericUpDown4.Value	= this.trackBar4.Value	= m_CArtCam.GetGlobalGain();
			this.numericUpDown5.Value	= this.trackBar5.Value	= m_CArtCam.GetExposureTime();

			if(m_CArtCam.GetDllType() == ARTCAM_CAMERATYPE.ARTCAM_CAMERATYPE_130MI_MOUT)
			{
				this.CheckVflip.Checked = m_CArtCam.GetMirrorV();
			}
			else
			{
				this.CheckVflip.Enabled = false;
			}

			//! NbN̎擾
			switch(m_CArtCam.Monitor_GetCameraClock())
			{
				case 5 : this.ComboClock.SelectedIndex = 1; break;
				case 2 :
				default: this.ComboClock.SelectedIndex = 0; break;
			}

			//! 𑜓x̎擾
			int MonWidth, MonHeight;
			m_CArtCam.Monitor_GetPreviewSize(out MonWidth , out MonHeight);
			
			if(800 == MonWidth || 600 == MonHeight)
				this.ComboResolution.SelectedIndex = 0;
			else if(1280 == MonWidth || 720 == MonHeight)
				this.ComboResolution.SelectedIndex = 1;
			else
				this.ComboResolution.SelectedIndex = 2;


			//! J[\̏Ԏ擾
			m_CurrentCursorNum = 0;
			this.radioButtonCursor1.Checked = true;
			for(int i=0; i<2; i++)
			{
				m_CursorEnable[i] = m_CArtCam.Monitor_GetCrossCursorMode(i);
				m_CArtCam.Monitor_GetCrossCursorPos (i, out m_CursorPosX[i],  out m_CursorPosY[i]);
				m_CArtCam.Monitor_GetCrossCursorSize(i, out m_CursorSizeX[i], out m_CursorSizeY[i]);

				m_CursorColor[i] = System.Drawing.ColorTranslator.FromOle(
					m_CArtCam.Monitor_GetCrossCursorColorR(i) <<  0 |
					m_CArtCam.Monitor_GetCrossCursorColorG(i) <<  8 |
					m_CArtCam.Monitor_GetCrossCursorColorB(i) << 16
					);
			}
			SetCursor();

			//!I[gACX̏Ԏ擾
			m_AIMode = m_CArtCam.Monitor_GetAutoIrisMode();
			this.SetAI();
			m_CArtCam.Monitor_GetAutoIrisRange(out m_AIMin, out m_AIMax);
			this.numericUpDownAiMin.Value = m_AIMin;
			this.numericUpDownAiMax.Value = m_AIMax;

		}

		
		//! J[\ݒ̏Ԃ_CAOɔf 
		private void SetCursor()
		{
			this.CheckCursorEnable.Checked = (m_CursorEnable[m_CurrentCursorNum] == 0) ?  false : true;
			this.trackBarCurPosX.Value = m_CursorPosX[m_CurrentCursorNum];
			this.trackBarCurPosY.Value = m_CursorPosY[m_CurrentCursorNum];
			this.numericUpDownCurPosX.Value = m_CursorPosX[m_CurrentCursorNum];
			this.numericUpDownCurPosY.Value = m_CursorPosY[m_CurrentCursorNum];

			this.trackBarCurSizeX.Value = m_CursorSizeX[m_CurrentCursorNum];
			this.trackBarCurSizeY.Value = m_CursorSizeY[m_CurrentCursorNum];
			this.numericUpDownCurSizeX.Value = m_CursorSizeX[m_CurrentCursorNum];
			this.numericUpDownCurSizeY.Value = m_CursorSizeY[m_CurrentCursorNum];

			this.ButtonCurosrColor.BackColor = m_CursorColor[m_CurrentCursorNum];
		}

		//! I[gACXݒ̏Ԃ_CAOɔf
		private void SetAI()
		{
			switch((AI_TYPE)m_AIMode)
			{
				case AI_TYPE.AI_NONE:		
					this.CheckAiGain.Checked		= false;	
					this.CheckAiExposure.Checked	= false;		
					break;
				case AI_TYPE.AI_EXPOSURE:
					this.CheckAiGain.Checked		= false;	
					this.CheckAiExposure.Checked	= true;		
					break;
				case AI_TYPE.AI_GAIN:		
					this.CheckAiGain.Checked		= true;	
					this.CheckAiExposure.Checked	= false;		
					break;
				case AI_TYPE.AI_BOTH:
					this.CheckAiGain.Checked		= true;	
					this.CheckAiExposure.Checked	= true;		
					break;
			}
		}

		//! xC[J[QC̐ݒ()
		private void trackBar1_Scroll(object sender, System.EventArgs e)
		{
			this.numericUpDown1.Value = this.trackBar1.Value;
			m_CArtCam.Monitor_SetBayerGainRed(this.trackBar1.Value);
		}
		private void numericUpDown1_ValueChanged(object sender, System.EventArgs e)
		{
			this.trackBar1.Value = (int)this.numericUpDown1.Value;
			m_CArtCam.Monitor_SetBayerGainRed((int)this.numericUpDown1.Value);
		}

		//! xC[J[QC̐ݒ()
		private void trackBar2_Scroll(object sender, System.EventArgs e)
		{
			this.numericUpDown2.Value = this.trackBar2.Value;
			m_CArtCam.Monitor_SetBayerGainGreen(this.trackBar2.Value);
		}
		private void numericUpDown2_ValueChanged(object sender, System.EventArgs e)
		{
			this.trackBar2.Value = (int)this.numericUpDown2.Value;
			m_CArtCam.Monitor_SetBayerGainGreen((int)this.numericUpDown2.Value);
		}

		//! xC[J[QC̐ݒ()
		private void trackBar3_Scroll(object sender, System.EventArgs e)
		{
			this.numericUpDown3.Value = this.trackBar3.Value;
			m_CArtCam.Monitor_SetBayerGainBlue(this.trackBar3.Value);
		}
		private void numericUpDown3_ValueChanged(object sender, System.EventArgs e)
		{
			this.trackBar3.Value = (int)this.numericUpDown3.Value;
			m_CArtCam.Monitor_SetBayerGainBlue((int)this.numericUpDown3.Value);
		}

		// Gain settings
		private void trackBar4_Scroll(object sender, System.EventArgs e)
		{
			this.numericUpDown4.Value = this.trackBar4.Value;
			m_CArtCam.SetGlobalGain(this.trackBar4.Value);
		}
		private void numericUpDown4_ValueChanged(object sender, System.EventArgs e)
		{
			this.trackBar4.Value = (int)this.numericUpDown4.Value;
			m_CArtCam.SetGlobalGain((int)this.numericUpDown4.Value);
		}

		// Exposure time settings
		private void trackBar5_Scroll(object sender, System.EventArgs e)
		{
			this.numericUpDown5.Value = this.trackBar5.Value;
			m_CArtCam.SetExposureTime(this.trackBar5.Value);
		}
		private void numericUpDown5_ValueChanged(object sender, System.EventArgs e)
		{
			this.trackBar5.Value = (int)this.numericUpDown5.Value;
			m_CArtCam.SetExposureTime((int)this.numericUpDown5.Value);
		}


		//! \[hɐ؂ւ
		private void button1_Click(object sender, System.EventArgs e)
		{
			m_CArtCam.Monitor_SetPreviewMode(1);
		}

		//! Î~\[hɐ؂ւ
		//! Î~\ɉꂽꍇ́A摜XV(XibvVbg)
		private void button2_Click(object sender, System.EventArgs e)
		{
			m_CArtCam.Monitor_SetPreviewMode(0);
		}


		//! NbN̐ݒ
		//! 16MHzݒ -> SetCameraClock(0) ͎gpȂłB
		//! 48MHzݒ́ASXGA(1280*1024)o͂ł͓삵Ȃꍇ܂B
		private void comboBox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (this.ComboClock.SelectedIndex == 0)
				m_CArtCam.Monitor_SetCameraClock(1);
			else
				m_CArtCam.Monitor_SetCameraClock(2);
		}

		//! o͉𑜓x̐ݒ
		//! 720p <-> SXGA̐؂ւ͂ł܂B
		private void comboBox2_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			//SVGA
			if(this.ComboResolution.SelectedIndex == 0)
				m_CArtCam.Monitor_SetPreviewSize(800,600);
				//720p
			else if(this.ComboResolution.SelectedIndex == 1)
				m_CArtCam.Monitor_SetPreviewSize(1280,720);
				//SXGA
			else
				m_CArtCam.Monitor_SetPreviewSize(1280,1024);
		}

		//! J[[h̐؂ւ
		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			int Flg = (true == this.CheckColor.Checked) ? 1 : 0 ;
			m_CArtCam.Monitor_SetColorMode(Flg);
			this.CheckAWB.Enabled = this.CheckColor.Checked;
			this.CheckAwbLock.Enabled = this.CheckColor.Checked;
		}

		//! I[gzCgoX[h̐؂ւ
		private void checkBox2_CheckedChanged(object sender, System.EventArgs e)
		{
			m_CArtCam.Monitor_SetBayerGainAuto((true == this.CheckAWB.Checked) ? 1: 0);

			this.CheckAwbLock.Enabled = this.CheckAWB.Checked;

			int MonitorBayerGainRed = m_CArtCam.Monitor_GetBayerGainRed();
			this.numericUpDown1.Value = this.trackBar1.Value = MonitorBayerGainRed;

			int MonitorBayerGainGreen = m_CArtCam.Monitor_GetBayerGainGreen();
			this.numericUpDown2.Value = this.trackBar2.Value = MonitorBayerGainGreen;
			

			int MonitorBayerGainBlue = m_CArtCam.Monitor_GetBayerGainBlue();
			this.numericUpDown3.Value = this.trackBar3.Value =  MonitorBayerGainBlue;

			this.numericUpDown1.Enabled = !this.CheckAWB.Checked;
			this.numericUpDown2.Enabled = !this.CheckAWB.Checked;
			this.numericUpDown3.Enabled = !this.CheckAWB.Checked;
			this.trackBar1.Enabled = !this.CheckAWB.Checked;
			this.trackBar2.Enabled = !this.CheckAWB.Checked;
			this.trackBar3.Enabled = !this.CheckAWB.Checked;

		}

		//! I[gzCgoXŒݒ̐؂ւ
		private void checkBox3_CheckedChanged(object sender, System.EventArgs e)
		{
			m_CArtCam.Monitor_SetBayerGainLock((true == this.CheckAwbLock.Checked) ? 1: 0);
		}

		//! ~[]̐؂ւ
		private void checkBox4_CheckedChanged(object sender, System.EventArgs e)
		{
			m_CArtCam.SetMirrorV(this.CheckVflip.Checked);
		}

		//! ݂̐ݒۑ
		private void button3_Click(object sender, System.EventArgs e)
		{
			int ExposureTime = m_CArtCam.GetExposureTime();
			int GlobalGain	 = m_CArtCam.GetGlobalGain();
			
			//! WX^ݒL^鐔
			m_CArtCam.Fpga_WriteRegister(0xB6, 0x03);

			//! Exposure time
			m_CArtCam.Fpga_WriteRegister(0xC0, 0x09);
			m_CArtCam.Fpga_WriteRegister(0xC1, (int)(ExposureTime >> 8));
			m_CArtCam.Fpga_WriteRegister(0xC2, (int)ExposureTime);

			//! Gain
			m_CArtCam.Fpga_WriteRegister(0xC3, 0x35);
			m_CArtCam.Fpga_WriteRegister(0xC4, (int)(GlobalGain >> 8));
			m_CArtCam.Fpga_WriteRegister(0xC5, (int)GlobalGain);


			if(m_CArtCam.GetDllType() == ARTCAM_CAMERATYPE.ARTCAM_CAMERATYPE_130MI_MOUT)
			{
				//! c~[]
				int MirrorV		 = m_CArtCam.ReadRegister(0x20);
				m_CArtCam.Fpga_WriteRegister(0xC6, 0x20);
				m_CArtCam.Fpga_WriteRegister(0xC7, (int)MirrorV >> 8);
				m_CArtCam.Fpga_WriteRegister(0xC8, (int)MirrorV);
			}

			//!ۑ
			//!zCgoX̐ݒȂǂŕۑ܂B
			m_CArtCam.Monitor_SaveCurrentSettings();

		}


		//! ΏۃJ[\̐؂ւ
		private void radioButtonCursor1_CheckedChanged(object sender, System.EventArgs e)
		{
			if(radioButtonCursor1.Checked == true)
				m_CurrentCursorNum = 0;
			
			SetCursor();
		}
		private void radioButtonCursor2_CheckedChanged(object sender, System.EventArgs e)
		{
			if(radioButtonCursor2.Checked == true)
				m_CurrentCursorNum = 1;
			
			SetCursor();
		}

		//! J[\ON/OFF؂ւ
		private void checkBox5_CheckedChanged(object sender, System.EventArgs e)
		{
			if(this.CheckCursorEnable.Checked == true)
				m_CursorEnable[m_CurrentCursorNum] = 1;
			else
				m_CursorEnable[m_CurrentCursorNum] = 0;

			m_CArtCam.Monitor_SetCrossCursorMode(m_CurrentCursorNum, m_CursorEnable[m_CurrentCursorNum]);
		}

		//! J[\SXʒuύX
		private void trackBarCurPosX_Scroll(object sender, System.EventArgs e)
		{
			m_CursorPosX[m_CurrentCursorNum] = trackBarCurPosX.Value;
			numericUpDownCurPosX.Value = m_CursorPosX[m_CurrentCursorNum];
			m_CArtCam.Monitor_SetCrossCursorPos(m_CurrentCursorNum, m_CursorPosX[m_CurrentCursorNum], m_CursorPosY[m_CurrentCursorNum]);
		}
		private void numericUpDownCurPosX_ValueChanged(object sender, System.EventArgs e)
		{
			m_CursorPosX[m_CurrentCursorNum] = (int)numericUpDownCurPosX.Value;
			trackBarCurPosX.Value = m_CursorPosX[m_CurrentCursorNum];
			m_CArtCam.Monitor_SetCrossCursorPos(m_CurrentCursorNum, m_CursorPosX[m_CurrentCursorNum], m_CursorPosY[m_CurrentCursorNum]);
		}

		//! J[\SYʒuύX
		private void trackBarCurPosY_Scroll(object sender, System.EventArgs e)
		{
			m_CursorPosY[m_CurrentCursorNum] = trackBarCurPosY.Value;
			numericUpDownCurPosY.Value = m_CursorPosY[m_CurrentCursorNum];
			m_CArtCam.Monitor_SetCrossCursorPos(m_CurrentCursorNum, m_CursorPosX[m_CurrentCursorNum], m_CursorPosY[m_CurrentCursorNum]);		
		}
		private void numericUpDownCurPosY_ValueChanged(object sender, System.EventArgs e)
		{
			m_CursorPosY[m_CurrentCursorNum] = (int)numericUpDownCurPosY.Value;
			trackBarCurPosY.Value = m_CursorPosY[m_CurrentCursorNum];
			m_CArtCam.Monitor_SetCrossCursorPos(m_CurrentCursorNum, m_CursorPosX[m_CurrentCursorNum], m_CursorPosY[m_CurrentCursorNum]);
		}

		//! J[\XύX
		private void trackBarCurSizeX_Scroll(object sender, System.EventArgs e)
		{
			m_CursorSizeX[m_CurrentCursorNum] = trackBarCurSizeX.Value;
			numericUpDownCurSizeX.Value = m_CursorSizeX[m_CurrentCursorNum];
			m_CArtCam.Monitor_SetCrossCursorSize(m_CurrentCursorNum, m_CursorSizeX[m_CurrentCursorNum], m_CursorSizeY[m_CurrentCursorNum]);		
		}
		private void numericUpDownCurSizeX_ValueChanged(object sender, System.EventArgs e)
		{
			m_CursorSizeX[m_CurrentCursorNum] = (int)numericUpDownCurSizeX.Value;
			trackBarCurSizeX.Value= m_CursorSizeX[m_CurrentCursorNum];
			m_CArtCam.Monitor_SetCrossCursorSize(m_CurrentCursorNum, m_CursorSizeX[m_CurrentCursorNum], m_CursorSizeY[m_CurrentCursorNum]);		
		}

		//! J[\YύX
		private void trackBarCurSizeY_Scroll(object sender, System.EventArgs e)
		{
			m_CursorSizeY[m_CurrentCursorNum] = trackBarCurSizeY.Value;
			numericUpDownCurSizeY.Value = m_CursorSizeY[m_CurrentCursorNum];
			m_CArtCam.Monitor_SetCrossCursorSize(m_CurrentCursorNum, m_CursorSizeX[m_CurrentCursorNum], m_CursorSizeY[m_CurrentCursorNum]);				
		}
		private void numericUpDownCurSizeY_ValueChanged(object sender, System.EventArgs e)
		{
			m_CursorSizeY[m_CurrentCursorNum] = (int)numericUpDownCurSizeY.Value;
			trackBarCurSizeY.Value = m_CursorSizeY[m_CurrentCursorNum];
			m_CArtCam.Monitor_SetCrossCursorSize(m_CurrentCursorNum, m_CursorSizeX[m_CurrentCursorNum], m_CursorSizeY[m_CurrentCursorNum]);						
		}

		// Change color of cursor
		private void button4_Click(object sender, System.EventArgs e)
		{
			if(DialogResult.OK == colorDialog1.ShowDialog())
			{
				m_CursorColor[m_CurrentCursorNum] = this.colorDialog1.Color;
				this.ButtonCurosrColor.BackColor = this.colorDialog1.Color;
				m_CArtCam.Monitor_SetCrossCursorColorR(m_CurrentCursorNum, m_CursorColor[m_CurrentCursorNum].R);
				m_CArtCam.Monitor_SetCrossCursorColorG(m_CurrentCursorNum, m_CursorColor[m_CurrentCursorNum].G);
				m_CArtCam.Monitor_SetCrossCursorColorB(m_CurrentCursorNum, m_CursorColor[m_CurrentCursorNum].B);
			}
		}


		// Change auto iris mode
		private void checkBoxAiGain_CheckedChanged(object sender, System.EventArgs e)
		{
			SetAIMode();
		}
		private void checkBoxAiExposure_CheckedChanged(object sender, System.EventArgs e)
		{
			SetAIMode();
		}
		private void SetAIMode()
		{
			if(this.CheckAiGain.Checked == true)
			{
				if(this.CheckAiExposure.Checked == true)
				{
					m_CArtCam.Monitor_SetAutoIrisMode((int)AI_TYPE.AI_BOTH);
				}
				else
				{
					m_CArtCam.Monitor_SetAutoIrisMode((int)AI_TYPE.AI_GAIN);
				}
			}
			else
			{
				if(this.CheckAiExposure.Checked == true)
				{
					m_CArtCam.Monitor_SetAutoIrisMode((int)AI_TYPE.AI_EXPOSURE);
				}
				else
				{
					m_CArtCam.Monitor_SetAutoIrisMode((int)AI_TYPE.AI_NONE);
				}
			}
		}


		//! I[gACX̖ڕWlݒ肷
		private void numericUpDownAiMin_ValueChanged(object sender, System.EventArgs e)
		{
			m_AIMin = (int)numericUpDownAiMin.Value;
			m_CArtCam.Monitor_SetAutoIrisRange(m_AIMin, m_AIMax);
		}

		//! I[gACX̖ڕWlݒ肷
		private void numericUpDownAiMax_ValueChanged(object sender, System.EventArgs e)
		{
			m_AIMin = (int)numericUpDownAiMax.Value;
			m_CArtCam.Monitor_SetAutoIrisRange(m_AIMin, m_AIMax);		
		}
	
	}
}
