unit ArtCam;

interface

uses
  Windows;

type
  HACAM  = DWORD;
  LONG   = longint;
  LPBYTE = ^Byte;
  LPLONG = ^LONG;
  LPBOOL = ^BOOL;

  DeviceNameList = array[0..9, 0..255] of AnsiChar;


    DLL_MESSAGE = (
        WM_GRAPHNOTIFY = $8001,     // {o[Wł͎gp܂
        WM_GRAPHPAINT,              // fXVꂽɃAvP[Vɑ܂
        WM_ERROR                    // G[ɃAvP[Vɑ܂
    );

    // J^Cv
    ARTCAM_CAMERATYPE = (
        // USB2V[Y
        ARTCAM_CAMERATYPE_DS = 1,           // DirectShow Camera
        ARTCAM_CAMERATYPE_DISABLE1,         // 
        ARTCAM_CAMERATYPE_USTC,             // ARTUST
        ARTCAM_CAMERATYPE_CNV,              // ARTCNV
        ARTCAM_CAMERATYPE_DISABLE2,         // 
        ARTCAM_CAMERATYPE_130MI,            // ARTCAM-130MI
        ARTCAM_CAMERATYPE_DISABLE3,         // 
        ARTCAM_CAMERATYPE_200MI,            // ARTCAM-200MI
        ARTCAM_CAMERATYPE_300MI,            // ARTCAM-300MI
        ARTCAM_CAMERATYPE_150P,             // ARTCAM-150P
        ARTCAM_CAMERATYPE_320P,             // ARTCAM-320P
        ARTCAM_CAMERATYPE_DISABLE4,         // 
        ARTCAM_CAMERATYPE_200SH,            // ARTCAM-200SH
        ARTCAM_CAMERATYPE_098,              // ARTCAM-098
        ARTCAM_CAMERATYPE_036MI,            // ARTCAM-036MI
        ARTCAM_CAMERATYPE_500P,             // ARTCAM-500P
        ARTCAM_CAMERATYPE_150P2,            // ARTCAM-150PU
        ARTCAM_CAMERATYPE_036MIST,          // ARTCAM-036MIST
        ARTCAM_CAMERATYPE_500MI,            // ARTCAM-500MI
        ARTCAM_CAMERATYPE_T111,             // ARTCAM-T111
        ARTCAM_CAMERATYPE_T112,             // ARTCAM-T112
        ARTCAM_CAMERATYPE_150P3,            // ARTCAM-150PV
        ARTCAM_CAMERATYPE_130MI_MOUT,       // ARTCAM-130MI MOUT
		    ARTCAM_CAMERATYPE_150P3_MOUT,		    // ARTCAM-150PV MOUT
		    ARTCAM_CAMERATYPE_267KY,				    // ARTCAM-267KY
		    ARTCAM_CAMERATYPE_274KY,				    // ARTCAM-274KY
		    ARTCAM_CAMERATYPE_625KY,				    // ARTCAM-274KY
		    ARTCAM_CAMERATYPE_V135MI,			      // ARTCAM-V135MI
		    ARTCAM_CAMERATYPE_445KY,				    // ARTCAM-445KY
		    ARTCAM_CAMERATYPE_098II,				    // ARTCAM-098II
		    ARTCAM_CAMERATYPE_MV413,				    // ARTCAM-MV413USB
		    ARTCAM_CAMERATYPE_OV210,				    // ARTCAM-OV210
		    ARTCAM_CAMERATYPE_850SH,				    // ARTCAM-850SH
		    ARTCAM_CAMERATYPE_1251SH,			      // ARTCAM-1252SH
		    ARTCAM_CAMERATYPE_D131,				      // ARTCAM-D131
		    ARTCAM_CAMERATYPE_900MI,				    // ARTCAM-900MI
		    ARTCAM_CAMERATYPE_1000MI,			      // ARTCAM-1000MI
		    ARTCAM_CAMERATYPE_500P2,				    // ARTCAM-500P2

        // SATA V[Y
        ARTCAM_CAMERATYPE_SATA = 201        // SATA CAMERA
    );

    // SATA J^Cv
    ARTCAM_CAMERATYPE_SATA1 = (
        ARTCAM_CAMERATYPE_SATA_LVDS = 0,    // 
        ARTCAM_CAMERATYPE_SATA_300MI,       // 
        ARTCAM_CAMERATYPE_SATA_500MI,       // 
        ARTCAM_CAMERATYPE_SATA_MV413,       // 
        ARTCAM_CAMERATYPE_SATA_800MI,       // 
        ARTCAM_CAMERATYPE_SATA_036MI,       // 
        ARTCAM_CAMERATYPE_SATA_150P,        // 
		    ARTCAM_CAMERATYPE_SATA_267KY,		//
		    ARTCAM_CAMERATYPE_SATA_274KY,		//
		    ARTCAM_CAMERATYPE_SATA_625KY,		//
		    ARTCAM_CAMERATYPE_SATA_130MI,		//
		    ARTCAM_CAMERATYPE_SATA_200MI		//
    );

    // G[R[h
    ARTCAMSDK_ERROR = (
        ARTCAMSDK_NOERROR = 0,      // 
        ARTCAMSDK_NOT_INITIALIZE,   // Ă܂
        ARTCAMSDK_DISABLEDDEVICE,   // ps\ȃfoCXɃANZX悤Ƃ܂
        ARTCAMSDK_CREATETHREAD,     // 摜荞ݗpXbh쐬Ɏs
        ARTCAMSDK_CREATEWINDOW,     // EBhE쐬Ɏs
        ARTCAMSDK_OUTOFMEMORY,      // C[W]ɏ\ȃmۂĂȂ@́@̊mۂɎs
        ARTCAMSDK_CAMERASET,        // JifoCXj̐ݒŃG[
        ARTCAMSDK_CAMERASIZE,       // JifoCXj̃TCYݒŃG[
        ARTCAMSDK_CAPTURE,          // f荞݂Ŏs
        ARTCAMSDK_PARAM,            // ԈĂ܂
        ARTCAMSDK_DIRECTSHOW,       // DirectShow G[
        ARTCAMSDK_UNSUPPORTED,      // ̋@\̓T|[gĂ܂
        ARTCAMSDK_UNKNOWN,          // s̃G[
        ARTCAMSDK_CAPTURELOST,      // foCX
        ARTCAMSDK_FILENOTFOUND,     // wt@CȂ
        ARTCAMSDK_FPGASET,          // FPGA̐ݒŃG[
		    ARTCAMSDK_TRANSIMAGEFAILED	// 摜]Ɏs
    );

    // ]
    GP_INFO = record
      lSize:      LONG;             // \̂̃TCY sizeof(GP_INFO)
      lWidth:     LONG;             // 摜̕
      lHeight:    LONG;             // 摜̍
      lBpp:       LONG;             // 摜̃rbgkx
      lFps:       LONG;             // t[[giۂ10{̒lj
      pImage:     LPBYTE;           // CallBackPreviewŎw肵摜̃|C^
    end;

    // J̏
    CAMERAINFO = record
      lSize:            LONG;       // \̂̃TCY
      lWidth:           LONG;       // J̗Lő啝
      lHeight:          LONG;       // J̗Lő卂
      lGlobalGainMin:   LONG;       // O[oQC̍Œligps\̃J́|Pj
      lGlobalGainMax:   LONG;       // O[oQC̍Œligps\̃J́|Pj
      lColorGainMin:    LONG;       // J[QC̍Œligps\̃J́|Pj
      lColorGainMax:    LONG;       // J[QC̍Œligps\̃J́|Pj
      lExposureMin:     LONG;       // IԂ̍Œligps\̃J́|Pj
      lExposureMax:     LONG;       // IԂ̍Œligps\̃J́|Pj
    end;

    LPCAMERAINFO = ^CAMERAINFO;

    // 摜tB^[̎
    ARTCAM_FILTERTYPE = (
        ARTCAM_FILTERTYPE_RESERVE = 0,          // \񂳂Ă܂
        ARTCAM_FILTERTYPE_BRIGHTNESS,           // 邳
        ARTCAM_FILTERTYPE_CONTRAST,             // RgXg
        ARTCAM_FILTERTYPE_HUE,                  // F
        ARTCAM_FILTERTYPE_SATURATION,           // ʓx
        ARTCAM_FILTERTYPE_SHARPNESS,            // N
        ARTCAM_FILTERTYPE_BAYER_GAIN_RGB,       // xC[ϊ̃J[QC
        ARTCAM_FILTERTYPE_BAYER_GAIN_R,         // xC[ϊ̃J[QCiԂ̂݁j
        ARTCAM_FILTERTYPE_BAYER_GAIN_G,         // xC[ϊ̃J[QCi΂̂݁j
        ARTCAM_FILTERTYPE_BAYER_GAIN_B,         // xC[ϊ̃J[QCi̂݁j
        ARTCAM_FILTERTYPE_BAYER_GAIN_AUTO,      // zCgoX
        ARTCAM_FILTERTYPE_GAMMA,                // K}
        ARTCAM_FILTERTYPE_BAYERMODE,            // xC[ϊ[h
        ARTCAM_FILTERTYPE_GLOBAL_GAIN,          // J̃O[oQC
        ARTCAM_FILTERTYPE_COLOR_GAIN_R,         // J̃J[QCiԁj
        ARTCAM_FILTERTYPE_COLOR_GAIN_G1,        // J̃J[QCi΂Pj
        ARTCAM_FILTERTYPE_COLOR_GAIN_G2,        // J̃J[QCi΂Qj
        ARTCAM_FILTERTYPE_COLOR_GAIN_B,         // J̃J[QCij
        ARTCAM_FILTERTYPE_EXPOSURETIME,         // IԁiVb^[Xs[hj
        ARTCAM_FILTERTYPE_GRAY_MODE,            // O[XP[@[h
        ARTCAM_FILTERTYPE_GRAY_GAIN_R,          // O[XP[@QCiԁj
        ARTCAM_FILTERTYPE_GRAY_GAIN_G1,         // O[XP[@QCi΂Pj
        ARTCAM_FILTERTYPE_GRAY_GAIN_G2,         // O[XP[@QCi΂Qj
        ARTCAM_FILTERTYPE_GRAY_GAIN_B,          // O[XP[@QCij
        ARTCAM_FILTERTYPE_GRAY_OFFSET_R,        // O[XP[@ItZbgiԁj
        ARTCAM_FILTERTYPE_GRAY_OFFSET_G1,       // O[XP[@ItZbgi΂Pj
        ARTCAM_FILTERTYPE_GRAY_OFFSET_G2,       // O[XP[@ItZbgi΂Qj
        ARTCAM_FILTERTYPE_GRAY_OFFSET_B         // O[XP[@ItZbgij
    );

    // Ԉ][h
    SUBSAMPLE = (
        SUBSAMPLE_1 = 0,    // tTCY
        SUBSAMPLE_2,        // P^Q
        SUBSAMPLE_4,        // P^S
        SUBSAMPLE_8,         // P^W
        BINNING_2   = 16,
		    BINNING_4	= 17
    );

    // I[gACX[h
    AI_TYPE = (
        AI_NONE = 0,        // 
        AI_EXPOSURE,        // Io
        AI_GAIN,            // QC
        AI_BOTH			        // I + QC
    );

    // O[XP[[h
    GRAY_TYPE = (
        GRAY_NONE = 0,      // @xC[ẑ܂
        GRAY_BAYERCONVERT,  // xC[z GRAY GAIN  GRAY OFFSET ŉZ
        GRAY_GRAYSCALE      // J[ϊAPx݂̂ɂ
    );

    // rfItH[}bg
    VIDEOFORMAT = (
        VIDEOFORMAT_NTSC = 0,   // NTSC
        VIDEOFORMAT_PAL,        // PAL
        VIDEOFORMAT_PALM,       // PALM
        VIDEOFORMAT_SECAM       // SECAM
    );

    // TvO[g
    SAMPLING_RATE = (
        WIDE_HISPEED = 0,   // 
        WIDE_LOWSPEED,      // 
        NORMAL_HISPEED,     // 
        NORMAL_LOWSPEED     //
    );


    // 摜ۑ`
    FILETYPE = (
        FILETYPE_BITMAP = 0,    // rbg}bvŕۑ܂BTCY
        FILETYPE_RAW,           // f[^݂̂ۑ܂BTCY
        FILETYPE_JPEG_HIGH,     // iJPEGŕۑ܂B⃉C͕܂BTCY
        FILETYPE_JPEG_NOMAL,    // WiJPEGŕۑ܂Bׂp^[͕܂BTCY
        FILETYPE_JPEG_LOW,      // iJPEGŕۑ܂BubNmCYڗ܂BTCY
        FILETYPE_PNG,           // PNGŕۑ܂B16rbg摜mɕۑł܂BTCY
        FILETYPE_TIFF           // TIFFŕۑ܂B16rbg摜mɕۑł܂BTCY
    );


  AC_GetDllVersion      = function : DWORD; cdecl;
  AC_GetLastError       = function (hACam: HACAM): LONG; cdecl;

  AC_Initialize         = function (hWnd: HWND): HACAM; cdecl;
  AC_Release            = function (hACam: HACAM): BOOL; cdecl;

  AC_Preview            = function (hACam: HACAM): BOOL; cdecl;
  AC_Record             = function (hACam: HACAM; lpAviName: LPCTSTR; RecTime: UINT; fShow: BOOL): BOOL; cdecl;
  AC_CallBackPreview    = function (hACam: HACAM; hWnd: HWND; lpImage: LPBYTE; Size: LONG; TopDown: BOOL): BOOL; cdecl;
  AC_Close              = function (hACam: HACAM): BOOL; cdecl;

  // 1230
  AC_SnapShot           = function (hACam: HACAM; lpImage: LPBYTE; Size: LONG; TopDown: BOOL): BOOL; cdecl;

  // 1250
  AC_Capture            = function (hACam: HACAM): BOOL; cdecl;

  // 1260
  AC_Trigger            = function (hACam: HACAM; hWnd: HWND; lpImage: LPBYTE; Size: LONG; TopDown: BOOL): BOOL; cdecl;
  AC_SaveImage          = function (hACam: HACAM; lpSaveName: LPCTSTR; FileType: LONG): BOOL; cdecl;


  AC_SetPreviewWindow   = function (hACam: HACAM; hWnd: HWND; Left: LONG; Top: LONG; Right: LONG; Bottom: LONG): BOOL; cdecl;
  AC_SetCaptureWindow   = function (hACam: HACAM; Width: LONG; Height: LONG; Fps: LONG): BOOL; cdecl;
  AC_SetCaptureWindowEx = function (hACam: HACAM; HTotal: LONG; HStart: LONG; HEffective: LONG; VTotal: LONG; VStart: LONG; VEffective: LONG): BOOL; cdecl;
  AC_GetCaptureWindowEx = function (hACam: HACAM; HTotal: LPLONG; HStart: LPLONG; HEffective: LPLONG; VTotal: LPLONG; VStart: LPLONG; VEffective: LPLONG): BOOL; cdecl;

  AC_SetColorMode       = function (hACam: HACAM; ColorMode: LONG): BOOL; cdecl;
  AC_GetColorMode       = function (hACam: HACAM): LONG; cdecl;

  AC_SetCrossbar        = function (hACam: HACAM; Output: LONG; Input: LONG): BOOL; cdecl;
  AC_SetDeviceNumber    = function (hACam: HACAM; Number: LONG): BOOL; cdecl;
  AC_EnumDevice         = function (hACam: HACAM; szDeviceName: DeviceNameList): LONG; cdecl;
  AC_GetDeviceName      = function (hACam: HACAM; index: LONG; szDeviceName: LPSTR; nSize: LONG): BOOL; cdecl;

  AC_StartPreview       = function (hACam: HACAM): BOOL; cdecl;
  AC_StopPreview        = function (hACam: HACAM): BOOL; cdecl;
  AC_GetImage           = function (hACam: HACAM; lpImage: LPBYTE; Size: LONG; TopDown: BOOL): BOOL; cdecl;

  AC_Width              = function (hACam: HACAM): LONG; cdecl;
  AC_Height             = function (hACam: HACAM): LONG; cdecl;
  AC_Fps                = function (hACam: HACAM): LONG; cdecl;

  AC_SetCameraDlg       = function (hACam: HACAM; hWnd: HWND): BOOL; cdecl;
  AC_SetImageDlg        = function (hACam: HACAM; hWnd: HWND): BOOL; cdecl;
  AC_SetAnalogDlg       = function (hACam: HACAM; hWnd: HWND): BOOL; cdecl;

  // 1230
  AC_SetIOPort          = function (hACam: HACAM; byteData: BYTE; longData: LONG; Reserve: DWORD): BOOL; cdecl;
  AC_GetIOPort          = function (hACam: HACAM; byteData: LPBYTE; longData: LPLONG; Reserve: DWORD): BOOL; cdecl;
  AC_SetFilterValue     = function (hACam: HACAM; FilterType: LONG; Value: LONG): BOOL; cdecl;
  AC_GetFilterValue     = function (hACam: HACAM; FilterType: LONG; Error: LPBOOL): LONG; cdecl;
  AC_SetSubSample       = function (hACam: HACAM; SubSampleMode: LONG): BOOL; cdecl;
  AC_GetSubSample       = function (hACam: HACAM): LONG; cdecl;
  AC_SetWaitTime        = function (hACam: HACAM; WaitTime: LONG): BOOL; cdecl;
  AC_GetWaitTime        = function (hACam: HACAM): LONG; cdecl;

  // 1240
  AC_SetMirrorV         = function (hACam: HACAM; Flg: BOOL): BOOL; cdecl;
  AC_GetMirrorV         = function (hACam: HACAM): BOOL; cdecl;
  AC_SetMirrorH         = function (hACam: HACAM; Flg: BOOL): BOOL; cdecl;
  AC_GetMirrorH         = function (hACam: HACAM): BOOL; cdecl;

  AC_SetBrightness      = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetBrightness      = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetContrast        = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetContrast        = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetHue             = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetHue             = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetSaturation      = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetSaturation      = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetSharpness       = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetSharpness       = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetBayerGainRGB    = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetBayerGainRGB    = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetBayerGainRed    = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetBayerGainRed    = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetBayerGainGreen  = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetBayerGainGreen  = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetBayerGainBlue   = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetBayerGainBlue   = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetBayerGainAuto   = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetBayerGainAuto   = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetGamma           = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetGamma           = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetBayerMode       = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetBayerMode       = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetGlobalGain      = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetGlobalGain      = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetColorGainRed    = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetColorGainRed    = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetColorGainGreen1 = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetColorGainGreen1 = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetColorGainGreen2 = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetColorGainGreen2 = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetColorGainBlue   = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetColorGainBlue   = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetExposureTime    = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetExposureTime    = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;

  // 1260
  AC_SetHalfClock       = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetHalfClock       = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetAutoIris        = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetAutoIris        = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;

  // 1275
  AC_SetSamplingRate    = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetSamplingRate    = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_GetVideoFormat     = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;

  // 1276
  AC_WriteSromID        = function (hACam: HACAM; Address: LONG; Value: LONG): BOOL; cdecl;
  AC_ReadSromID         = function (hACam: HACAM; Address: LONG; Error: LPBOOL): LONG; cdecl;

  // 1280
  AC_GetCameraInfo      = function (hACam: HACAM; pInfo: LPCAMERAINFO): BOOL; cdecl;
  AC_GetStatus          = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;

  AC_WriteRegister      = function (hACam: HACAM; Address: BYTE; Value: DWORD): BOOL; cdecl;
  AC_ReadRegister       = function (hACam: HACAM; Address: BYTE; Error: LPBOOL): DWORD; cdecl;
  AC_WriteRegisterEx    = function (hACam: HACAM; Address: DWORD; Value: DWORD): BOOL; cdecl;
  AC_ReadRegisterEx     = function (hACam: HACAM; Address: DWORD; Error: LPBOOL): DWORD; cdecl;
  AC_SetCrcCheckMode    = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetCrcCheckMode    = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetLChannelValue   = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetLChannelValue   = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetChannelProfileMode =  function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetChannelProfile  = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;

  AC_SetGrayMode        = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetGrayMode        = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetGrayGainR       = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetGrayGainR       = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetGrayGainG1      = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetGrayGainG1      = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetGrayGainG2      = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetGrayGainG2      = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetGrayGainB       = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetGrayGainB       = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetGrayOffsetR     = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetGrayOffsetR     = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetGrayOffsetG1    = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetGrayOffsetG1    = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetGrayOffsetG2    = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetGrayOffsetG2    = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetGrayOffsetB     = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_GetGrayOffsetB     = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;

  // SATA
  AC_SetCameraType      = function (hACam: HACAM; Flg: LONG): BOOL; cdecl;
  AC_GetCameraType      = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetSyncV           = function (hACam: HACAM; Flg: LONG): BOOL; cdecl;
  AC_GetSyncV           = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_SetSyncH           = function (hACam: HACAM; Flg: LONG): BOOL; cdecl;
  AC_GetSyncH           = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;

  // MOUT
  AC_Fpga_WriteRegister = function (hACam: HACAM; Address: BYTE; Value: DWORD): BOOL; cdecl;
  AC_Fpga_ReadRegister  = function (hACam: HACAM; Address: BYTE; Error: LPBOOL): DWORD; cdecl;

  AC_Monitor_SetPreviewMode     = function (hACam: HACAM; Preview: BOOL): BOOL; cdecl;
  AC_Monitor_GetPreviewMode     = function (hACam: HACAM; Error: LPBOOL): BOOL; cdecl;
  AC_Monitor_SetPreviewSize     = function (hACam: HACAM; Width: LONG; Height: LONG): BOOL; cdecl;
  AC_Monitor_GetPreviewSize     = function (hACam: HACAM; LPWidth: LPLONG; LPHeight: LPLONG): BOOL; cdecl;
  AC_Monitor_SetColorMode       = function (hACam: HACAM; ColorMode: BOOL): BOOL; cdecl;
  AC_Monitor_GetColorMode       = function (hACam: HACAM; Error: LPBOOL): BOOL; cdecl;
  AC_Monitor_SetCameraClock     = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_Monitor_GetCameraClock     = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_Monitor_SetBayerGainAuto   = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_Monitor_GetBayerGainAuto   = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_Monitor_SetBayerGainLock	  = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
	AC_Monitor_GetBayerGainLock   = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_Monitor_SetBayerGainRed    = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_Monitor_GetBayerGainRed    = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_Monitor_SetBayerGainGreen  = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_Monitor_GetBayerGainGreen  = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
  AC_Monitor_SetBayerGainBlue   = function (hACam: HACAM; Value: LONG): BOOL; cdecl;
  AC_Monitor_GetBayerGainBlue   = function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;

  AC_Monitor_SaveCurrentSettings  = function 	(hACam: HACAM): BOOL; cdecl;
  AC_Monitor_InitRegisterSettings = function 	(hACam: HACAM; Flg: LONG): BOOL; cdecl;

	AC_Monitor_SetCrossCursorMode =   function (hACam: HACAM; CursorNum: LONG; Value: LONG): BOOL; cdecl;
	AC_Monitor_GetCrossCursorMode =   function (hACam: HACAM; CursorNum: LONG; Error: LPBOOL): LONG; cdecl;
	AC_Monitor_SetCrossCursorColorR = function (hACam: HACAM; CursorNum: LONG; Value: LONG): BOOL; cdecl;
	AC_Monitor_GetCrossCursorColorR = function (hACam: HACAM; CursorNum: LONG; Error: LPBOOL): LONG; cdecl;
	AC_Monitor_SetCrossCursorColorG = function (hACam: HACAM; CursorNum: LONG; Value: LONG): BOOL; cdecl;
	AC_Monitor_GetCrossCursorColorG = function (hACam: HACAM; CursorNum: LONG; Error: LPBOOL): LONG; cdecl;
	AC_Monitor_SetCrossCursorColorB = function (hACam: HACAM; CursorNum: LONG; Value: LONG): BOOL; cdecl;
	AC_Monitor_GetCrossCursorColorB = function 	(hACam: HACAM; CursorNum: LONG; Error: LPBOOL): LONG; cdecl;
	AC_Monitor_SetCrossCursorColorRGB = function (hACam: HACAM; CursorNum: LONG; Value: LONG): BOOL; cdecl;
	AC_Monitor_GetCrossCursorColorRGB = function (hACam: HACAM; CursorNum: LONG; Error: LPBOOL): LONG; cdecl;
	AC_Monitor_SetCrossCursorPos  =   function (hACam: HACAM; CursorNum: LONG; ValueX: LONG; ValueY: LONG): BOOL; cdecl;
	AC_Monitor_GetCrossCursorPos  =   function (hACam: HACAM; CursorNum: LONG; ValueX: LPLONG; ValueY: LPLONG): BOOL; cdecl;
	AC_Monitor_SetCrossCursorSize =   function (hACam: HACAM; CursorNum: LONG; ValueX: LONG; ValueY: LONG): BOOL; cdecl;
	AC_Monitor_GetCrossCursorSize =   function (hACam: HACAM; CursorNum: LONG; ValueX: LPLONG; ValueY: LPLONG): BOOL; cdecl;

	AC_Monitor_SetAutoIrisMode  =     function (hACam: HACAM; Value: LONG): BOOL; cdecl;
	AC_Monitor_GetAutoIrisMode  =     function (hACam: HACAM; Error: LPBOOL): LONG; cdecl;
	AC_Monitor_SetAutoIrisRange =     function (hACam: HACAM; Min: LONG; Max: LONG): BOOL; cdecl;
	AC_Monitor_GetAutoIrisRange =     function (hACam: HACAM; Min: LPLONG; Max: LPLONG): BOOL; cdecl;
	AC_Monitor_LoadFirmware     =     function (hACam: HACAM; szFileName: LPCTSTR): BOOL; cdecl;

	AC_Monitor_GetRealExposureTime      =     function (hACam: HACAM):LONG; cdecl;


  TArtCam = class

  protected
    FDLLHandle: THandle;	// ckk̃CX^Xnh
    SdkHandle:  HACAM;		// J̃nh

    F_GetDllVersion:        AC_GetDllVersion;
    F_GetLastError:         AC_GetLastError;

    F_Initialize:           AC_Initialize;
    F_Release:              AC_Release;

    F_Preview:              AC_Preview;
    F_Record:               AC_Record;
    F_CallBackPreview:      AC_CallBackPreview;
    F_Close:                AC_Close;

    //1230
    F_SnapShot:             AC_SnapShot;

    //1250
    F_Capture:              AC_Capture;

    //1260
    F_Trigger:              AC_Trigger;
    F_SaveImage:            AC_SaveImage;


    F_SetPreviewWindow:     AC_SetPreviewWindow;
    F_SetCaptureWindow:     AC_SetCaptureWindow;
    F_SetCaptureWindowEx:   AC_SetCaptureWindowEx;
    F_GetCaptureWindowEx:   AC_GetCaptureWindowEx;

    F_SetColorMode:         AC_SetColorMode;
    F_GetColorMode:         AC_GetColorMode;

    F_SetCrossbar:          AC_SetCrossbar;
    F_SetDeviceNumber:      AC_SetDeviceNumber;
    F_EnumDevice:           AC_EnumDevice;
    F_GetDeviceName:        AC_GetDeviceName;

    F_StartPreview:         AC_StartPreview;
    F_StopPreview:          AC_StopPreview;
    F_GetImage:             AC_GetImage;

    F_Width:                AC_Width;
    F_Height:               AC_Height;
    F_Fps:                  AC_Fps;

    F_SetCameraDlg:         AC_SetCameraDlg;
    F_SetImageDlg:          AC_SetImageDlg;
    F_SetAnalogDlg:         AC_SetAnalogDlg;

    //1230
    F_SetIOPort:            AC_SetIOPort;
    F_GetIOPort:            AC_GetIOPort;
    F_SetFilterValue:       AC_SetFilterValue;
    F_GetFilterValue:       AC_GetFilterValue;
    F_SetSubSample:         AC_SetSubSample;
    F_GetSubSample:         AC_GetSubSample;
    F_SetWaitTime:          AC_SetWaitTime;
    F_GetWaitTime:          AC_GetWaitTime;

    //1240
    F_SetMirrorV:           AC_SetMirrorV;
    F_GetMirrorV:           AC_GetMirrorV;
    F_SetMirrorH:           AC_SetMirrorH;
    F_GetMirrorH:           AC_GetMirrorH;
    F_SetBrightness:        AC_SetBrightness;
    F_GetBrightness:        AC_GetBrightness;

    F_SetContrast:          AC_SetContrast;
    F_GetContrast:          AC_GetContrast;
    F_SetHue:               AC_SetHue;
    F_GetHue:               AC_GetHue;
    F_SetSaturation:        AC_SetSaturation;
    F_GetSaturation:        AC_GetSaturation;
    F_SetSharpness:         AC_SetSharpness;
    F_GetSharpness:         AC_GetSharpness;
    F_SetBayerGainRGB:      AC_SetBayerGainRGB;
    F_GetBayerGainRGB:      AC_GetBayerGainRGB;
    F_SetBayerGainRed:      AC_SetBayerGainRed;
    F_GetBayerGainRed:      AC_GetBayerGainRed;
    F_SetBayerGainGreen:    AC_SetBayerGainGreen;
    F_GetBayerGainGreen:    AC_GetBayerGainGreen;
    F_SetBayerGainBlue:     AC_SetBayerGainBlue;
    F_GetBayerGainBlue:     AC_GetBayerGainBlue;
    F_SetBayerGainAuto:     AC_SetBayerGainAuto;
    F_GetBayerGainAuto:     AC_GetBayerGainAuto;
    F_SetGamma:             AC_SetGamma;
    F_GetGamma:             AC_GetGamma;
    F_SetBayerMode:         AC_SetBayerMode;
    F_GetBayerMode:         AC_GetBayerMode;
    F_SetGlobalGain:        AC_SetGlobalGain;
    F_GetGlobalGain:        AC_GetGlobalGain;
    F_SetColorGainRed:      AC_SetColorGainRed;
    F_GetColorGainRed:      AC_GetColorGainRed;
    F_SetColorGainGreen1:   AC_SetColorGainGreen1;
    F_GetColorGainGreen1:   AC_GetColorGainGreen1;
    F_SetColorGainGreen2:   AC_SetColorGainGreen2;
    F_GetColorGainGreen2:   AC_GetColorGainGreen2;
    F_SetColorGainBlue:     AC_SetColorGainBlue;
    F_GetColorGainBlue:     AC_GetColorGainBlue;
    F_SetExposureTime:      AC_SetExposureTime;
    F_GetExposureTime:      AC_GetExposureTime;

    //1260
    F_SetHalfClock:         AC_SetHalfClock;
    F_GetHalfClock:         AC_GetHalfClock;
    F_SetAutoIris:          AC_SetAutoIris;
    F_GetAutoIris:          AC_GetAutoIris;

    //1275
    F_SetSamplingRate:      AC_SetSamplingRate;
    F_GetSamplingRate:      AC_GetSamplingRate;
    F_GetVideoFormat:       AC_GetVideoFormat;

    // 1276
    F_WriteSromID:          AC_WriteSromID;
    F_ReadSromID:           AC_ReadSromID;

    // 1280
    F_GetCameraInfo:        AC_GetCameraInfo;
    F_GetStatus:            AC_GetStatus;

    F_WriteRegister:        AC_WriteRegister;
    F_ReadRegister:         AC_ReadRegister;
    
    F_WriteRegisterEx:      AC_WriteRegisterEx;
    F_ReadRegisterEx:       AC_ReadRegisterEx;
    
   	F_SetCrcCheckMode:		AC_SetCrcCheckMode;
	  F_GetCrcCheckMode:		AC_GetCrcCheckMode;

   	F_SetLChannelValue:		AC_SetLChannelValue;
	  F_GetLChannelValue:		AC_GetLChannelValue;
	  F_SetChannelProfileMode:	AC_SetChannelProfileMode;
	  F_GetChannelProfile:	AC_GetChannelProfile;
	
    F_SetGrayMode:          AC_SetGrayMode;
    F_GetGrayMode:          AC_GetGrayMode;
    F_SetGrayGainR:         AC_SetGrayGainR;
    F_GetGrayGainR:         AC_GetGrayGainR;
    F_SetGrayGainG1:        AC_SetGrayGainG1;
    F_GetGrayGainG1:        AC_GetGrayGainG1;
    F_SetGrayGainG2:        AC_SetGrayGainG2;
    F_GetGrayGainG2:        AC_GetGrayGainG2;
    F_SetGrayGainB:         AC_SetGrayGainB;
    F_GetGrayGainB:         AC_GetGrayGainB;
    F_SetGrayOffsetR:       AC_SetGrayOffsetR;
    F_GetGrayOffsetR:       AC_GetGrayOffsetR;
    F_SetGrayOffsetG1:      AC_SetGrayOffsetG1;
    F_GetGrayOffsetG1:      AC_GetGrayOffsetG1;
    F_SetGrayOffsetG2:      AC_SetGrayOffsetG2;
    F_GetGrayOffsetG2:      AC_GetGrayOffsetG2;
    F_SetGrayOffsetB:       AC_SetGrayOffsetB;
    F_GetGrayOffsetB:       AC_GetGrayOffsetB;

    // SATA
    F_SetCameraType:        AC_SetCameraType;
    F_GetCameraType:        AC_GetCameraType;
    
	F_SetSyncV:				AC_SetSyncV;
	F_GetSyncV:				AC_GetSyncV;
	F_SetSyncH:				AC_SetSyncH;
	F_GetSyncH:				AC_GetSyncH;

    // MOUT
    F_Fpga_WriteRegister:   AC_Fpga_WriteRegister;
    F_Fpga_ReadRegister:    AC_Fpga_ReadRegister;

    F_Monitor_SetPreviewMode:       AC_Monitor_SetPreviewMode;
    F_Monitor_GetPreviewMode:       AC_Monitor_GetPreviewMode;
    F_Monitor_SetPreviewSize:       AC_Monitor_SetPreviewSize;
    F_Monitor_GetPreviewSize:       AC_Monitor_GetPreviewSize;
    F_Monitor_SetColorMode:         AC_Monitor_SetColorMode;
    F_Monitor_GetColorMode:         AC_Monitor_GetColorMode;
    F_Monitor_SetCameraClock:       AC_Monitor_SetCameraClock;
    F_Monitor_GetCameraClock:       AC_Monitor_GetCameraClock;
    F_Monitor_SetBayerGainAuto:     AC_Monitor_SetBayerGainAuto;
    F_Monitor_GetBayerGainAuto:     AC_Monitor_GetBayerGainAuto;
    F_Monitor_SetBayerGainLock:		AC_Monitor_SetBayerGainLock;
    F_Monitor_GetBayerGainLock:		AC_Monitor_GetBayerGainLock;
    F_Monitor_SetBayerGainRed:      AC_Monitor_SetBayerGainRed;
    F_Monitor_GetBayerGainRed:      AC_Monitor_GetBayerGainRed;
    F_Monitor_SetBayerGainGreen:    AC_Monitor_SetBayerGainGreen;
    F_Monitor_GetBayerGainGreen:    AC_Monitor_GetBayerGainGreen;
    F_Monitor_SetBayerGainBlue:     AC_Monitor_SetBayerGainBlue;
    F_Monitor_GetBayerGainBlue:     AC_Monitor_GetBayerGainBlue;

    F_Monitor_SaveCurrentSettings:  AC_Monitor_SaveCurrentSettings;
    F_Monitor_InitRegisterSettings: AC_Monitor_InitRegisterSettings;
    
    F_Monitor_SetCrossCursorMode:   AC_Monitor_SetCrossCursorMode;
    F_Monitor_GetCrossCursorMode:   AC_Monitor_GetCrossCursorMode;
    F_Monitor_SetCrossCursorColorR:	AC_Monitor_SetCrossCursorColorR;
    F_Monitor_GetCrossCursorColorR:	AC_Monitor_GetCrossCursorColorR;
    F_Monitor_SetCrossCursorColorG:	AC_Monitor_SetCrossCursorColorG;
    F_Monitor_GetCrossCursorColorG:	AC_Monitor_GetCrossCursorColorG;
    F_Monitor_SetCrossCursorColorB:	AC_Monitor_SetCrossCursorColorB;
    F_Monitor_GetCrossCursorColorB:	AC_Monitor_GetCrossCursorColorB;
    F_Monitor_SetCrossCursorColorRGB:	AC_Monitor_SetCrossCursorColorRGB;
    F_Monitor_GetCrossCursorColorRGB:	AC_Monitor_GetCrossCursorColorRGB;
    F_Monitor_SetCrossCursorPos:	AC_Monitor_SetCrossCursorPos;
    F_Monitor_GetCrossCursorPos:	AC_Monitor_GetCrossCursorPos;
    F_Monitor_SetCrossCursorSize:	AC_Monitor_SetCrossCursorSize;
    F_Monitor_GetCrossCursorSize:	AC_Monitor_GetCrossCursorSize;

    F_Monitor_SetAutoIrisMode:		AC_Monitor_SetAutoIrisMode;
    F_Monitor_GetAutoIrisMode:		AC_Monitor_GetAutoIrisMode;
    F_Monitor_SetAutoIrisRange:		AC_Monitor_SetAutoIrisRange;
    F_Monitor_GetAutoIrisRange:		AC_Monitor_GetAutoIrisRange;
    F_Monitor_LoadFirmware:     	AC_Monitor_LoadFirmware;

    F_Monitor_GetRealExposureTime:     AC_Monitor_GetRealExposureTime;


    procedure NullSet;

  public
    constructor Create;
    destructor Destroy; override;

    function IsInit:            Boolean;

    function LoadLibrary        (lpLibFileName: PChar): Boolean;
    procedure FreeLibrary;

    function GetDllVersion:     DWORD;
    function GetLastError:      LONG;

    function Initialize         (hWnd: HWND): Boolean;
    function Release:           BOOL;

    function Preview:           BOOL;
    function RecordA            (lpAviName: LPCTSTR; RecTime: UINT; fShow: BOOL): BOOL;
    function CallBackPreview    (hWnd: HWND; lpImage: LPBYTE; Size: LONG; TopDown: BOOL): BOOL;
    function Close:             BOOL;

    // 1230
    function SnapShot           (lpImage: LPBYTE; Size: LONG; TopDown: BOOL): BOOL;

    // 1250
    function Capture:           BOOL;

    // 1260
    function Trigger            (hWnd: HWND; lpImage: LPBYTE; Size: LONG; TopDown: BOOL): BOOL;
    function SaveImage          (lpSaveName: LPCTSTR; FileType: FILETYPE): BOOL;


    function SetPreviewWindow   (hWnd: HWND; Left: LONG; Top: LONG; Right: LONG; Bottom: LONG): BOOL;
    function SetCaptureWindow   (Width: LONG; Height: LONG; Fps: LONG): BOOL;
    function SetCaptureWindowEx (HTotal: LONG; HStart: LONG; HEffective: LONG; VTotal: LONG; VStart: LONG; VEffective: LONG): BOOL;
    function GetCaptureWindowEx (HTotal: LPLONG; HStart: LPLONG; HEffective: LPLONG; VTotal: LPLONG; VStart: LPLONG; VEffective: LPLONG): BOOL;

    function SetColorMode       (ColorMode: LONG): BOOL;
    function GetColorMode:      LONG;

    function SetCrossbar        (Output: LONG; Input: LONG): BOOL;
    function SetDeviceNumber    (Number: LONG): BOOL;
    function EnumDevice         (szDeviceName: DeviceNameList): LONG;
    function GetDeviceName      (index: LONG; szDeviceName: LPSTR; nSize: LONG): BOOL;

    function StartPreview:      BOOL;
    function StopPreview:       BOOL;
    function GetImage           (lpImage: LPBYTE; Size: LONG; TopDown: BOOL): BOOL;

    function Width:             LONG;
    function Height:            LONG;
    function Fps:               LONG;

    function SetCameraDlg       (hWnd: HWND): BOOL;
    function SetImageDlg        (hWnd: HWND): BOOL;
    function SetAnalogDlg       (hWnd: HWND): BOOL;

    // 1230
    function SetIOPort          (byteData: BYTE; longData: LONG; Reserve: DWORD): BOOL;
    function GetIOPort          (byteData: LPBYTE; longData: LPLONG; Reserve: DWORD): BOOL;
    function SetFilterValue     (FilterType: ARTCAM_FILTERTYPE; Value: LONG): BOOL;
    function GetFilterValue     (FilterType: ARTCAM_FILTERTYPE; Error: LPBOOL): LONG;

    function SetSubSample       (SubSampleMode: SUBSAMPLE): BOOL;
    function GetSubSample:      SUBSAMPLE;
    function SetWaitTime        (WaitTime: LONG): BOOL;
    function GetWaitTime:       LONG;

    // 1240
    function SetMirrorV         (Flg: BOOL): BOOL;
    function GetMirrorV:        BOOL;
    function SetMirrorH         (Flg: BOOL): BOOL;
    function GetMirrorH:        BOOL;

    function SetBrightness      (Value: LONG): BOOL;
    function GetBrightness      (Error: LPBOOL): LONG;
    function SetContrast        (Value: LONG): BOOL;
    function GetContrast        (Error: LPBOOL): LONG;
    function SetHue             (Value: LONG): BOOL;
    function GetHue             (Error: LPBOOL): LONG;
    function SetSaturation      (Value: LONG): BOOL;
    function GetSaturation      (Error: LPBOOL): LONG;
    function SetSharpness       (Value: LONG): BOOL;
    function GetSharpness       (Error: LPBOOL): LONG;
    function SetBayerGainRGB    (Value: LONG): BOOL;
    function GetBayerGainRGB    (Error: LPBOOL): LONG;
    function SetBayerGainRed    (Value: LONG): BOOL;
    function GetBayerGainRed    (Error: LPBOOL): LONG;
    function SetBayerGainGreen  (Value: LONG): BOOL;
    function GetBayerGainGreen  (Error: LPBOOL): LONG;
    function SetBayerGainBlue   (Value: LONG): BOOL;
    function GetBayerGainBlue   (Error: LPBOOL): LONG;
    function SetBayerGainAuto   (Value: LONG): BOOL;
    function GetBayerGainAuto   (Error: LPBOOL): LONG;
    function SetGamma           (Value: LONG): BOOL;
    function GetGamma           (Error: LPBOOL): LONG;
    function SetBayerMode       (Value: LONG): BOOL;
    function GetBayerMode       (Error: LPBOOL): LONG;
    function SetGlobalGain      (Value: LONG): BOOL;
    function GetGlobalGain      (Error: LPBOOL): LONG;
    function SetColorGainRed    (Value: LONG): BOOL;
    function GetColorGainRed    (Error: LPBOOL): LONG;
    function SetColorGainGreen1 (Value: LONG): BOOL;
    function GetColorGainGreen1 (Error: LPBOOL): LONG;
    function SetColorGainGreen2 (Value: LONG): BOOL;
    function GetColorGainGreen2 (Error: LPBOOL): LONG;
    function SetColorGainBlue   (Value: LONG): BOOL;
    function GetColorGainBlue   (Error: LPBOOL): LONG;
    function SetExposureTime    (Value: LONG): BOOL;
    function GetExposureTime    (Error: LPBOOL): LONG;

    // 1260
    function SetHalfClock       (Value: LONG): BOOL;
    function GetHalfClock       (Error: LPBOOL): LONG;
    function SetAutoIris        (Value: LONG): BOOL;
    function GetAutoIris        (Error: LPBOOL): LONG;

    // 1275
    function SetSamplingRate    (Value: LONG): BOOL;
    function GetSamplingRate    (Error: LPBOOL): LONG;
    function GetVideoFormat     (Error: LPBOOL): LONG;

    // 1276
    function WriteSromID        (Address: LONG; Value: LONG): BOOL;
    function ReadSromID         (Address: LONG; Error: LPBOOL): LONG;

    // 1280
    function GetCameraInfo      (pInfo: LPCAMERAINFO): BOOL; cdecl;
    function GetStatus          (Error: LPBOOL): LONG; cdecl;

    function WriteRegister      (Address: BYTE; Value: DWORD): BOOL; cdecl;
    function ReadRegister       (Address: BYTE; Error: LPBOOL): DWORD; cdecl;
    function WriteRegisterEx   	(Address: DWORD; Value: DWORD): BOOL; cdecl;
    function ReadRegisterEx    	(Address: DWORD; Error: LPBOOL): DWORD; cdecl;

    function SetCrcCheckMode  	(Value: LONG): BOOL; cdecl;
    function GetCrcCheckMode  	(Error: LPBOOL): LONG; cdecl;
    function SetLChannelValue  	(Value: LONG): BOOL; cdecl;
    function GetLChannelValue  	(Error: LPBOOL): LONG; cdecl;
    function SetChannelProfileMode	(Value: LONG): BOOL; cdecl;
    function GetChannelProfile  	(Error: LPBOOL): LONG; cdecl;

    function SetGrayMode        (Value: LONG): BOOL; cdecl;
    function GetGrayMode        (Error: LPBOOL): LONG; cdecl;
    function SetGrayGainR       (Value: LONG): BOOL; cdecl;
    function GetGrayGainR       (Error: LPBOOL): LONG; cdecl;
    function SetGrayGainG1      (Value: LONG): BOOL; cdecl;
    function GetGrayGainG1      (Error: LPBOOL): LONG; cdecl;
    function SetGrayGainG2      (Value: LONG): BOOL; cdecl;
    function GetGrayGainG2      (Error: LPBOOL): LONG; cdecl;
    function SetGrayGainB       (Value: LONG): BOOL; cdecl;
    function GetGrayGainB       (Error: LPBOOL): LONG; cdecl;
    function SetGrayOffsetR     (Value: LONG): BOOL; cdecl;
    function GetGrayOffsetR     (Error: LPBOOL): LONG; cdecl;
    function SetGrayOffsetG1    (Value: LONG): BOOL; cdecl;
    function GetGrayOffsetG1    (Error: LPBOOL): LONG; cdecl;
    function SetGrayOffsetG2    (Value: LONG): BOOL; cdecl;
    function GetGrayOffsetG2    (Error: LPBOOL): LONG; cdecl;
    function SetGrayOffsetB     (Value: LONG): BOOL; cdecl;
    function GetGrayOffsetB     (Error: LPBOOL): LONG; cdecl;

    // SATA
    function SetCameraType  (Flg: LONG): BOOL; cdecl;
    function GetCameraType  (Error: LPBOOL): LONG; cdecl;
    function SetSyncV    		(Flg: LONG): BOOL; cdecl;
    function GetSyncV      		(Error: LPBOOL): LONG; cdecl;
    function SetSyncH     	 	(Flg: LONG): BOOL; cdecl;
    function GetSyncH     		 (Error: LPBOOL): LONG; cdecl;

    // MOUT
    function Fpga_WriteRegister (Address: BYTE; Value: DWORD): BOOL; cdecl;
    function Fpga_ReadRegister  (Address: BYTE; Error: LPBOOL): DWORD; cdecl;

    function Monitor_SetPreviewMode     (Preview: BOOL): BOOL; cdecl;
    function Monitor_GetPreviewMode     (Error: LPBOOL): BOOL; cdecl;
    function Monitor_SetPreviewSize     (Width: LONG; Height: LONG): BOOL; cdecl;
    function Monitor_GetPreviewSize     (LPWidth: LPLONG; LPHeight: LPLONG): BOOL; cdecl;
    function Monitor_SetColorMode       (ColorMode: BOOL): BOOL; cdecl;
    function Monitor_GetColorMode       (Error: LPBOOL): BOOL; cdecl;
    function Monitor_SetCameraClock     (Value: LONG): BOOL; cdecl;
    function Monitor_GetCameraClock     (Error: LPBOOL): LONG; cdecl;
    function Monitor_SetBayerGainAuto   (Value: LONG): BOOL; cdecl;
    function Monitor_GetBayerGainAuto   (Error: LPBOOL): LONG; cdecl;
	  function Monitor_SetBayerGainLock	(Value: LONG): BOOL; cdecl;
	  function Monitor_GetBayerGainLock	(Error: LPBOOL): LONG; cdecl;
    function Monitor_SetBayerGainRed    (Value: LONG): BOOL; cdecl;
    function Monitor_GetBayerGainRed    (Error: LPBOOL): LONG; cdecl;
    function Monitor_SetBayerGainGreen  (Value: LONG): BOOL; cdecl;
    function Monitor_GetBayerGainGreen  (Error: LPBOOL): LONG; cdecl;
    function Monitor_SetBayerGainBlue   (Value: LONG): BOOL; cdecl;
    function Monitor_GetBayerGainBlue   (Error: LPBOOL): LONG; cdecl;
    
    function Monitor_SaveCurrentSettings	():BOOL; cdecl;
    function Monitor_InitRegisterSettings	(Flg: LONG): BOOL; cdecl;

	function Monitor_SetCrossCursorMode	(CursorNum: LONG; Value: LONG): BOOL; cdecl;
	function Monitor_GetCrossCursorMode	(CursorNum: LONG; Error: LPBOOL): LONG; cdecl;
	function Monitor_SetCrossCursorColorR	(CursorNum: LONG; Value: LONG): BOOL; cdecl;
	function Monitor_GetCrossCursorColorR	(CursorNum: LONG; Error: LPBOOL): LONG; cdecl;
	function Monitor_SetCrossCursorColorG	(CursorNum: LONG; Value: LONG): BOOL; cdecl;
	function Monitor_GetCrossCursorColorG	(CursorNum: LONG; Error: LPBOOL): LONG; cdecl;
	function Monitor_SetCrossCursorColorB	(CursorNum: LONG; Value: LONG): BOOL; cdecl;
	function Monitor_GetCrossCursorColorB	(CursorNum: LONG; Error: LPBOOL): LONG; cdecl;
	function Monitor_SetCrossCursorColorRGB	(CursorNum: LONG; Value: LONG): BOOL; cdecl;
	function Monitor_GetCrossCursorColorRGB	(CursorNum: LONG; Error: LPBOOL): LONG; cdecl;
	function Monitor_SetCrossCursorPos	(CursorNum: LONG; ValueX: LONG; ValueY: LONG): BOOL; cdecl;
	function Monitor_GetCrossCursorPos	(CursorNum: LONG; ValueX: LPLONG; ValueY: LPLONG): BOOL; cdecl;
	function Monitor_SetCrossCursorSize	(CursorNum: LONG; ValueX: LONG; ValueY: LONG): BOOL; cdecl;
	function Monitor_GetCrossCursorSize	(CursorNum: LONG; ValueX: LPLONG; ValueY: LPLONG): BOOL; cdecl;

	function Monitor_SetAutoIrisMode	(Value: LONG): BOOL; cdecl;
	function Monitor_GetAutoIrisMode	(Error: LPBOOL): LONG; cdecl;
	function Monitor_SetAutoIrisRange	(Min: LONG; Max: LONG): BOOL; cdecl;
	function Monitor_GetAutoIrisRange	(Min: LPLONG; Max: LPLONG): BOOL; cdecl;
	function Monitor_LoadFirmware		  (szFileName: LPCTSTR): BOOL; cdecl;

	function Monitor_GetRealExposureTime:		LONG; cdecl;

  end;


const
  SUB_SAMPLE: array[0..3] of Integer = (1, 2, 4, 8);

implementation



procedure TArtCam.NullSet;
begin
  @F_GetDllVersion              := nil;
  @F_GetLastError               := nil;
  @F_Initialize                 := nil;
  @F_Release                    := nil;
  @F_Preview                    := nil;
  @F_Record                     := nil;
  @F_CallBackPreview            := nil;
  @F_Close                      := nil;
  @F_SnapShot                   := nil;
  @F_Capture                    := nil;
  @F_Trigger                    := nil;
  @F_SaveImage                  := nil;
  @F_SetPreviewWindow           := nil;
  @F_SetCaptureWindow           := nil;
  @F_SetCaptureWindowEx         := nil;
  @F_GetCaptureWindowEx         := nil;
  @F_SetColorMode               := nil;
  @F_GetColorMode               := nil;
  @F_SetCrossbar                := nil;
  @F_SetDeviceNumber            := nil;
  @F_EnumDevice                 := nil;
  @F_GetDeviceName              := nil;
  @F_StartPreview               := nil;
  @F_StopPreview                := nil;
  @F_GetImage                   := nil;
  @F_Width                      := nil;
  @F_Height                     := nil;
  @F_Fps                        := nil;
  @F_SetCameraDlg               := nil;
  @F_SetImageDlg                := nil;
  @F_SetAnalogDlg               := nil;
  @F_SetIOPort                  := nil;
  @F_GetIOPort                  := nil;
  @F_SetFilterValue             := nil;
  @F_GetFilterValue             := nil;
  @F_SetSubSample               := nil;
  @F_GetSubSample               := nil;
  @F_SetWaitTime                := nil;
  @F_GetWaitTime                := nil;
  @F_SetMirrorV                 := nil;
  @F_GetMirrorV                 := nil;
  @F_SetMirrorH                 := nil;
  @F_GetMirrorH                 := nil;
  @F_SetBrightness              := nil;
  @F_GetBrightness              := nil;
  @F_SetContrast                := nil;
  @F_GetContrast                := nil;
  @F_SetHue                     := nil;
  @F_GetHue                     := nil;
  @F_SetSaturation              := nil;
  @F_GetSaturation              := nil;
  @F_SetSharpness               := nil;
  @F_GetSharpness               := nil;
  @F_SetBayerGainRGB            := nil;
  @F_GetBayerGainRGB            := nil;
  @F_SetBayerGainRed            := nil;
  @F_GetBayerGainRed            := nil;
  @F_SetBayerGainGreen          := nil;
  @F_GetBayerGainGreen          := nil;
  @F_SetBayerGainBlue           := nil;
  @F_GetBayerGainBlue           := nil;
  @F_SetBayerGainAuto           := nil;
  @F_GetBayerGainAuto           := nil;
  @F_SetGamma                   := nil;
  @F_GetGamma                   := nil;
  @F_SetBayerMode               := nil;
  @F_GetBayerMode               := nil;
  @F_SetGlobalGain              := nil;
  @F_GetGlobalGain              := nil;
  @F_SetColorGainRed            := nil;
  @F_GetColorGainRed            := nil;
  @F_SetColorGainGreen1         := nil;
  @F_GetColorGainGreen1         := nil;
  @F_SetColorGainGreen2         := nil;
  @F_GetColorGainGreen2         := nil;
  @F_SetColorGainBlue           := nil;
  @F_GetColorGainBlue           := nil;
  @F_SetExposureTime            := nil;
  @F_GetExposureTime            := nil;
  @F_SetHalfClock               := nil;
  @F_GetHalfClock               := nil;
  @F_SetAutoIris                := nil;
  @F_GetAutoIris                := nil;
  @F_SetSamplingRate            := nil;
  @F_GetSamplingRate            := nil;
  @F_GetVideoFormat             := nil;
  @F_WriteSromID                := nil;
  @F_ReadSromID                 := nil;
  @F_GetCameraInfo              := nil;
  @F_GetStatus                  := nil;
  @F_WriteRegister              := nil;
  @F_ReadRegister               := nil;
  @F_WriteRegisterEx              := nil;
  @F_ReadRegisterEx               := nil;
  @F_SetCrcCheckMode			:= nil;
  @F_GetCrcCheckMode			:= nil;
  @F_SetLChannelValue			:= nil;
  @F_GetLChannelValue			:= nil;
  @F_SetChannelProfileMode		:= nil;
  @F_GetChannelProfile			:= nil;
  @F_SetGrayMode                := nil;
  @F_GetGrayMode                := nil;
  @F_SetGrayGainR               := nil;
  @F_GetGrayGainR               := nil;
  @F_SetGrayGainG1              := nil;
  @F_GetGrayGainG1              := nil;
  @F_SetGrayGainG2              := nil;
  @F_GetGrayGainG2              := nil;
  @F_SetGrayGainB               := nil;
  @F_GetGrayGainB               := nil;
  @F_SetGrayOffsetR             := nil;
  @F_GetGrayOffsetR             := nil;
  @F_SetGrayOffsetG1            := nil;
  @F_GetGrayOffsetG1            := nil;
  @F_SetGrayOffsetG2            := nil;
  @F_GetGrayOffsetG2            := nil;
  @F_SetGrayOffsetB             := nil;
  @F_GetGrayOffsetB             := nil;
  @F_SetCameraType              := nil;
  @F_GetCameraType              := nil;
  @F_SetSyncV					:= nil;
  @F_GetSyncV					:= nil;
  @F_SetSyncH					:= nil;
  @F_GetSyncH					:= nil;
  @F_Fpga_WriteRegister         := nil;
  @F_Fpga_ReadRegister          := nil;
  @F_Monitor_SetPreviewMode     := nil;
  @F_Monitor_GetPreviewMode     := nil;
  @F_Monitor_SetPreviewSize     := nil;
  @F_Monitor_GetPreviewSize     := nil;
  @F_Monitor_SetColorMode       := nil;
  @F_Monitor_GetColorMode       := nil;
  @F_Monitor_SetCameraClock     := nil;
  @F_Monitor_GetCameraClock     := nil;
  @F_Monitor_SetBayerGainAuto   := nil;
  @F_Monitor_GetBayerGainAuto   := nil;
  @F_Monitor_SetBayerGainLock	:= nil;
  @F_Monitor_GetBayerGainLock	:= nil;
  @F_Monitor_SetBayerGainRed    := nil;
  @F_Monitor_GetBayerGainRed    := nil;
  @F_Monitor_SetBayerGainGreen  := nil;
  @F_Monitor_GetBayerGainGreen  := nil;
  @F_Monitor_SetBayerGainBlue   := nil;
  @F_Monitor_GetBayerGainBlue   := nil;
  @F_Monitor_SaveCurrentSettings 	:= nil;
  @F_Monitor_InitRegisterSettings	:= nil;
  @F_Monitor_SetCrossCursorMode	:= nil;
  @F_Monitor_GetCrossCursorMode	:= nil;
  @F_Monitor_SetCrossCursorColorR	:= nil;
  @F_Monitor_GetCrossCursorColorR	:= nil;
  @F_Monitor_SetCrossCursorColorG	:= nil;
  @F_Monitor_GetCrossCursorColorG	:= nil;
  @F_Monitor_SetCrossCursorColorB	:= nil;
  @F_Monitor_GetCrossCursorColorB	:= nil;
  @F_Monitor_SetCrossCursorColorRGB	:= nil;
  @F_Monitor_GetCrossCursorColorRGB	:= nil;
  @F_Monitor_SetCrossCursorPos	:= nil;
  @F_Monitor_GetCrossCursorPos	:= nil;
  @F_Monitor_SetCrossCursorSize := nil;
  @F_Monitor_GetCrossCursorSize := nil;
  @F_Monitor_SetAutoIrisMode	:= nil;
  @F_Monitor_GetAutoIrisMode	:= nil;
  @F_Monitor_SetAutoIrisRange	:= nil;
  @F_Monitor_GetAutoIrisRange	:= nil;
  @F_Monitor_LoadFirmware		:= nil;
  @F_Monitor_GetRealExposureTime	:= nil;
  
  

  FDLLHandle := 0;
  SdkHandle := 0;
end;

constructor TArtCam.Create;
begin
  NullSet;
end;

destructor TArtCam.Destroy;
begin
  FreeLibrary;
end;

function TArtCam.IsInit: Boolean;
begin
  if SdkHandle<>0 then
    begin
      Result := true;
    exit;
  end;

  Result := false;
end;

function TArtCam.LoadLibrary(lpLibFileName: PChar): Boolean;
begin
  FDLLHandle := Windows.LoadLibrary(lpLibFileName);
  if FDLLHandle<>0 then begin
    @F_GetDllVersion:=        GetProcAddress(FDLLHandle, 'ArtCam_GetDllVersion');
    @F_GetLastError:=         GetProcAddress(FDLLHandle, 'ArtCam_GetLastError');

    @F_Initialize:=           GetProcAddress(FDLLHandle, 'ArtCam_Initialize');
    @F_Release:=              GetProcAddress(FDLLHandle, 'ArtCam_Release');

    @F_Preview:=              GetProcAddress(FDLLHandle, 'ArtCam_Preview');
    @F_Record:=               GetProcAddress(FDLLHandle, 'ArtCam_Record');
    @F_CallBackPreview:=      GetProcAddress(FDLLHandle, 'ArtCam_CallBackPreview');
    @F_Close:=                GetProcAddress(FDLLHandle, 'ArtCam_Close');

    // 1230
    @F_SnapShot:=             GetProcAddress(FDLLHandle, 'ArtCam_SnapShot');

    // 1250
    @F_Capture:=              GetProcAddress(FDLLHandle, 'ArtCam_Capture');

    // 1260
    @F_Trigger:=              GetProcAddress(FDLLHandle, 'ArtCam_Trigger');
    @F_SaveImage:=            GetProcAddress(FDLLHandle, 'ArtCam_SaveImage');


    @F_SetPreviewWindow:=     GetProcAddress(FDLLHandle, 'ArtCam_SetPreviewWindow');
    @F_SetCaptureWindow:=     GetProcAddress(FDLLHandle, 'ArtCam_SetCaptureWindow');
    @F_SetCaptureWindowEx:=   GetProcAddress(FDLLHandle, 'ArtCam_SetCaptureWindowEx');
    @F_GetCaptureWindowEx:=   GetProcAddress(FDLLHandle, 'ArtCam_GetCaptureWindowEx');

    @F_SetColorMode:=         GetProcAddress(FDLLHandle, 'ArtCam_SetColorMode');
    @F_GetColorMode:=         GetProcAddress(FDLLHandle, 'ArtCam_GetColorMode');

    @F_SetCrossbar:=          GetProcAddress(FDLLHandle, 'ArtCam_SetCrossbar');
    @F_SetDeviceNumber:=      GetProcAddress(FDLLHandle, 'ArtCam_SetDeviceNumber');
    @F_EnumDevice:=           GetProcAddress(FDLLHandle, 'ArtCam_EnumDevice');
    @F_GetDeviceName:=        GetProcAddress(FDLLHandle, 'ArtCam_GetDeviceName');

    @F_StartPreview:=         GetProcAddress(FDLLHandle, 'ArtCam_StartPreview');
    @F_StopPreview:=          GetProcAddress(FDLLHandle, 'ArtCam_StopPreview');
    @F_GetImage:=             GetProcAddress(FDLLHandle, 'ArtCam_GetImage');

    @F_Width:=                GetProcAddress(FDLLHandle, 'ArtCam_Width');
    @F_Height:=               GetProcAddress(FDLLHandle, 'ArtCam_Height');
    @F_Fps:=                  GetProcAddress(FDLLHandle, 'ArtCam_Fps');

    @F_SetCameraDlg:=         GetProcAddress(FDLLHandle, 'ArtCam_SetCameraDlg');
    @F_SetImageDlg:=          GetProcAddress(FDLLHandle, 'ArtCam_SetImageDlg');
    @F_SetAnalogDlg:=         GetProcAddress(FDLLHandle, 'ArtCam_SetAnalogDlg');

    // 1230
    @F_SetIOPort:=            GetProcAddress(FDLLHandle, 'ArtCam_SetIOPort');
    @F_GetIOPort:=            GetProcAddress(FDLLHandle, 'ArtCam_GetIOPort');

    @F_SetFilterValue:=       GetProcAddress(FDLLHandle, 'ArtCam_SetFilterValue');
    @F_GetFilterValue:=       GetProcAddress(FDLLHandle, 'ArtCam_GetFilterValue');

    @F_SetSubSample:=         GetProcAddress(FDLLHandle, 'ArtCam_SetSubSample');
    @F_GetSubSample:=         GetProcAddress(FDLLHandle, 'ArtCam_GetSubSample');

    @F_SetWaitTime:=          GetProcAddress(FDLLHandle, 'ArtCam_SetWaitTime');
    @F_GetWaitTime:=          GetProcAddress(FDLLHandle, 'ArtCam_GetWaitTime');

    // 1240
    @F_SetMirrorV:=           GetProcAddress(FDLLHandle, 'ArtCam_SetMirrorV');
    @F_GetMirrorV:=           GetProcAddress(FDLLHandle, 'ArtCam_GetMirrorV');

    @F_SetMirrorH:=           GetProcAddress(FDLLHandle, 'ArtCam_SetMirrorH');
    @F_GetMirrorH:=           GetProcAddress(FDLLHandle, 'ArtCam_GetMirrorH');

    @F_SetBrightness:=        GetProcAddress(FDLLHandle, 'ArtCam_SetBrightness');
    @F_GetBrightness:=        GetProcAddress(FDLLHandle, 'ArtCam_GetBrightness');

    @F_SetContrast:=          GetProcAddress(FDLLHandle, 'ArtCam_SetContrast');
    @F_GetContrast:=          GetProcAddress(FDLLHandle, 'ArtCam_GetContrast');

    @F_SetHue:=               GetProcAddress(FDLLHandle, 'ArtCam_SetHue');
    @F_GetHue:=               GetProcAddress(FDLLHandle, 'ArtCam_GetHue');

    @F_SetSaturation:=        GetProcAddress(FDLLHandle, 'ArtCam_SetSaturation');
    @F_GetSaturation:=        GetProcAddress(FDLLHandle, 'ArtCam_GetSaturation');

    @F_SetSharpness:=         GetProcAddress(FDLLHandle, 'ArtCam_SetSharpness');
    @F_GetSharpness:=         GetProcAddress(FDLLHandle, 'ArtCam_GetSharpness');

    @F_SetBayerGainRGB:=      GetProcAddress(FDLLHandle, 'ArtCam_SetBayerGainRGB');
    @F_GetBayerGainRGB:=      GetProcAddress(FDLLHandle, 'ArtCam_GetBayerGainRGB');

    @F_SetBayerGainRed:=      GetProcAddress(FDLLHandle, 'ArtCam_SetBayerGainRed');
    @F_GetBayerGainRed:=      GetProcAddress(FDLLHandle, 'ArtCam_GetBayerGainRed');

    @F_SetBayerGainGreen:=    GetProcAddress(FDLLHandle, 'ArtCam_SetBayerGainGreen');
    @F_GetBayerGainGreen:=    GetProcAddress(FDLLHandle, 'ArtCam_GetBayerGainGreen');

    @F_SetBayerGainBlue:=     GetProcAddress(FDLLHandle, 'ArtCam_SetBayerGainBlue');
    @F_GetBayerGainBlue:=     GetProcAddress(FDLLHandle, 'ArtCam_GetBayerGainBlue');

    @F_SetBayerGainAuto:=     GetProcAddress(FDLLHandle, 'ArtCam_SetBayerGainAuto');
    @F_GetBayerGainAuto:=     GetProcAddress(FDLLHandle, 'ArtCam_GetBayerGainAuto');

    @F_SetGamma:=             GetProcAddress(FDLLHandle, 'ArtCam_SetGamma');
    @F_GetGamma:=             GetProcAddress(FDLLHandle, 'ArtCam_GetGamma');

    @F_SetBayerMode:=         GetProcAddress(FDLLHandle, 'ArtCam_SetBayerMode');
    @F_GetBayerMode:=         GetProcAddress(FDLLHandle, 'ArtCam_GetBayerMode');

    @F_SetGlobalGain:=        GetProcAddress(FDLLHandle, 'ArtCam_SetGlobalGain');
    @F_GetGlobalGain:=        GetProcAddress(FDLLHandle, 'ArtCam_GetGlobalGain');

    @F_SetColorGainRed:=      GetProcAddress(FDLLHandle, 'ArtCam_SetColorGainRed');
    @F_GetColorGainRed:=      GetProcAddress(FDLLHandle, 'ArtCam_GetColorGainRed');

    @F_SetColorGainGreen1:=   GetProcAddress(FDLLHandle, 'ArtCam_SetColorGainGreen1');
    @F_GetColorGainGreen1:=   GetProcAddress(FDLLHandle, 'ArtCam_GetColorGainGreen1');

    @F_SetColorGainGreen2:=   GetProcAddress(FDLLHandle, 'ArtCam_SetColorGainGreen2');
    @F_GetColorGainGreen2:=   GetProcAddress(FDLLHandle, 'ArtCam_GetColorGainGreen2');

    @F_SetColorGainBlue:=     GetProcAddress(FDLLHandle, 'ArtCam_SetColorGainBlue');
    @F_GetColorGainBlue:=     GetProcAddress(FDLLHandle, 'ArtCam_GetColorGainBlue');

    @F_SetExposureTime:=      GetProcAddress(FDLLHandle, 'ArtCam_SetExposureTime');
    @F_GetExposureTime:=      GetProcAddress(FDLLHandle, 'ArtCam_GetExposureTime');

    // 1260
    @F_SetHalfClock:=         GetProcAddress(FDLLHandle, 'ArtCam_SetHalfClock');
    @F_GetHalfClock:=         GetProcAddress(FDLLHandle, 'ArtCam_GetHalfClock');

    @F_SetAutoIris:=          GetProcAddress(FDLLHandle, 'ArtCam_SetAutoIris');
    @F_GetAutoIris:=          GetProcAddress(FDLLHandle, 'ArtCam_GetAutoIris');

    // 1275
    @F_SetSamplingRate:=      GetProcAddress(FDLLHandle, 'ArtCam_SetSamplingRate');
    @F_GetSamplingRate:=      GetProcAddress(FDLLHandle, 'ArtCam_GetSamplingRate');
    @F_GetVideoFormat:=       GetProcAddress(FDLLHandle, 'ArtCam_GetVideoFormat');

    // 1276
    @F_WriteSromID:=          GetProcAddress(FDLLHandle, 'ArtCam_WriteSromID');
    @F_ReadSromID:=           GetProcAddress(FDLLHandle, 'ArtCam_ReadSromID');

    // 1280
    @F_GetCameraInfo:=        GetProcAddress(FDLLHandle, 'ArtCam_GetCameraInfo');
    @F_GetStatus:=            GetProcAddress(FDLLHandle, 'ArtCam_GetStatus');

    @F_WriteRegister:=        GetProcAddress(FDLLHandle, 'ArtCam_WriteRegister');
    @F_ReadRegister:=         GetProcAddress(FDLLHandle, 'ArtCam_ReadRegister');

    @F_WriteRegisterEx:=  		GetProcAddress(FDLLHandle, 'ArtCam_WriteRegisterEx');
    @F_ReadRegisterEx:=         GetProcAddress(FDLLHandle, 'ArtCam_ReadRegisterEx');
    
    @F_SetCrcCheckMode:=        GetProcAddress(FDLLHandle, 'ArtCam_SetCrcCheckMode');
    @F_GetCrcCheckMode:=        GetProcAddress(FDLLHandle, 'ArtCam_GetCrcCheckMode');
    
    @F_SetLChannelValue:=    	GetProcAddress(FDLLHandle, 'ArtCam_SetLChannelValue');
    @F_GetLChannelValue:=     	GetProcAddress(FDLLHandle, 'ArtCam_GetLChannelValue');
    @F_SetChannelProfileMode:=	GetProcAddress(FDLLHandle, 'ArtCam_SetChannelProfileMode');
    @F_GetChannelProfile:=     	GetProcAddress(FDLLHandle, 'ArtCam_GetChannelProfile');

    @F_SetGrayMode:=          GetProcAddress(FDLLHandle, 'ArtCam_SetGrayMode');
    @F_GetGrayMode:=          GetProcAddress(FDLLHandle, 'ArtCam_GetGrayMode');

    @F_SetGrayGainR:=         GetProcAddress(FDLLHandle, 'ArtCam_SetGrayGainR');
    @F_GetGrayGainR:=         GetProcAddress(FDLLHandle, 'ArtCam_GetGrayGainR');

    @F_SetGrayGainG1:=        GetProcAddress(FDLLHandle, 'ArtCam_SetGrayGainG1');
    @F_GetGrayGainG1:=        GetProcAddress(FDLLHandle, 'ArtCam_GetGrayGainG1');

    @F_SetGrayGainG2:=        GetProcAddress(FDLLHandle, 'ArtCam_SetGrayGainG2');
    @F_GetGrayGainG2:=        GetProcAddress(FDLLHandle, 'ArtCam_GetGrayGainG2');

    @F_SetGrayGainB:=         GetProcAddress(FDLLHandle, 'ArtCam_SetGrayGainB');
    @F_GetGrayGainB:=         GetProcAddress(FDLLHandle, 'ArtCam_GetGrayGainB');

    @F_SetGrayOffsetR:=       GetProcAddress(FDLLHandle, 'ArtCam_SetGrayOffsetR');
    @F_GetGrayOffsetR:=       GetProcAddress(FDLLHandle, 'ArtCam_GetGrayOffsetR');

    @F_SetGrayOffsetG1:=      GetProcAddress(FDLLHandle, 'ArtCam_SetGrayOffsetG1');
    @F_GetGrayOffsetG1:=      GetProcAddress(FDLLHandle, 'ArtCam_GetGrayOffsetG1');

    @F_SetGrayOffsetG2:=      GetProcAddress(FDLLHandle, 'ArtCam_SetGrayOffsetG2');
    @F_GetGrayOffsetG2:=      GetProcAddress(FDLLHandle, 'ArtCam_GetGrayOffsetG2');

    @F_SetGrayOffsetB:=       GetProcAddress(FDLLHandle, 'ArtCam_SetGrayOffsetB');
    @F_GetGrayOffsetB:=       GetProcAddress(FDLLHandle, 'ArtCam_GetGrayOffsetB');

    // SATA
    @F_SetCameraType:=        GetProcAddress(FDLLHandle, 'ArtCam_SetCameraType');
    @F_GetCameraType:=        GetProcAddress(FDLLHandle, 'ArtCam_GetCameraType');
    
    @F_SetSyncV:=				GetProcAddress(FDLLHandle, 'ArtCam_SetSyncV');
    @F_GetSyncV:=        		GetProcAddress(FDLLHandle, 'ArtCam_GetSyncV');
    @F_SetSyncH:=        		GetProcAddress(FDLLHandle, 'ArtCam_SetSyncH');
    @F_GetSyncH:=        		GetProcAddress(FDLLHandle, 'ArtCam_GetSyncH');

    // MOUT
    @F_Fpga_WriteRegister:=       GetProcAddress(FDLLHandle, 'ArtCam_Fpga_WriteRegister');
    @F_Fpga_ReadRegister:=        GetProcAddress(FDLLHandle, 'ArtCam_Fpga_ReadRegister');

    @F_Monitor_SetPreviewMode:=   GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetPreviewMode');
    @F_Monitor_GetPreviewMode:=   GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetPreviewMode');

    @F_Monitor_SetPreviewSize:=   GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetPreviewSize');
    @F_Monitor_GetPreviewSize:=   GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetPreviewSize');

    @F_Monitor_SetColorMode:=     GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetColorMode');
    @F_Monitor_GetColorMode:=     GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetColorMode');

    @F_Monitor_SetCameraClock:=   GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetCameraClock');
    @F_Monitor_GetCameraClock:=   GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetCameraClock');

    @F_Monitor_SetBayerGainAuto:= GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetBayerGainAuto');
    @F_Monitor_GetBayerGainAuto:= GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetBayerGainAuto');
    
    @F_Monitor_SetBayerGainLock:= GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetBayerGainLock');
    @F_Monitor_GetBayerGainLock:= GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetBayerGainLock');

    @F_Monitor_SetBayerGainRed:=  GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetBayerGainRed');
    @F_Monitor_GetBayerGainRed:=  GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetBayerGainRed');

    @F_Monitor_SetBayerGainGreen:=GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetBayerGainGreen');
    @F_Monitor_GetBayerGainGreen:=GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetBayerGainGreen');

    @F_Monitor_SetBayerGainBlue:= GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetBayerGainBlue');
    @F_Monitor_GetBayerGainBlue:= GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetBayerGainBlue');
    
    @F_Monitor_SaveCurrentSettings:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetBayerGainBlue');
    @F_Monitor_InitRegisterSettings:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetBayerGainBlue');
    
    @F_Monitor_SetCrossCursorMode:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetBayerGainBlue');
    @F_Monitor_GetCrossCursorMode:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetBayerGainBlue');
    @F_Monitor_SetCrossCursorColorR:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetCrossCursorColorR');
    @F_Monitor_GetCrossCursorColorR:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetCrossCursorColorR');
    @F_Monitor_SetCrossCursorColorG:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetCrossCursorColorG');
    @F_Monitor_GetCrossCursorColorG:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetCrossCursorColorG');
    @F_Monitor_SetCrossCursorColorB:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetCrossCursorColorB');
    @F_Monitor_GetCrossCursorColorB:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetCrossCursorColorB');
    @F_Monitor_SetCrossCursorColorRGB:= GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetCrossCursorColorRGB');
    @F_Monitor_GetCrossCursorColorRGB:= GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetCrossCursorColorRGB');
    @F_Monitor_SetCrossCursorPos:= 		GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetCrossCursorPos');
    @F_Monitor_GetCrossCursorPos:=		GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetCrossCursorPos');
    @F_Monitor_SetCrossCursorSize:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetCrossCursorSize');
    @F_Monitor_GetCrossCursorSize:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetCrossCursorSize');
    
    @F_Monitor_SetAutoIrisMode:= 		GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetAutoIrisMode');
    @F_Monitor_GetAutoIrisMode:= 		GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetAutoIrisMode');
    @F_Monitor_SetAutoIrisRange:=		GetProcAddress(FDLLHandle, 'ArtCam_Monitor_SetAutoIrisRange');
    @F_Monitor_GetAutoIrisRange:= 		GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetAutoIrisRange');
    @F_Monitor_LoadFirmware:=	 		GetProcAddress(FDLLHandle, 'ArtCam_Monitor_LoadFirmware');
    
    @F_Monitor_GetRealExposureTime:= 	GetProcAddress(FDLLHandle, 'ArtCam_Monitor_GetRealExposureTime');

    Result := true;
    exit;
  end;

  Result := false;
end;

procedure TArtCam.FreeLibrary;
begin
  if FDLLHandle<>0 then Windows.FreeLibrary(FDLLHandle);
  NullSet;
end;


function TArtCam.GetDllVersion: DWORD;
begin
  if @F_GetDllVersion<>nil then
  begin
    Result := F_GetDllVersion();
    exit;
  end;

  Result := 0;
end;

function TArtCam.GetLastError: LONG;
begin
  if @F_GetLastError<>nil then
  begin
    Result := F_GetLastError(SdkHandle);
    exit;
  end;

  Result := 0;
end;


function TArtCam.Initialize (hWnd: HWND): Boolean;
begin
  if @F_Release<>nil then
  begin
    SdkHandle := F_Initialize(hWnd);
    if SdkHandle<>0 then
      begin
        Result := true;
      exit;
    end;
  end;

  Result := false;
end;

function TArtCam.Release: BOOL;
begin
  if @F_Release<>nil then
  begin
    Result := F_Release(SdkHandle);
    exit;
  end;

  Result := FALSE;
end;


function TArtCam.Preview: BOOL;
begin
  if @F_Preview<>nil then
  begin
    Result := F_Preview(SdkHandle);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.RecordA (lpAviName: LPCTSTR; RecTime: UINT; fShow: BOOL): BOOL;
begin
  if @F_Record<>nil then
  begin
    Result := F_Record(SdkHandle, lpAviName, RecTime, fShow);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.CallBackPreview (hWnd: HWND; lpImage: LPBYTE; Size: LONG; TopDown: BOOL): BOOL;
begin
  if @F_CallBackPreview<>nil then
  begin
    Result := F_CallBackPreview(SdkHandle, hWnd, lpImage, Size, TopDown);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Close: BOOL;
begin
  if @F_Close<>nil then
  begin
    Result := F_Close(SdkHandle);
    exit;
  end;

  Result := FALSE;
end;


// 1230
function TArtCam.SnapShot (lpImage: LPBYTE; Size: LONG; TopDown: BOOL): BOOL;
begin
  if @F_SnapShot<>nil then
  begin
    Result := F_SnapShot(SdkHandle, lpImage, Size, TopDown);
    exit;
  end;

  Result := FALSE;
end;


// 1250
function TArtCam.Capture: BOOL;
begin
  if @F_Capture<>nil then
  begin
    Result := F_Capture(SdkHandle);
    exit;
  end;

  Result := FALSE;
end;


// 1260
function TArtCam.Trigger (hWnd: HWND; lpImage: LPBYTE; Size: LONG; TopDown: BOOL): BOOL;
begin
  if @F_Trigger<>nil then
  begin
    Result := F_Trigger(SdkHandle, hWnd, lpImage, Size, TopDown);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.SaveImage (lpSaveName: LPCTSTR; FileType: FILETYPE): BOOL;
begin
  if @F_SaveImage<>nil then
  begin
    Result := F_SaveImage(SdkHandle, lpSaveName, LONG(FileType));
    exit;
  end;

  Result := FALSE;
end;



function TArtCam.SetPreviewWindow (hWnd: HWND; Left: LONG; Top: LONG; Right: LONG; Bottom: LONG): BOOL;
begin
  if @F_SetPreviewWindow<>nil then
  begin
    Result := F_SetPreviewWindow(SdkHandle, hWnd, Left, Top, Right, Bottom);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.SetCaptureWindow (Width: LONG; Height: LONG; Fps: LONG): BOOL;
begin
  if @F_SetCaptureWindow<>nil then
  begin
    Result := F_SetCaptureWindow(SdkHandle, Width, Height, Fps);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.SetCaptureWindowEx (HTotal: LONG; HStart: LONG; HEffective: LONG; VTotal: LONG; VStart: LONG; VEffective: LONG): BOOL;
begin
  if @F_SetCaptureWindowEx<>nil then
  begin
    Result := F_SetCaptureWindowEx(SdkHandle, HTotal, HStart, HEffective, VTotal, VStart, VEffective);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetCaptureWindowEx (HTotal: LPLONG; HStart: LPLONG; HEffective: LPLONG; VTotal: LPLONG; VStart: LPLONG; VEffective: LPLONG): BOOL;
begin
  if @F_GetCaptureWindowEx<>nil then
  begin
    Result := F_GetCaptureWindowEx(SdkHandle, HTotal, HStart, HEffective, VTotal, VStart, VEffective);
    exit;
  end;

  Result := FALSE;
end;


function TArtCam.SetColorMode (ColorMode: LONG): BOOL;
begin
  if @F_SetColorMode<>nil then
  begin
    Result := F_SetColorMode(SdkHandle, ColorMode);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetColorMode: LONG;
begin
  if @F_GetColorMode<>nil then
  begin
    Result := F_GetColorMode(SdkHandle);
    exit;
  end;

  Result := 0;
end;


function TArtCam.SetCrossbar (Output: LONG; Input: LONG): BOOL;
begin
  if @F_SetCrossbar<>nil then
  begin
    Result := F_SetCrossbar(SdkHandle, Output, Input);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.SetDeviceNumber (Number: LONG): BOOL;
begin
  if @F_SetDeviceNumber<>nil then
  begin
    Result := F_SetDeviceNumber(SdkHandle, Number);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.EnumDevice (szDeviceName: DeviceNameList): LONG;
begin
  if @F_EnumDevice<>nil then
  begin
    Result := F_EnumDevice(SdkHandle, szDeviceName);
    exit;
  end;

  Result := 0;
end;

function TArtCam.GetDeviceName (index: LONG; szDeviceName: LPSTR; nSize: LONG): BOOL;
begin
  if @F_GetDeviceName<>nil then
  begin
    Result := F_GetDeviceName(SdkHandle, index, szDeviceName, nSize);
    exit;
  end;

  Result := FALSE;
end;


function TArtCam.StartPreview: BOOL;
begin
  if @F_StartPreview<>nil then
  begin
    Result := F_StartPreview(SdkHandle);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.StopPreview: BOOL;
begin
  if @F_StopPreview<>nil then
  begin
    Result := F_StopPreview(SdkHandle);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetImage (lpImage: LPBYTE; Size: LONG; TopDown: BOOL): BOOL;
begin
  if @F_GetImage<>nil then
  begin
    Result := F_GetImage(SdkHandle, lpImage, Size, TopDown);
    exit;
  end;

  Result := FALSE;
end;


function TArtCam.Width: LONG;
begin
  if @F_Width<>nil then
  begin
    Result := F_Width(SdkHandle);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Height: LONG;
begin
  if @F_Height<>nil then
  begin
    Result := F_Height(SdkHandle);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Fps: LONG;
begin
  if @F_Fps<>nil then
  begin
    Result := F_Fps(SdkHandle);
    exit;
  end;

  Result := 0;
end;


function TArtCam.SetCameraDlg (hWnd: HWND): BOOL;
begin
  if @F_SetCameraDlg<>nil then
  begin
    Result := F_SetCameraDlg(SdkHandle, hWnd);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.SetImageDlg (hWnd: HWND): BOOL;
begin
  if @F_SetImageDlg<>nil then
  begin
    Result := F_SetImageDlg(SdkHandle, hWnd);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.SetAnalogDlg (hWnd: HWND): BOOL;
begin
  if @F_SetAnalogDlg<>nil then
  begin
    Result := F_SetAnalogDlg(SdkHandle, hWnd);
    exit;
  end;

  Result := FALSE;
end;


// 1230
function TArtCam.SetIOPort (byteData: BYTE; longData: LONG; Reserve: DWORD): BOOL;
begin
  if @F_SetIOPort<>nil then
  begin
    Result := F_SetIOPort(SdkHandle, byteData, longData, Reserve);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetIOPort (byteData: LPBYTE; longData: LPLONG; Reserve: DWORD): BOOL;
begin
  if @F_GetIOPort<>nil then
  begin
    Result := F_GetIOPort(SdkHandle, byteData, longData, Reserve);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.SetFilterValue (FilterType: ARTCAM_FILTERTYPE; Value: LONG): BOOL;
begin
  if @F_SetFilterValue<>nil then
  begin
    Result := F_SetFilterValue(SdkHandle, LONG(FilterType), Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetFilterValue (FilterType: ARTCAM_FILTERTYPE; Error: LPBOOL): LONG;
begin
  if @F_GetFilterValue<>nil then
  begin
    Result := F_GetFilterValue(SdkHandle, LONG(FilterType), Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetSubSample (SubSampleMode: SUBSAMPLE): BOOL;
begin
  if @F_SetSubSample<>nil then
  begin
    Result := F_SetSubSample(SdkHandle, LONG(SubSampleMode));
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetSubSample: SUBSAMPLE;
begin
  if @F_GetSubSample<>nil then
  begin
    Result := SUBSAMPLE(F_GetSubSample(SdkHandle));
    exit;
  end;

  Result := SUBSAMPLE_1;
end;

function TArtCam.SetWaitTime (WaitTime: LONG): BOOL;
begin
  if @F_SetWaitTime<>nil then
  begin
    Result := F_SetWaitTime(SdkHandle, WaitTime);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetWaitTime: LONG;
begin
  if @F_GetWaitTime<>nil then
  begin
    Result := F_GetWaitTime(SdkHandle);
    exit;
  end;

  Result := 0;
end;


// 1240
function TArtCam.SetMirrorV (Flg: BOOL): BOOL;
begin
  if @F_SetMirrorV<>nil then
  begin
    Result := F_SetMirrorV(SdkHandle, Flg);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetMirrorV: BOOL;
begin
  if @F_GetMirrorV<>nil then
  begin
    Result := F_GetMirrorV(SdkHandle);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.SetMirrorH (Flg: BOOL): BOOL;
begin
  if @F_SetMirrorH<>nil then
  begin
    Result := F_SetMirrorH(SdkHandle, Flg);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetMirrorH: BOOL;
begin
  if @F_GetMirrorH<>nil then
  begin
    Result := F_GetMirrorH(SdkHandle);
    exit;
  end;

  Result := FALSE;
end;


function TArtCam.SetBrightness (Value: LONG): BOOL;
begin
  if @F_SetBrightness<>nil then
  begin
    Result := F_SetBrightness(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetBrightness (Error: LPBOOL): LONG;
begin
  if @F_GetBrightness<>nil then
  begin
    Result := F_GetBrightness(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetContrast (Value: LONG): BOOL;
begin
  if @F_SetContrast<>nil then
  begin
    Result := F_SetContrast(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetContrast (Error: LPBOOL): LONG;
begin
  if @F_GetContrast<>nil then
  begin
    Result := F_GetContrast(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetHue (Value: LONG): BOOL;
begin
  if @F_SetHue<>nil then
  begin
    Result := F_SetHue(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetHue (Error: LPBOOL): LONG;
begin
  if @F_GetHue<>nil then
  begin
    Result := F_GetHue(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetSaturation (Value: LONG): BOOL;
begin
  if @F_SetSaturation<>nil then
  begin
    Result := F_SetSaturation(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetSaturation (Error: LPBOOL): LONG;
begin
  if @F_GetSaturation<>nil then
  begin
    Result := F_GetSaturation(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetSharpness (Value: LONG): BOOL;
begin
  if @F_SetSharpness<>nil then
  begin
    Result := F_SetSharpness(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetSharpness (Error: LPBOOL): LONG;
begin
  if @F_GetSharpness<>nil then
  begin
    Result := F_GetSharpness(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetBayerGainRGB (Value: LONG): BOOL;
begin
  if @F_SetBayerGainRGB<>nil then
  begin
    Result := F_SetBayerGainRGB(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetBayerGainRGB (Error: LPBOOL): LONG;
begin
  if @F_GetBayerGainRGB<>nil then
  begin
    Result := F_GetBayerGainRGB(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetBayerGainRed (Value: LONG): BOOL;
begin
  if @F_SetBayerGainRed<>nil then
  begin
    Result := F_SetBayerGainRed(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetBayerGainRed (Error: LPBOOL): LONG;
begin
  if @F_GetBayerGainRed<>nil then
  begin
    Result := F_GetBayerGainRed(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetBayerGainGreen (Value: LONG): BOOL;
begin
  if @F_SetBayerGainGreen<>nil then
  begin
    Result := F_SetBayerGainGreen(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetBayerGainGreen (Error: LPBOOL): LONG;
begin
  if @F_GetBayerGainGreen<>nil then
  begin
    Result := F_GetBayerGainGreen(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetBayerGainBlue (Value: LONG): BOOL;
begin
  if @F_SetBayerGainBlue<>nil then
  begin
    Result := F_SetBayerGainBlue(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetBayerGainBlue (Error: LPBOOL): LONG;
begin
  if @F_GetBayerGainBlue<>nil then
  begin
    Result := F_GetBayerGainBlue(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetBayerGainAuto (Value: LONG): BOOL;
begin
  if @F_SetBayerGainAuto<>nil then
  begin
    Result := F_SetBayerGainAuto(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetBayerGainAuto (Error: LPBOOL): LONG;
begin
  if @F_GetBayerGainAuto<>nil then
  begin
    Result := F_GetBayerGainAuto(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetGamma (Value: LONG): BOOL;
begin
  if @F_SetGamma<>nil then
  begin
    Result := F_SetGamma(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetGamma (Error: LPBOOL): LONG;
begin
  if @F_GetGamma<>nil then
  begin
    Result := F_GetGamma(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetBayerMode (Value: LONG): BOOL;
begin
  if @F_SetBayerMode<>nil then
  begin
    Result := F_SetBayerMode(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetBayerMode (Error: LPBOOL): LONG;
begin
  if @F_GetBayerMode<>nil then
  begin
    Result := F_GetBayerMode(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetGlobalGain (Value: LONG): BOOL;
begin
  if @F_SetGlobalGain<>nil then
  begin
    Result := F_SetGlobalGain(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetGlobalGain (Error: LPBOOL): LONG;
begin
  if @F_GetGlobalGain<>nil then
  begin
    Result := F_GetGlobalGain(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetColorGainRed (Value: LONG): BOOL;
begin
  if @F_SetColorGainRed<>nil then
  begin
    Result := F_SetColorGainRed(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetColorGainRed (Error: LPBOOL): LONG;
begin
  if @F_GetColorGainRed<>nil then
  begin
    Result := F_GetColorGainRed(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetColorGainGreen1 (Value: LONG): BOOL;
begin
  if @F_SetColorGainGreen1<>nil then
  begin
    Result := F_SetColorGainGreen1(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetColorGainGreen1 (Error: LPBOOL): LONG;
begin
  if @F_GetColorGainGreen1<>nil then
  begin
    Result := F_GetColorGainGreen1(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetColorGainGreen2 (Value: LONG): BOOL;
begin
  if @F_SetColorGainGreen2<>nil then
  begin
    Result := F_SetColorGainGreen2(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetColorGainGreen2 (Error: LPBOOL): LONG;
begin
  if @F_GetColorGainGreen2<>nil then
  begin
    Result := F_GetColorGainGreen2(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetColorGainBlue (Value: LONG): BOOL;
begin
  if @F_SetColorGainBlue<>nil then
  begin
    Result := F_SetColorGainBlue(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetColorGainBlue (Error: LPBOOL): LONG;
begin
  if @F_GetColorGainBlue<>nil then
  begin
    Result := F_GetColorGainBlue(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetExposureTime (Value: LONG): BOOL;
begin
  if @F_SetExposureTime<>nil then
  begin
    Result := F_SetExposureTime(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetExposureTime (Error: LPBOOL): LONG;
begin
  if @F_GetExposureTime<>nil then
  begin
    Result := F_GetExposureTime(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

// 1260
function TArtCam.SetHalfClock (Value: LONG): BOOL;
begin
  if @F_SetHalfClock<>nil then
  begin
    Result := F_SetHalfClock(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetHalfClock (Error: LPBOOL): LONG;
begin
  if @F_GetHalfClock<>nil then
  begin
    Result := F_GetHalfClock(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetAutoIris (Value: LONG): BOOL;
begin
  if @F_SetAutoIris<>nil then
  begin
    Result := F_SetAutoIris(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetAutoIris (Error: LPBOOL): LONG;
begin
  if @F_GetAutoIris<>nil then
  begin
    Result := F_GetAutoIris(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;


// 1275
function TArtCam.SetSamplingRate (Value: LONG): BOOL;
begin
  if @F_SetSamplingRate<>nil then
  begin
    Result := F_SetSamplingRate(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetSamplingRate (Error: LPBOOL): LONG;
begin
  if @F_GetSamplingRate<>nil then
  begin
    Result := F_GetSamplingRate(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.GetVideoFormat (Error: LPBOOL): LONG;
begin
  if @F_GetVideoFormat<>nil then
  begin
    Result := F_GetVideoFormat(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;


// 1276
function TArtCam.WriteSromID (Address: LONG; Value: LONG): BOOL;
begin
  if @F_WriteSromID<>nil then
  begin
    Result := F_WriteSromID(SdkHandle, Address, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.ReadSromID (Address: LONG; Error: LPBOOL): LONG;
begin
  if @F_ReadSromID<>nil then
  begin
    Result := F_ReadSromID(SdkHandle, Address, Error);
    exit;
  end;

  Result := 0;
end;


// 1280
function TArtCam.GetCameraInfo (pInfo: LPCAMERAINFO): BOOL;
begin
  if @F_GetCameraInfo<>nil then
  begin
    Result := F_GetCameraInfo(SdkHandle, pInfo);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetStatus (Error: LPBOOL): LONG;
begin
  if @F_GetStatus<>nil then
  begin
    Result := F_GetStatus(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.WriteRegister (Address: BYTE; Value: DWORD): BOOL;
begin
  if @F_WriteRegister<>nil then
  begin
    Result := F_WriteRegister(SdkHandle, Address, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.ReadRegister (Address: BYTE; Error: LPBOOL): DWORD;
begin
  if @F_ReadRegister<>nil then
  begin
    Result := F_ReadRegister(SdkHandle, Address, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.WriteRegisterEx   	(Address: DWORD; Value: DWORD): BOOL;
begin
  if @F_WriteRegisterEx<>nil then
  begin
    Result := F_WriteRegisterEx(SdkHandle, Address, Value);
    exit;
  end;
  
  Result := FALSE;
end;
    
function TArtCam.ReadRegisterEx    	(Address: DWORD; Error: LPBOOL): DWORD;
begin
  if @F_ReadRegisterEx<>nil then
  begin 
    Result := F_ReadRegisterEx(SdkHandle, Address, Error);
    exit;
  end;
  
  Result := 0;
end;

function TArtCam.SetCrcCheckMode  	(Value: LONG): BOOL; 
begin
  if @F_SetCrcCheckMode<>nil then
  begin
    Result := F_SetCrcCheckMode(SdkHandle, Value);
    exit;
  end;
  
  Result := FALSE;
end;


function TArtCam.GetCrcCheckMode  	(Error: LPBOOL): LONG;
begin
  if @F_GetCrcCheckMode<>nil then
  begin
    Result := F_GetCrcCheckMode(SdkHandle, Error);
    exit;
  end;
    
  Result := 0;
end;

function TArtCam.SetLChannelValue  	(Value: LONG): BOOL; 
begin
  if @F_SetLChannelValue<>nil then
  begin
    Result := F_SetLChannelValue(SdkHandle, Value);
    exit;
  end;
  
  Result := FALSE;
end;

function TArtCam.GetLChannelValue  	(Error: LPBOOL): LONG; 
begin
  if @F_GetCrcCheckMode<>nil then
  begin
    Result := F_GetCrcCheckMode(SdkHandle, Error);
    exit;
  end;
  
  Result := 0;
end;

function TArtCam.SetChannelProfileMode	(Value: LONG): BOOL; 
Begin
  if @F_SetChannelProfileMode<>nil then
  begin
    Result := F_SetChannelProfileMode(SdkHandle, Value);
    exit;
  end;
  
  Result := FALSE;
end;
 
function TArtCam.GetChannelProfile  	(Error: LPBOOL): LONG;
Begin
  if @F_GetChannelProfile<>nil then
  begin
    Result := F_GetChannelProfile(SdkHandle, Error);
    exit;
  end;
  
  Result := 0;
end;

function TArtCam.SetGrayMode (Value: LONG): BOOL;
begin
  if @F_SetGrayMode<>nil then
  begin
    Result := F_SetGrayMode(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetGrayMode (Error: LPBOOL): LONG;
begin
  if @F_GetGrayMode<>nil then
  begin
    Result := F_GetGrayMode(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetGrayGainR (Value: LONG): BOOL;
begin
  if @F_SetGrayGainR<>nil then
  begin
    Result := F_SetGrayGainR(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetGrayGainR (Error: LPBOOL): LONG;
begin
  if @F_GetGrayGainR<>nil then
  begin
    Result := F_GetGrayGainR(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetGrayGainG1 (Value: LONG): BOOL;
begin
  if @F_SetGrayGainG1<>nil then
  begin
    Result := F_SetGrayGainG1(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetGrayGainG1 (Error: LPBOOL): LONG;
begin
  if @F_GetGrayGainG1<>nil then
  begin
    Result := F_GetGrayGainG1(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetGrayGainG2 (Value: LONG): BOOL;
begin
  if @F_SetGrayGainG2<>nil then
  begin
    Result := F_SetGrayGainG2(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetGrayGainG2 (Error: LPBOOL): LONG;
begin
  if @F_GetGrayGainG2<>nil then
  begin
    Result := F_GetGrayGainG2(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetGrayGainB (Value: LONG): BOOL;
begin
  if @F_SetGrayGainB<>nil then
  begin
    Result := F_SetGrayGainB(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetGrayGainB (Error: LPBOOL): LONG;
begin
  if @F_GetGrayGainB<>nil then
  begin
    Result := F_GetGrayGainB(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetGrayOffsetR (Value: LONG): BOOL;
begin
  if @F_SetGrayOffsetR<>nil then
  begin
    Result := F_SetGrayOffsetR(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetGrayOffsetR (Error: LPBOOL): LONG;
begin
  if @F_GetGrayOffsetR<>nil then
  begin
    Result := F_GetGrayOffsetR(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetGrayOffsetG1 (Value: LONG): BOOL;
begin
  if @F_SetGrayOffsetG1<>nil then
  begin
    Result := F_SetGrayOffsetG1(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetGrayOffsetG1 (Error: LPBOOL): LONG;
begin
  if @F_GetGrayOffsetG1<>nil then
  begin
    Result := F_GetGrayOffsetG1(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetGrayOffsetG2 (Value: LONG): BOOL;
begin
  if @F_SetGrayOffsetG2<>nil then
  begin
    Result := F_SetGrayOffsetG2(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetGrayOffsetG2 (Error: LPBOOL): LONG;
begin
  if @F_GetGrayOffsetG2<>nil then
  begin
    Result := F_GetGrayOffsetG2(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetGrayOffsetB (Value: LONG): BOOL;
begin
  if @F_SetGrayOffsetB<>nil then
  begin
    Result := F_SetGrayOffsetB(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetGrayOffsetB (Error: LPBOOL): LONG;
begin
  if @F_GetGrayOffsetB<>nil then
  begin
    Result := F_GetGrayOffsetB(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;


// SATA
function TArtCam.SetCameraType (Flg: LONG): BOOL;
begin
  if @F_SetCameraType<>nil then
  begin
    Result := F_SetCameraType(SdkHandle, Flg);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetCameraType (Error: LPBOOL): LONG;
begin
  if @F_GetCameraType<>nil then
  begin
    Result := F_GetCameraType(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetSyncV	(Flg: LONG): BOOL; 
begin
  if @F_SetSyncV<>nil then
  begin
    Result := F_SetSyncV(SdkHandle, Flg);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetSyncV	(Error: LPBOOL): LONG;
begin
  if @F_GetSyncV<>nil then
  begin
    Result := F_GetSyncV(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.SetSyncH	(Flg: LONG): BOOL;
begin
  if @F_SetSyncH<>nil then
  begin
    Result := F_SetSyncH(SdkHandle, Flg);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.GetSyncH	(Error: LPBOOL): LONG;
begin
  if @F_GetSyncH<>nil then
  begin
    Result := F_GetSyncH(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;


// MOUT
function TArtCam.Fpga_WriteRegister (Address: BYTE; Value: DWORD): BOOL;
begin
  if @F_Fpga_WriteRegister<>nil then
  begin
    Result := F_Fpga_WriteRegister(SdkHandle, Address, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Fpga_ReadRegister (Address: BYTE; Error: LPBOOL): DWORD;
begin
  if @F_Fpga_ReadRegister<>nil then
  begin
    Result := F_Fpga_ReadRegister(SdkHandle, Address, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SetPreviewMode (Preview: BOOL): BOOL;
begin
  if @F_Monitor_SetPreviewMode<>nil then
  begin
    Result := F_Monitor_SetPreviewMode(SdkHandle, Preview);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetPreviewMode (Error: LPBOOL): BOOL;
begin
  if @F_Monitor_GetPreviewMode<>nil then
  begin
    Result := F_Monitor_GetPreviewMode(SdkHandle, Error);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_SetPreviewSize (Width: LONG; Height: LONG): BOOL;
begin
  if @F_Monitor_SetPreviewSize<>nil then
  begin
    Result := F_Monitor_SetPreviewSize(SdkHandle, Width, Height);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetPreviewSize (LPWidth: LPLONG; LPHeight: LPLONG): BOOL;
begin
  if @F_Monitor_GetPreviewSize<>nil then
  begin
    Result := F_Monitor_GetPreviewSize(SdkHandle, LPWidth, LPHeight);
    exit;
  end;

  Result := FALSE;
end;


function TArtCam.Monitor_SetColorMode (ColorMode: BOOL): BOOL;
begin
  if @F_Monitor_SetColorMode<>nil then
  begin
    Result := F_Monitor_SetColorMode(SdkHandle, ColorMode);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetColorMode (Error: LPBOOL): BOOL;
begin
  if @F_Monitor_GetColorMode<>nil then
  begin
    Result := F_Monitor_GetColorMode(SdkHandle, Error);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_SetCameraClock (Value: LONG): BOOL;
begin
  if @F_Monitor_SetCameraClock<>nil then
  begin
    Result := F_Monitor_SetCameraClock(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetCameraClock (Error: LPBOOL): LONG;
begin
  if @F_Monitor_GetCameraClock<>nil then
  begin
    Result := F_Monitor_GetCameraClock(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SetBayerGainAuto (Value: LONG): BOOL;
begin
  if @F_Monitor_SetBayerGainAuto<>nil then
  begin
    Result := F_Monitor_SetBayerGainAuto(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetBayerGainAuto (Error: LPBOOL): LONG;
begin
  if @F_Monitor_GetBayerGainAuto<>nil then
  begin
    Result := F_Monitor_GetBayerGainAuto(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SetBayerGainLock	(Value: LONG): BOOL;
begin
  if @F_Monitor_SetBayerGainLock<>nil then
  begin
    Result := F_Monitor_SetBayerGainLock(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetBayerGainLock	(Error: LPBOOL): LONG;
begin
  if @F_Monitor_GetBayerGainLock<>nil then
  begin
    Result := F_Monitor_GetBayerGainLock(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SetBayerGainRed (Value: LONG): BOOL;
begin
  if @F_Monitor_SetBayerGainRed<>nil then
  begin
    Result := F_Monitor_SetBayerGainRed(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetBayerGainRed (Error: LPBOOL): LONG;
begin
  if @F_Monitor_GetBayerGainRed<>nil then
  begin
    Result := F_Monitor_GetBayerGainRed(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SetBayerGainGreen (Value: LONG): BOOL;
begin
  if @F_Monitor_SetBayerGainGreen<>nil then
  begin
    Result := F_Monitor_SetBayerGainGreen(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetBayerGainGreen (Error: LPBOOL): LONG;
begin
  if @F_Monitor_GetBayerGainGreen<>nil then
  begin
    Result := F_Monitor_GetBayerGainGreen(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SetBayerGainBlue (Value: LONG): BOOL;
begin
  if @F_Monitor_SetBayerGainBlue<>nil then
  begin
    Result := F_Monitor_SetBayerGainBlue(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetBayerGainBlue (Error: LPBOOL): LONG;
begin
  if @F_Monitor_GetBayerGainBlue<>nil then
  begin
    Result := F_Monitor_GetBayerGainBlue(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SaveCurrentSettings:	BOOL;
begin
  if @F_Monitor_SaveCurrentSettings<>nil then
  begin
    Result := F_Monitor_SaveCurrentSettings(SdkHandle);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_InitRegisterSettings	(Flg: LONG): BOOL;
begin
  if @F_Monitor_InitRegisterSettings<>nil then
  begin
    Result := F_Monitor_InitRegisterSettings(SdkHandle, Flg);
    exit;
  end;

  Result := FALSE;
end;
    
function TArtCam.Monitor_SetCrossCursorMode	(CursorNum: LONG; Value: LONG): BOOL;
begin
  if @F_Monitor_SetCrossCursorMode<>nil then
  begin
    Result := F_Monitor_SetCrossCursorMode(SdkHandle, CursorNum, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetCrossCursorMode	(CursorNum: LONG; Error: LPBOOL): LONG;
begin
  if @F_Monitor_GetCrossCursorMode<>nil then
  begin
    Result := F_Monitor_GetCrossCursorMode(SdkHandle, CursorNum, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SetCrossCursorColorR	(CursorNum: LONG; Value: LONG): BOOL;
begin
  if @F_Monitor_SetCrossCursorColorR<>nil then
  begin
    Result := F_Monitor_SetCrossCursorColorR(SdkHandle, CursorNum, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetCrossCursorColorR	(CursorNum: LONG; Error: LPBOOL): LONG;
begin
  if @F_Monitor_GetCrossCursorColorR<>nil then
  begin
    Result := F_Monitor_GetCrossCursorColorR(SdkHandle, CursorNum, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SetCrossCursorColorG	(CursorNum: LONG; Value: LONG): BOOL;
begin
  if @F_Monitor_SetCrossCursorColorG<>nil then
  begin
    Result := F_Monitor_SetCrossCursorColorG(SdkHandle, CursorNum, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetCrossCursorColorG	(CursorNum: LONG; Error: LPBOOL): LONG;
begin
  if @F_Monitor_GetCrossCursorColorG<>nil then
  begin
    Result := F_Monitor_GetCrossCursorColorG(SdkHandle, CursorNum, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SetCrossCursorColorB	(CursorNum: LONG; Value: LONG): BOOL;
begin
  if @F_Monitor_SetCrossCursorColorB<>nil then
  begin
    Result := F_Monitor_SetCrossCursorColorB(SdkHandle, CursorNum, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetCrossCursorColorB	(CursorNum: LONG; Error: LPBOOL): LONG;
begin
  if @F_Monitor_GetCrossCursorColorB<>nil then
  begin
    Result := F_Monitor_GetCrossCursorColorB(SdkHandle, CursorNum, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SetCrossCursorColorRGB	(CursorNum: LONG; Value: LONG): BOOL;
begin
  if @F_Monitor_SetCrossCursorColorRGB<>nil then
  begin
    Result := F_Monitor_SetCrossCursorColorRGB(SdkHandle, CursorNum, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetCrossCursorColorRGB	(CursorNum: LONG; Error: LPBOOL): LONG;
begin
  if @F_Monitor_GetCrossCursorColorRGB<>nil then
  begin
    Result := F_Monitor_GetCrossCursorColorRGB(SdkHandle, CursorNum, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SetCrossCursorPos	(CursorNum: LONG; ValueX: LONG; ValueY: LONG): BOOL;
begin
  if @F_Monitor_SetCrossCursorPos<>nil then
  begin
    Result := F_Monitor_SetCrossCursorPos(SdkHandle, CursorNum, ValueX, ValueY);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetCrossCursorPos	(CursorNum: LONG; ValueX: LPLONG; ValueY: LPLONG): BOOL;
begin
  if @F_Monitor_GetCrossCursorPos<>nil then
  begin
    Result := F_Monitor_GetCrossCursorPos(SdkHandle, CursorNum, ValueX, ValueY);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_SetCrossCursorSize	(CursorNum: LONG; ValueX: LONG; ValueY: LONG): BOOL;
begin
  if @F_Monitor_SetCrossCursorSize<>nil then
  begin
    Result := F_Monitor_SetCrossCursorSize(SdkHandle, CursorNum, ValueX, ValueY);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetCrossCursorSize	(CursorNum: LONG; ValueX: LPLONG; ValueY: LPLONG): BOOL;
begin
  if @F_Monitor_GetCrossCursorSize<>nil then
  begin
    Result := F_Monitor_GetCrossCursorSize(SdkHandle, CursorNum, ValueX, ValueY);
    exit;
  end;

  Result := FALSE;
end;


function TArtCam.Monitor_SetAutoIrisMode	(Value: LONG): BOOL;
begin
  if @F_Monitor_SetAutoIrisMode<>nil then
  begin
    Result := F_Monitor_SetAutoIrisMode(SdkHandle, Value);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetAutoIrisMode	(Error: LPBOOL): LONG;
begin
  if @F_Monitor_GetAutoIrisMode<>nil then
  begin
    Result := F_Monitor_GetAutoIrisMode(SdkHandle, Error);
    exit;
  end;

  Result := 0;
end;

function TArtCam.Monitor_SetAutoIrisRange	(Min: LONG; Max: LONG): BOOL;
begin
  if @F_Monitor_SetAutoIrisRange<>nil then
  begin
    Result := F_Monitor_SetAutoIrisRange(SdkHandle, Min, Max);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetAutoIrisRange	(Min: LPLONG; Max: LPLONG): BOOL;
begin
  if @F_Monitor_GetAutoIrisRange<>nil then
  begin
    Result := F_Monitor_GetAutoIrisRange(SdkHandle, Min, Max);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_LoadFirmware		(szFileName: LPCTSTR): BOOL;
begin
  if @F_Monitor_LoadFirmware<>nil then
  begin
    Result := F_Monitor_LoadFirmware(SdkHandle, szFileName);
    exit;
  end;

  Result := FALSE;
end;

function TArtCam.Monitor_GetRealExposureTime:		LONG;
begin
  if @F_Monitor_GetRealExposureTime<>nil then
  begin
    Result := F_Monitor_GetRealExposureTime(SdkHandle);
    exit;
  end;

  Result := 0;
end;



end.

